/*
	Copyright 2018-2019 Giovanni Franza - HB9EIK 

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef _TMATE2_H
#define _TMATE2_H

typedef struct _tmate2_status  {
	int lp;
	int att;
	int tx;
	int rx;
	int smeter; // in dBm
	int power;  // in mW
	int vfo;    //0=A 1=B
	int nr;
	int nb;
	int an;
	int frequency; // Hz
	int am;
	int lsb;
	int usb;
	int cwplus;
	int cwminus;
	int fm;
	int e1vol;
	int e1sql;
	int e1nr;
	int e1nb;
	int e1an;
	int e2rit;
	unsigned char rxcolor[3];
	unsigned char txcolor[3];
	void *work;
} t2status, *t2statusp;

int TMate2OpenConnection( void );
int TMate2CloseConnection( void );
int TMate2ReadValue( int *enc1,int *enc2,int *enc3, int *tasti );
int TMate2ReadVersion( char *H1,char *H2,char *F1,char *F2 );
void TMate2WriteNumberOnMainDisplay(unsigned char *LCDVector, int Value );
void TMate2WriteNumberOnSmeterDisplay(unsigned char *LCDVector, int SmeterValue );
void TMate2SetSegment( unsigned char *LCDVector, int lcd_mask, unsigned char status );
void TMate2SetLcd( unsigned char *bufout );
void TMate2SetStatus( t2statusp stat );
int TMate2AddCallback( int keyNumber, int Button, int *value, void *Work, void (*AuxDown)( void *, int ), void (*Write)( void *, int ), void (*Down)( void *, int ), void (*Up)( void *, int ) );

#define BLANK	21

#define  nCOM0 0
#define  nCOM1 0x20
#define  nCOM2 0x40
#define  nCOM3 0x60
#define  nCOM4 0x80
#define  nCOM5 0xa0
#define  nCOM6 0xc0
#define  nCOM7 0xe0

#define SEG0    0
#define SEG1    1
#define SEG2    2
#define SEG3    3
#define SEG4    4
#define SEG5    5
#define SEG6    6
#define SEG7    7
#define SEG8    8
#define SEG9    9
#define SEG10  10
#define SEG11  11
#define SEG12  12
#define SEG13  13
#define SEG14  14
#define SEG15  15
#define SEG16  16
#define SEG17  17
#define SEG18  18
#define SEG19  19
#define SEG20  20
#define SEG21  21
#define SEG22  22
#define SEG23  23
#define SEG24  24
#define SEG25  25
#define SEG26  26
#define SEG27  27
#define SEG28  28
#define SEG29  29
#define SEG30  30
#define SEG31  31


#define SEGA 0x01
#define SEGB 0x02
#define SEGC 0x04
#define SEGD 0x08
#define SEGE 0x10
#define SEGF 0x40
#define SEGG 0x20

#define SEG_T16  				nCOM0|SEG2    // 0
#define SEG_DB_MINUS			nCOM4|SEG28   //    
#define SEG_CW_PLUS			nCOM0|SEG21   // T18
#define SEG_CW_MINUS 		nCOM1|SEG21   // T19
#define SEG_DIG_PLUS 		nCOM2|SEG21   // T20
#define SEG_DIG_MINUS		nCOM3|SEG21   // T21
#define SEG_T22  				nCOM3|SEG4    // T22
#define SEG_T23  				nCOM3|SEG6    // T23
#define SEG_T24  				nCOM3|SEG8    // T24
#define SEG_T25  				nCOM3|SEG10   // T25
#define SEG_T26  				nCOM3|SEG12   // T26
#define SEG_T27  				nCOM3|SEG14   // T27
#define SEG_T28  				nCOM3|SEG16   // T28
#define SEG_T29  				nCOM3|SEG18   // T29
#define SEG_T30  				nCOM3|SEG20   // T30
#define SEG_DOT1  			nCOM4|SEG9    // T31
#define SEG_DOT2  			nCOM4|SEG15   // T32
#define SEG_HZ  				nCOM0|SEG23   // T33
#define SEG_E1  				nCOM7|SEG0    // T34
#define SEG_ERR  				nCOM4|SEG19	  // T36 
#define SEG_E2  				nCOM4|SEG8    // T37  
#define SEG_LP					nCOM1|SEG0    
#define SEG_ATT  				nCOM0|SEG1
#define SEG_S   				nCOM4|SEG0
#define SEG_VFO 				nCOM5|SEG0
#define SEG_NR  				nCOM6|SEG0
#define SEG_NB  				nCOM6|SEG1
#define SEG_1   				nCOM4|SEG1
#define SEG_A   				nCOM5|SEG1
#define SEG_B   				nCOM5|SEG2
#define SEG_VOL 				nCOM7|SEG1
#define SEG_9   				nCOM1|SEG2
#define SEG_7   				nCOM2|SEG2
#define SEG_5   				nCOM3|SEG2
#define SEG_3   				nCOM4|SEG2
#define SEG_AN  				nCOM6|SEG2
#define SEG_RFG 				nCOM7|SEG2
#define SEG_SQL 				nCOM4|SEG3
#define SEG_DRV 				nCOM4|SEG4
#define SEG_SHIFT 			nCOM4|SEG12
#define SEG_LOW 				nCOM4|SEG11	
#define SEG_HIGH				nCOM4|SEG10		
#define SEG_DSB  				nCOM4|SEG21
#define SEG_FM					nCOM5|SEG21
#define SEG_USB				nCOM6|SEG21
#define SEG_SAM				nCOM7|SEG21
#define SEG_DRM			   nCOM0|SEG22
#define SEG_DIG				nCOM1|SEG22
#define SEG_STEREO			nCOM2|SEG22
#define SEG_DBM				nCOM4|SEG22
#define SEG_CW					nCOM5|SEG22
#define SEG_LSB				nCOM6|SEG22
#define SEG_AM					nCOM7|SEG22
#define PLUS20					nCOM5|SEG9	//T46
#define PLUS40					nCOM5|SEG15	//T47	
#define PLUS60					nCOM5|SEG18 //T48	
#define SEG_10					nCOM5|SEG8
#define SEG_20					nCOM5|SEG10
#define SEG_40					nCOM5|SEG16
#define SEG_60					nCOM5|SEG19
#define SEG_RX					nCOM2|SEG0
#define SEG_TX					nCOM3|SEG0
#define SEG_ATT_1				nCOM2|SEG31  //T42
#define SEG_ATT_2				nCOM0|SEG31  //T43
#define SEG_PRE				nCOM1|SEG31
#define SEG_PRE_1				nCOM0|SEG30  //T44
#define SEG_PRE_2				nCOM1|SEG30  //T45
#define SEG_mW_W				nCOM0|SEG27	 //T39
#define SEG_mW_m				nCOM0|SEG28	 //T17
#define SEG_W					nCOM5|SEG20  //T38
#define SEG_K					nCOM0|SEG25  //T40
#define SEG_RIT				nCOM4|SEG13 
#define SEG_XIT				nCOM4|SEG14 
#define SEG_W_FM				nCOM4|SEG20 // T41
#define SEG_T33				nCOM4|SEG5  // T33
#define SEG_T35				nCOM4|SEG6  // T35
#define SEG_T36				nCOM4|SEG7  // T36

#define SMETER_SEG1        nCOM3|SEG1	// T1
#define SMETER_SEG2			nCOM2|SEG1	// T2
#define SMETER_SEG3			nCOM1|SEG1	// T3
#define SMETER_SEG4			nCOM7|SEG31	// T4
#define SMETER_SEG5			nCOM6|SEG31	// T5
#define SMETER_SEG6			nCOM5|SEG31	// T6
#define SMETER_SEG7			nCOM4|SEG31	// T7
#define SMETER_SEG8			nCOM4|SEG30	// T8
#define SMETER_SEG9			nCOM5|SEG30	// T9
#define SMETER_SEG10			nCOM6|SEG30	// T10
#define SMETER_SEG11			nCOM7|SEG30	// T11
#define SMETER_SEG12			nCOM7|SEG29	// T12
#define SMETER_SEG13			nCOM6|SEG29	// T13
#define SMETER_SEG14			nCOM5|SEG29	// T14
#define SMETER_SEG15			nCOM4|SEG29	// T15

#define SEG_MAIN_9A   nCOM0|SEG4 
#define SEG_MAIN_9B   nCOM1|SEG4
#define SEG_MAIN_9C   nCOM2|SEG4
#define SEG_MAIN_9D   nCOM3|SEG3
#define SEG_MAIN_9E   nCOM2|SEG3
#define SEG_MAIN_9F   nCOM0|SEG3
#define SEG_MAIN_9G   nCOM1|SEG3
#define SEG_MAIN_8A   nCOM0|SEG6
#define SEG_MAIN_8B   nCOM1|SEG6
#define SEG_MAIN_8C   nCOM2|SEG6
#define SEG_MAIN_8D   nCOM3|SEG5
#define SEG_MAIN_8E   nCOM2|SEG5 
#define SEG_MAIN_8F   nCOM0|SEG5
#define SEG_MAIN_8G   nCOM1|SEG5
#define SEG_MAIN_7A   nCOM0|SEG8
#define SEG_MAIN_7B   nCOM1|SEG8
#define SEG_MAIN_7C   nCOM2|SEG8
#define SEG_MAIN_7D   nCOM3|SEG7
#define SEG_MAIN_7E   nCOM2|SEG7
#define SEG_MAIN_7F   nCOM0|SEG7
#define SEG_MAIN_7G   nCOM1|SEG7 
#define SEG_MAIN_6A   nCOM0|SEG10    
#define SEG_MAIN_6B   nCOM1|SEG10
#define SEG_MAIN_6C   nCOM2|SEG10
#define SEG_MAIN_6D   nCOM3|SEG9
#define SEG_MAIN_6E   nCOM2|SEG9
#define SEG_MAIN_6F   nCOM0|SEG9
#define SEG_MAIN_6G   nCOM1|SEG9
#define SEG_MAIN_5A   nCOM0|SEG12
#define SEG_MAIN_5B   nCOM1|SEG12
#define SEG_MAIN_5C   nCOM2|SEG12
#define SEG_MAIN_5D   nCOM3|SEG11
#define SEG_MAIN_5E   nCOM2|SEG11
#define SEG_MAIN_5F   nCOM0|SEG11
#define SEG_MAIN_5G   nCOM1|SEG11
#define SEG_MAIN_4A   nCOM0|SEG14 
#define SEG_MAIN_4B   nCOM1|SEG14
#define SEG_MAIN_4C   nCOM2|SEG14
#define SEG_MAIN_4D   nCOM3|SEG13
#define SEG_MAIN_4E   nCOM2|SEG13
#define SEG_MAIN_4F   nCOM0|SEG13
#define SEG_MAIN_4G   nCOM1|SEG13
#define SEG_MAIN_3A   nCOM0|SEG16
#define SEG_MAIN_3B   nCOM1|SEG16
#define SEG_MAIN_3C   nCOM2|SEG16
#define SEG_MAIN_3D   nCOM3|SEG15
#define SEG_MAIN_3E   nCOM2|SEG15
#define SEG_MAIN_3F   nCOM0|SEG15
#define SEG_MAIN_3G   nCOM1|SEG15
#define SEG_MAIN_2A   nCOM0|SEG18 
#define SEG_MAIN_2B   nCOM1|SEG18
#define SEG_MAIN_2C   nCOM2|SEG18
#define SEG_MAIN_2D   nCOM3|SEG17
#define SEG_MAIN_2E   nCOM2|SEG17
#define SEG_MAIN_2F   nCOM0|SEG17
#define SEG_MAIN_2G   nCOM1|SEG17
#define SEG_MAIN_1A   nCOM0|SEG20 
#define SEG_MAIN_1B   nCOM1|SEG20
#define SEG_MAIN_1C   nCOM2|SEG20
#define SEG_MAIN_1D   nCOM3|SEG19
#define SEG_MAIN_1E   nCOM2|SEG19
#define SEG_MAIN_1F   nCOM0|SEG19
#define SEG_MAIN_1G   nCOM1|SEG19

#define SEG_SMETER_3A nCOM7|SEG27
#define SEG_SMETER_3B nCOM6|SEG27
#define SEG_SMETER_3C nCOM5|SEG27
#define SEG_SMETER_3D nCOM4|SEG27
#define SEG_SMETER_3E nCOM5|SEG28
#define SEG_SMETER_3F nCOM7|SEG28
#define SEG_SMETER_3G nCOM6|SEG28 
#define SEG_SMETER_2A nCOM7|SEG25 
#define SEG_SMETER_2B nCOM6|SEG25
#define SEG_SMETER_2C nCOM5|SEG25
#define SEG_SMETER_2D nCOM4|SEG25
#define SEG_SMETER_2E nCOM5|SEG26
#define SEG_SMETER_2F nCOM7|SEG26
#define SEG_SMETER_2G nCOM6|SEG26
#define SEG_SMETER_1A nCOM7|SEG23 
#define SEG_SMETER_1B nCOM6|SEG23
#define SEG_SMETER_1C nCOM5|SEG23
#define SEG_SMETER_1D nCOM4|SEG23
#define SEG_SMETER_1E nCOM5|SEG24
#define SEG_SMETER_1F nCOM7|SEG24
#define SEG_SMETER_1G nCOM6|SEG24 

#endif
