/*
	Copyright 2018-2019 Giovanni Franza - HB9EIK 

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#define _GNU_SOURCE
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <signal.h>
#include <math.h>
#include <syslog.h>
#include <glob.h>
#include "struct.h"
#include <arpa/inet.h>
#include <termio.h>
#include <dlfcn.h>
#include <portaudio.h>
#include <stdlib.h>
static char CATbuf[50];

void resetFreq( void *works, int value );

void forget( void *works, int value ) {
	sprintf( CATbuf, "ELADRE;" );
	sendWebSockStatFrame( works, CATbuf, strlen(CATbuf) );
}
void manForget( void *works, int value ) {
	forget( works, value );
	((workp)works)->numSameError=0;
	((workp)works)->lastError=0;
}
void setTouch( void *works, int value ) {
	((workp)works)->setup->isTouch=1-((workp)works)->setup->isTouch;
}
void getTouch( void *works, int button ) {
	int mode=((workp)works)->setup->isTouch>0?1:0;
	buttonp buttons=((workp)works)->buttons;
	buttons[button].activated=mode+1;
	buttons[button].decode=((workp)works)->strings->decodeIsTouch;
}
void setGraph( void *works, int value ) {
	((workp)works)->setup->Graphic=1-((workp)works)->setup->Graphic;
	if( ((workp)works)->setup->Graphic) {
		((workp)works)->setup->Antialiased=0;
	}
}
void getGraph( void *works, int button ) {
	int mode=((workp)works)->setup->Graphic>0?1:0;
	buttonp buttons=((workp)works)->buttons;
	buttons[button].activated=mode+1;
	buttons[button].decode=((workp)works)->strings->decodeGraphic;
}
void setAuDev( void *works, int button ) {
        ((workp)works)->setup->whatAuDev=1-((workp)works)->setup->whatAuDev;
        ((workp)works)->noAudio=1;
	usleep( 20000 );
        ((workp)works)->noAudio=0;
}
void getAuDev( void *works, int button ) {
	int mode=((workp)works)->setup->whatAuDev>0?1:0;
	buttonp buttons=((workp)works)->buttons;
	buttons[button].activated=mode+1;
	buttons[button].decode=((workp)works)->strings->decodeAuDev;
}
void setAudio( void *works, int value ) {
	((workp)works)->setup->audioFftEnabled=1-((workp)works)->setup->audioFftEnabled;
}
void getAudio( void *works, int button ) {
	int mode=((workp)works)->setup->audioFftEnabled;
	buttonp buttons=((workp)works)->buttons;
	buttons[button].activated=mode;
}
void setAntialias( void *works, int value ) {
	((workp)works)->setup->Antialiased=1-((workp)works)->setup->Antialiased;
	if ( ((workp)works)->setup->Antialiased ) {
		((workp)works)->setup->Graphic=0;
	}
}
void getAlias( void *works, int button ) {
	int mode=((workp)works)->setup->Antialiased>0?1:0;
	buttonp buttons=((workp)works)->buttons;
	buttons[button].activated=mode+1;
	buttons[button].decode=((workp)works)->strings->decodeAliased;
}
void setCommReset( void *works, int value ) {
	((workp)works)->countTo=1;
}
void setReset( void *works, int value ) {
	sprintf( CATbuf, "ELADRB;" );
	sendWebSockStatFrame( works, CATbuf, strlen(CATbuf) );
}
void handleLayer( void *works, int value ) {
	workp works1=(workp)works;
	if( works1->plotter->layer==4 ) {
		works1->plotter->layer=works1->plotter->baseLayer;
	} else {
		works1->plotter->layer=4;
	}
	memset( ((workp)works)->plotter->data, 0, sizeof( ((workp)works)->plotter->data ) );
}
void resetMods( void *works, int value ) {
	workp works1=(workp)works;
	if( works1->plotter->layer == 4 ) {
		works1->plotter->layer=works1->plotter->baseLayer;
	}
	memset( ((workp)works)->plotter->data, 0, sizeof( ((workp)works)->plotter->data ) );
}
void setSetup( void *works, int value ) {
	workp works1=(workp)works;
	works1->plotter->layer=16;
	memset( ((workp)works)->plotter->data, 0, sizeof( ((workp)works)->plotter->data ) );
}
void setTmate( void *works, int value ) {
	workp works1=(workp)works;
	works1->plotter->layer=32;
	memset( ((workp)works)->plotter->data, 0, sizeof( ((workp)works)->plotter->data ) );
}
void setHW( void *works, int value ) {
	workp works1=(workp)works;
	works1->noAudio=1;
	works1->setup->newDevAux=1;
	works1->setup->newDev=1;
	works1->plotter->layer=64;
	memset( ((workp)works)->plotter->data, 0, sizeof( ((workp)works)->plotter->data ) );
}
void setExp( void *works, int value ) {
	workp works1=(workp)works;
	works1->plotter->layer=1;
	works1->plotter->baseLayer=1;
	memset( ((workp)works)->plotter->data, 0, sizeof( ((workp)works)->plotter->data ) );
}
void resetHelp( void *works, int value ) {
	workp works1=(workp)works;
	works1->plotter->layer=works1->plotter->baseLayer;
	memset( ((workp)works)->plotter->data, 0, sizeof( ((workp)works)->plotter->data ) );
	works1->noAudio=0;
}
void setHelp( void *works, int value ) {
	workp works1=(workp)works;
	works1->plotter->layer=8;
	works1->plotter->baseLayer=8;
	memset( ((workp)works)->plotter->data, 0, sizeof( ((workp)works)->plotter->data ) );
}
void resetFreq( void *works, int value ) {
	workp works1=(workp)works;
	if( works1->plotter->layer==2 ) {
		works1->plotter->layer=works1->plotter->baseLayer;
	} else {
		works1->plotter->layer=2;
	}
	memset( ((workp)works)->plotter->data, 0, sizeof( ((workp)works)->plotter->data ) );
}
void getAnt( void *works, int button ) {
	buttonp buttons=((workp)works)->buttons;
	int mode = ((workp)works)->linParms->antenna;
	buttons[button].activated=180+mode*90;
}
static char antbuf[20];
static char *decodeAntString[]={ " ", antbuf };
void antRead( void *works, int button ) {
	buttonp buttons=((workp)works)->buttons;
	buttons[button].activated=1;
	sprintf( antbuf, "%d", ((workp)works)->linParms->antenna+1 );
	buttons[button].decode=decodeAntString;
}
void upAnt( void *works, int button ) {
	((workp)works)->linParms->antenna++;
	if( ((workp)works)->linParms->antenna >= 2 ) {
		((workp)works)->linParms->antenna = 2;
	}
	sprintf( CATbuf, "ELADAN%d;", ((workp)works)->linParms->antenna+1 );
	sendWebSockStatFrame( works, CATbuf, strlen(CATbuf) );
}
void downAnt( void *works, int button ) {
	((workp)works)->linParms->antenna--;
	if( ((workp)works)->linParms->antenna <= 0 ) {
		((workp)works)->linParms->antenna = 0;
	}
	sprintf( CATbuf, "ELADAN%d;", ((workp)works)->linParms->antenna+1 );
	sendWebSockStatFrame( works, CATbuf, strlen(CATbuf) );
}
void tuRead( void *works, int button ) {
	buttonp buttons=((workp)works)->buttons;
	int tune=((workp)works)->linParms->atu+1;
	buttons[button].activated=tune;
	int isTune=((workp)works)->linParms->isTune;
	if( isTune ) {
		buttons[button].activated=3;
	}
	buttons[button].decode=((workp)works)->strings->decodeTuString;
}
void setTu( void *works, int value ) {
	if( value>1 ) {
		sprintf( CATbuf, "ELADTU0;" );
	} else {
		sprintf( CATbuf, "ELADTU1;" );
	}
	sendWebSockStatFrame( works, CATbuf, strlen(CATbuf) );
}
void bankRead( void *works, int button ) {
	buttonp buttons=((workp)works)->buttons;
	int tune=((workp)works)->linParms->bank;
	buttons[button].activated=tune;
}
void setBank( void *works, int value ) {
	if( value <0 ) {
		value=1;
	}
	((workp)works)->linParms->bank=value;
	sprintf( CATbuf, "ELADBANK;" );
	sendWebSockStatFrame( works, CATbuf, strlen(CATbuf) );
}
void getRet( void *works, int button ) {
	buttonp buttons=((workp)works)->buttons;
	int autoReturn=((workp)works)->setup->autoReturn;
	buttons[button].activated=autoReturn;
}
void setRet( void *works, int value ) {
	((workp)works)->setup->autoReturn=1-((workp)works)->setup->autoReturn;
}
void paRead( void *works, int button ) {
	buttonp buttons=((workp)works)->buttons;
	int pa=((workp)works)->linParms->pa+1;
	buttons[button].activated=pa;
	buttons[button].decode=((workp)works)->strings->decodePaString;
}
void setPa( void *works, int value ) {
	int oldTxAtt=((workp)works)->linParms->oldTxAtt;
	int txAtt=((workp)works)->linParms->txAtt;
	if( txAtt<4 ) {
		sprintf( CATbuf, "ELADAT4;" );
	} else {
		sprintf( CATbuf, "ELADAT%01d;", oldTxAtt );
	}
	sendWebSockStatFrame( works, CATbuf, strlen(CATbuf) );
}
void upCwWPM( void *works, int button ) {
	((workp)works)->setup->KeyerSpeed+=1;
	if( ((workp)works)->setup->KeyerSpeed >= 100 ) {
		((workp)works)->setup->KeyerSpeed = 100;
	}
}
void downCwWPM( void *works, int button ) {
	((workp)works)->setup->KeyerSpeed-=1;
	if( ((workp)works)->setup->KeyerSpeed <= 1 ) {
		((workp)works)->setup->KeyerSpeed = 1;
	}
}
void memCwWPM( void *works, int button ) {
	static char *buffer;
	buttonp buttons=((workp)works)->buttons;
	int mode = ((workp)works)->setup->KeyerSpeed;
	buffer=buttons[button].str1;
	sprintf( buffer, "%d %s", mode, ((workp)works)->strings->messages[18] );
	buttons[button].activated=120+(double)mode*3;
}
void upKeyP( void *works, int button ) {
	((workp)works)->setup->KeyerMode+=1;
	if( ((workp)works)->setup->KeyerMode >= 2 ) {
		((workp)works)->setup->KeyerMode = 2;
	}
}
void downKeyP( void *works, int button ) {
	((workp)works)->setup->KeyerMode-=1;
	if( ((workp)works)->setup->KeyerMode <= 1 ) {
		((workp)works)->setup->KeyerMode = 1;
	}
}
void memKeyP( void *works, int button ) {
	static char *buffer;
	buttonp buttons=((workp)works)->buttons;
	int mode = ((workp)works)->setup->KeyerMode;
	buffer=buttons[button].str1;
	sprintf( buffer, "%s", ((workp)works)->strings->decodeKeyP[mode] );
	buttons[button].activated=0+(double)mode*180;
}
void setPitch( void *works, int button ) {
	sprintf( CATbuf, "PI%04d;", ((workp)works)->serParms->pitch );
	sendWebSockSerFrame( works, CATbuf, strlen(CATbuf) );
}
void upPitch( void *works, int button ) {
	((workp)works)->serParms->pitch+=10;
	if( ((workp)works)->serParms->pitch >= 1000 ) {
		((workp)works)->serParms->pitch = 1000;
	}
	setPitch( works, button );
}
void downPitch( void *works, int button ) {
	((workp)works)->serParms->pitch-=10;
	if( ((workp)works)->serParms->pitch <= 0 ) {
		((workp)works)->serParms->pitch = 0;
	}
	setPitch( works, button );
}
void getPitch( void *works, int button ) {
	return;
}
void memPitch( void *works, int button ) {
	static char *buffer;
	buttonp buttons=((workp)works)->buttons;
	int mode = ((workp)works)->serParms->pitch;
	buffer=buttons[button].str1;
	sprintf( buffer, "%d", mode );
	buttons[button].activated=120+(double)mode*0.3;
}
static glob_t globbaf;
void setFiHw( void *works, int button ) {
        struct termios TtyAttr;
        int ByteBits = CS8;
	int rc;

	if(  ((workp)works)->fifoFd > 0 ) {
		close( ((workp)works)->fifoFd );
		((workp)works)->fifoFd = -1;
	}
	close( ((workp)works)->fifoFd );
	if( ((workp)works)->setup->fiKeyPort == 0 ) {
		((workp)works)->fifoFdDef = open( "/dev/ptmx", O_RDWR );
		syslog( LOG_INFO, "works->fifoFdDef=%d opening ptmx\n", ((workp)works)->fifoFdDef );
		if( ((workp)works)->fifoFdDef <=0 ) {
			syslog( LOG_ERR, "unable to open ptmx, error %d", errno );
		}
		rc = grantpt( ((workp)works)->fifoFdDef );
		if( rc < 0 ) {
			syslog( LOG_ERR, "Error granting ptmx %d", rc );
		}
		syslog( LOG_INFO, "grantpt returns %d", rc );
		((workp)works)->fifoFd = ((workp)works)->fifoFdDef;
	} else {
		((workp)works)->fifoFd = open( ((workp)works)->setup->FifoDevice, O_RDWR | O_NOCTTY );
	}
	if( ((workp)works)->fifoFd == -1 ) {
		syslog( LOG_ERR, "unable to open fifo device %s, error %d", ((workp)works)->setup->FifoDevice, errno );
	} else {
		memset( &TtyAttr, 0, sizeof( struct termios ) );
		TtyAttr.c_iflag = IGNPAR;
		TtyAttr.c_cflag = ByteBits | CREAD | CLOCAL;
		TtyAttr.c_cc[VMIN] = 1;
		tcflush( ((workp)works)->fifoFd, TCIFLUSH );
		cfsetispeed( &TtyAttr, ((workp)works)->setup->FifoBaud );
		cfsetospeed( &TtyAttr, ((workp)works)->setup->FifoBaud );
		if( tcsetattr( ((workp)works)->fifoFd, TCSANOW, &TtyAttr ) < 0 ) {
			syslog( LOG_ERR, "Unable to set comm port %s", ((workp)works)->setup->FifoDevice );
		}
		if( ((workp)works)->setup->fiKeyPort == 0 ) {
			unlockpt( ((workp)works)->fifoFdDef );
/*
			((workp)works)->slavename = ptsname( ((workp)works)->fifoFdDef );
*/
			syslog( LOG_INFO, "slavename: %s", ((workp)works)->slavename );
			if( ((workp)works)->setup->hwdebug ) {
				fprintf( stderr, "slavename: %s", ((workp)works)->slavename );
				fflush( stderr );
			}
			rc = chmod( ((workp)works)->slavename, S_IRUSR|S_IWUSR|S_IRGRP|S_IWGRP|S_IROTH|S_IWOTH );
			if( rc ) {
				syslog( LOG_ERR, "error %d setting permissions on %s", errno, ((workp)works)->slavename );
				if( ((workp)works)->setup->hwdebug ) {
					fprintf( stderr, "error %d sessing permissions on: %s\n", errno, ((workp)works)->slavename );
					fflush( stderr );
				}
			}
		}
	}
}

int getAudioDevP( void *works, int button, int RTx ) {
	int	j, jr, jt;
	const PaDeviceInfo *deviceInfo;
	static char *buffer;
	buttonp buttons=((workp)works)->buttons;

	((workp)works)->setup->numDev = Pa_GetDeviceCount();
	if( ((workp)works)->setup->numDev < 0 ) {
		syslog( LOG_ERR, "ERROR: Pa_GetDeviceCount returned 0x%x\n", ((workp)works)->setup->numDev );
		Pa_Terminate();
		return 0;
	}
	
	if( ((workp)works)->setup->newDevAux==1 ) {
		((workp)works)->setup->newDevAux=0;
		((workp)works)->setup->numRxAux=0;
		for( j=0,jr=0; j<((workp)works)->setup->numDev; j++ ) {
			deviceInfo = Pa_GetDeviceInfo( j );
			if( deviceInfo->maxOutputChannels==0 ) {
				continue;
			}
			if( j == Pa_GetDefaultOutputDevice() ) {
				((workp)works)->setup->nefRx=jr;
				((workp)works)->setup->defRx=j;
				if(  ((workp)works)->setup->devRxAux ==  -1 ) {
					((workp)works)->setup->numRxAux=jr;
				}
			} else if( j == Pa_GetHostApiInfo( deviceInfo->hostApi )->defaultOutputDevice ) {
				((workp)works)->setup->nefRx=jr;
				((workp)works)->setup->defRx=j;
				if(  ((workp)works)->setup->devRxAux ==  -1 ) {
					((workp)works)->setup->numRxAux=jr;
				}
			}
			sprintf( ((workp)works)->setup->rxDev[jr], "%-45.45s", deviceInfo->name );
			((workp)works)->setup->rxDevN[jr] = j;
			if(  ((workp)works)->setup->devRxAux ==  ((workp)works)->setup->rxDevN[jr] ) {
				((workp)works)->setup->numRxAux=jr;
			}
			jr++;
		}
		((workp)works)->setup->numDevRx=jr;
		((workp)works)->setup->numTxAux=0;
		for( j=0,jt=0; j<((workp)works)->setup->numDev; j++ ) {
			deviceInfo = Pa_GetDeviceInfo( j );
			if( deviceInfo->maxInputChannels==0 ) {
				continue;
			}
			if( j == Pa_GetDefaultInputDevice() ) {
				((workp)works)->setup->nefTx=jt;
				((workp)works)->setup->defTx=j;
				if(  ((workp)works)->setup->devTxAux ==  -1 ) {
					((workp)works)->setup->numTxAux=jt;
				}
			} else if( j == Pa_GetHostApiInfo( deviceInfo->hostApi )->defaultInputDevice ) {
				((workp)works)->setup->nefTx=jt;
				((workp)works)->setup->defTx=j;
				if(  ((workp)works)->setup->devTxAux ==  -1 ) {
					((workp)works)->setup->numTxAux=jt;
				}
			}
			sprintf( ((workp)works)->setup->txDev[jt], "%-45.45s", deviceInfo->name );
			((workp)works)->setup->txDevN[jt] = j;
			if(  ((workp)works)->setup->devTxAux ==  ((workp)works)->setup->txDevN[jt] ) {
				((workp)works)->setup->numTxAux=jt;
			}
			jt++;
		}
		((workp)works)->setup->numDevTx=jt;
	}

	buffer=buttons[button].str1;
	if( RTx ) {
		if( ((workp)works)->setup->numRxAux < 0 || ((workp)works)->setup->numRxAux > ((workp)works)->setup->numDevRx-1 ) {
			((workp)works)->setup->numRxAux = ((workp)works)->setup->nefRx;
		}
		strcpy( buffer, ((workp)works)->setup->rxDev[((workp)works)->setup->numRxAux] );
		buttons[button].activated=-225+((workp)works)->setup->numRxAux*270/(((workp)works)->setup->numDevRx-1);
		((workp)works)->setup->devRxAux = ((workp)works)->setup->rxDevN[((workp)works)->setup->numRxAux];
	} else {
		if( ((workp)works)->setup->numTxAux < 0 || ((workp)works)->setup->numTxAux > ((workp)works)->setup->numDevTx-1 ) {
			((workp)works)->setup->numTxAux = ((workp)works)->setup->nefTx;
		}
		strcpy( buffer, ((workp)works)->setup->txDev[((workp)works)->setup->numTxAux] );
		buttons[button].activated=-225+((workp)works)->setup->numTxAux*270/(((workp)works)->setup->numDevTx-1);
		((workp)works)->setup->devTx = ((workp)works)->setup->txDevN[((workp)works)->setup->numTx];
	}
	return 0;
}
int getAudioDev( void *works, int button, int RTx ) {
	int	j, jr, jt;
	const PaDeviceInfo *deviceInfo;
	static char *buffer;
	buttonp buttons=((workp)works)->buttons;

	((workp)works)->setup->numDev = Pa_GetDeviceCount();
	if( ((workp)works)->setup->numDev < 0 ) {
		syslog( LOG_ERR, "ERROR: Pa_GetDeviceCount returned 0x%x\n", ((workp)works)->setup->numDev );
		Pa_Terminate();
		return 0;
	}
	
	if( ((workp)works)->setup->newDev==1 ) {
		((workp)works)->setup->newDev=0;
		((workp)works)->setup->numRx=0;
		for( j=0,jr=0; j<((workp)works)->setup->numDev; j++ ) {
			deviceInfo = Pa_GetDeviceInfo( j );
			if( deviceInfo->maxOutputChannels==0 ) {
				continue;
			}
			if( j == Pa_GetDefaultOutputDevice() ) {
				((workp)works)->setup->nefRx=jr;
				((workp)works)->setup->defRx=j;
				if(  ((workp)works)->setup->devRx ==  -1 ) {
					((workp)works)->setup->numRx=jr;
				}
			} else if( j == Pa_GetHostApiInfo( deviceInfo->hostApi )->defaultOutputDevice ) {
				((workp)works)->setup->nefRx=jr;
				((workp)works)->setup->defRx=j;
				if(  ((workp)works)->setup->devRx ==  -1 ) {
					((workp)works)->setup->numRx=jr;
				}
			}
			sprintf( ((workp)works)->setup->rxDev[jr], "%-45.45s", deviceInfo->name );
			((workp)works)->setup->rxDevN[jr] = j;
			if(  ((workp)works)->setup->devRx ==  ((workp)works)->setup->rxDevN[jr] ) {
				((workp)works)->setup->numRx=jr;
			}
			jr++;
		}
		((workp)works)->setup->numDevRx=jr;
		((workp)works)->setup->numTx=0;
		for( j=0,jt=0; j<((workp)works)->setup->numDev; j++ ) {
			deviceInfo = Pa_GetDeviceInfo( j );
			if( deviceInfo->maxInputChannels==0 ) {
				continue;
			}
			if( j == Pa_GetDefaultInputDevice() ) {
				((workp)works)->setup->nefTx=jt;
				((workp)works)->setup->defTx=j;
				if(  ((workp)works)->setup->devTx ==  -1 ) {
					((workp)works)->setup->numTx=jt;
				}
			} else if( j == Pa_GetHostApiInfo( deviceInfo->hostApi )->defaultInputDevice ) {
				((workp)works)->setup->nefTx=jt;
				((workp)works)->setup->defTx=j;
				if(  ((workp)works)->setup->devTx ==  -1 ) {
					((workp)works)->setup->numTx=jt;
				}
			}
			sprintf( ((workp)works)->setup->txDev[jt], "%-45.45s", deviceInfo->name );
			((workp)works)->setup->txDevN[jt] = j;
			if(  ((workp)works)->setup->devTx ==  ((workp)works)->setup->txDevN[jt] ) {
				((workp)works)->setup->numTx=jt;
			}
			jt++;
		}
		((workp)works)->setup->numDevTx=jt;
	}

	buffer=buttons[button].str1;
	if( RTx ) {
		if( ((workp)works)->setup->numRx < 0 || ((workp)works)->setup->numRx > ((workp)works)->setup->numDevRx-1 ) {
			((workp)works)->setup->numRx = ((workp)works)->setup->nefRx;
		}
		strcpy( buffer, ((workp)works)->setup->rxDev[((workp)works)->setup->numRx] );
		buttons[button].activated=-225+((workp)works)->setup->numRx*270/(((workp)works)->setup->numDevRx-1);
		((workp)works)->setup->devRx = ((workp)works)->setup->rxDevN[((workp)works)->setup->numRx];
	} else {
		if( ((workp)works)->setup->numTx < 0 || ((workp)works)->setup->numTx > ((workp)works)->setup->numDevTx-1 ) {
			((workp)works)->setup->numTx = ((workp)works)->setup->nefTx;
		}
		strcpy( buffer, ((workp)works)->setup->txDev[((workp)works)->setup->numTx] );
		buttons[button].activated=-225+((workp)works)->setup->numTx*270/(((workp)works)->setup->numDevTx-1);
		((workp)works)->setup->devTx = ((workp)works)->setup->txDevN[((workp)works)->setup->numTx];
	}
	return 0;
}

void upTxAuP( void *works, int button ) {
	((workp)works)->setup->numTxAux+=1;
	if( ((workp)works)->setup->numTxAux >= ((workp)works)->setup->numDevTx-1 ) {
		((workp)works)->setup->numTxAux = ((workp)works)->setup->numDevTx-1;
	}
	((workp)works)->setup->devTxAux = ((workp)works)->setup->txDevN[((workp)works)->setup->numTxAux];
	return;
}
void downTxAuP( void *works, int button ) {
	((workp)works)->setup->numTxAux-=1;
	if( ((workp)works)->setup->numTxAux <= 0 ) {
		((workp)works)->setup->numTxAux = 0;
	}
	((workp)works)->setup->devTxAux = ((workp)works)->setup->txDevN[((workp)works)->setup->numTxAux];
	return;
}
void getTxAuP( void *works, int button ) {
	getAudioDevP( works, button, 0 );
	return;
}
void upRxAuP( void *works, int button ) {
	((workp)works)->setup->numRxAux+=1;
	if( ((workp)works)->setup->numRxAux >= ((workp)works)->setup->numDevRx-1 ) {
		((workp)works)->setup->numRxAux = ((workp)works)->setup->numDevRx-1;
	}
	((workp)works)->setup->devRxAux = ((workp)works)->setup->rxDevN[((workp)works)->setup->numRxAux];
	return;
}
void downRxAuP( void *works, int button ) {
	((workp)works)->setup->numRxAux-=1;
	if( ((workp)works)->setup->numRxAux <= 0 ) {
		((workp)works)->setup->numRxAux = 0;
	}
	((workp)works)->setup->devRxAux = ((workp)works)->setup->rxDevN[((workp)works)->setup->numRxAux];
	return;
}
void getRxAuP( void *works, int button ) {
	getAudioDevP( works, button, 1 );
	return;
}

void upTxAu( void *works, int button ) {
	((workp)works)->setup->numTx+=1;
	if( ((workp)works)->setup->numTx >= ((workp)works)->setup->numDevTx-1 ) {
		((workp)works)->setup->numTx = ((workp)works)->setup->numDevTx-1;
	}
	((workp)works)->setup->devTx = ((workp)works)->setup->txDevN[((workp)works)->setup->numTx];
	return;
}
void downTxAu( void *works, int button ) {
	((workp)works)->setup->numTx-=1;
	if( ((workp)works)->setup->numTx <= 0 ) {
		((workp)works)->setup->numTx = 0;
	}
	((workp)works)->setup->devTx = ((workp)works)->setup->txDevN[((workp)works)->setup->numTx];
	return;
}
void getTxAu( void *works, int button ) {
	getAudioDev( works, button, 0 );
	return;
}
void upRxAu( void *works, int button ) {
	((workp)works)->setup->numRx+=1;
	if( ((workp)works)->setup->numRx >= ((workp)works)->setup->numDevRx-1 ) {
		((workp)works)->setup->numRx = ((workp)works)->setup->numDevRx-1;
	}
	((workp)works)->setup->devRx = ((workp)works)->setup->rxDevN[((workp)works)->setup->numRx];
	return;
}
void downRxAu( void *works, int button ) {
	((workp)works)->setup->numRx-=1;
	if( ((workp)works)->setup->numRx <= 0 ) {
		((workp)works)->setup->numRx = 0;
	}
	((workp)works)->setup->devRx = ((workp)works)->setup->rxDevN[((workp)works)->setup->numRx];
	return;
}
void getRxAu( void *works, int button ) {
	getAudioDev( works, button, 1 );
	return;
}
void upFiHw( void *works, int button ) {
	((workp)works)->setup->fiKeyPort+=1;
	if( ((workp)works)->setup->fiKeyPort >= globbaf.gl_pathc-1 ) {
		((workp)works)->setup->fiKeyPort = globbaf.gl_pathc-1;
	}
	strcpy( ((workp)works)->setup->FifoDevice, globbaf.gl_pathv[((workp)works)->setup->fiKeyPort] );
	setFiHw( works, button );
}
void downFiHw( void *works, int button ) {
	((workp)works)->setup->fiKeyPort-=1;
	if( ((workp)works)->setup->fiKeyPort <= 0 ) {
		((workp)works)->setup->fiKeyPort = 0;
	}
	strcpy( ((workp)works)->setup->FifoDevice, globbaf.gl_pathv[((workp)works)->setup->fiKeyPort] );
	setFiHw( works, button );
}
void getFiHw( void *works, int button ) {
	static char *buffer;
	int j;
	static char* pp=NULL;
	int mode = ((workp)works)->setup->fiKeyPort;
	buttonp buttons=((workp)works)->buttons;
	((workp)works)->setup->fiKeyPort=0;
	buffer=buttons[button].str1;
	if( pp ) {
		globbaf.gl_pathv[0]=pp;
	}
	globfree( &globbaf );
        glob( "/", 0,  NULL, &globbaf );
        glob( "/dev/ttyS*", GLOB_APPEND,  NULL, &globbaf );
        glob( "/dev/ttyUSB*", GLOB_APPEND,  NULL, &globbaf );
	pp=globbaf.gl_pathv[0];
	globbaf.gl_pathv[0]=((workp)works)->slavename;
	((workp)works)->setup->fiKeyPort=0;
	for( j=0; j<globbaf.gl_pathc; j++ ) {
		if( !strcmp( globbaf.gl_pathv[j], ((workp)works)->setup->FifoDevice ) ) {
			((workp)works)->setup->fiKeyPort=j;
			break;
		}
	}
	mode=((workp)works)->setup->fiKeyPort;
	strcpy( buffer, globbaf.gl_pathv[mode]+5 );
	buttons[button].activated=180+mode*180/(globbaf.gl_pathc>0?globbaf.gl_pathc:1);
}
void upFiBr( void *works, int button ) {
	((workp)works)->setup->FifoBaudIndex+=1;
	if( ((workp)works)->setup->FifoBaudIndex >= ((workp)works)->strings->nBaudRate-1 ) {
		((workp)works)->setup->FifoBaudIndex = ((workp)works)->strings->nBaudRate-1;
	}
	((workp)works)->setup->FifoBaud = ((workp)works)->strings->baudRate[((workp)works)->setup->FifoBaudIndex];
	setFiHw( works, button );
}
void downFiBr( void *works, int button ) {
	((workp)works)->setup->FifoBaudIndex-=1;
	if( ((workp)works)->setup->FifoBaudIndex <= 0 ) {
		((workp)works)->setup->FifoBaudIndex = 0;
	}
	((workp)works)->setup->FifoBaud = ((workp)works)->strings->baudRate[((workp)works)->setup->FifoBaudIndex];
	setFiHw( works, button );
}
void getFiBr( void *works, int button ) {
	static char *buffer;
	int j;
	buttonp buttons=((workp)works)->buttons;
	int mode = ((workp)works)->setup->FifoBaudIndex;
	buffer=buttons[button].str1;
	((workp)works)->setup->FifoBaudIndex=0;
	for( j=0; j<((workp)works)->strings->nBaudRate; j++ ) {
		if( ((workp)works)->strings->baudRate[j] == ((workp)works)->setup->FifoBaud ) {
			((workp)works)->setup->FifoBaudIndex=j;
			break;
		}
	}
	mode=((workp)works)->setup->FifoBaudIndex;
	sprintf( buffer, "%d", ((workp)works)->strings->baudRate[j] );
	buttons[button].activated=180+mode*180/(((workp)works)->strings->nBaudRate);
}
static glob_t globbuf;
void setCwHw( void *works, int button ) {
	if(  ((workp)works)->keyFd > 0 ) {
		close( ((workp)works)->keyFd );
		((workp)works)->keyFd = -1;
	}
	if( ((workp)works)->setup->cwKeyPort > 0 ) {
		((workp)works)->keyFd = open( ((workp)works)->setup->KeyerDevice, O_RDWR | O_NOCTTY );
		if( ((workp)works)->keyFd == -1 ) {
			syslog( LOG_ERR, "unable to open keyer device %s, error %d", ((workp)works)->setup->KeyerDevice, errno );
		}
	}
}
void upCwHw( void *works, int button ) {
	((workp)works)->setup->cwKeyPort+=1;
	if( ((workp)works)->setup->cwKeyPort >= globbuf.gl_pathc-1 ) {
		((workp)works)->setup->cwKeyPort = globbuf.gl_pathc-1;
	}
	strcpy( ((workp)works)->setup->KeyerDevice, globbuf.gl_pathv[((workp)works)->setup->cwKeyPort] );
	setCwHw( works, button );
}
void downCwHw( void *works, int button ) {
	((workp)works)->setup->cwKeyPort-=1;
	if( ((workp)works)->setup->cwKeyPort <= 0 ) {
		((workp)works)->setup->cwKeyPort = 0;
	}
	strcpy( ((workp)works)->setup->KeyerDevice, globbuf.gl_pathv[((workp)works)->setup->cwKeyPort] );
	setCwHw( works, button );
}
void getCwHw( void *works, int button ) {
	static char *buffer;
	int j;
	static char *pp=NULL;
	buttonp buttons=((workp)works)->buttons;
	int mode = ((workp)works)->setup->cwKeyPort;
	buffer=buttons[button].str1;
	if( pp ) {
		globbuf.gl_pathv[0]=pp;
	}
	globfree( &globbuf );
        glob( "/", 0,  NULL, &globbuf );
        glob( "/dev/ttyS*", GLOB_APPEND,  NULL, &globbuf );
        glob( "/dev/ttyUSB*", GLOB_APPEND,  NULL, &globbuf );
	pp=globbuf.gl_pathv[0];
	globbuf.gl_pathv[0]=((workp)works)->strings->messages[73];
	((workp)works)->setup->cwKeyPort=0;
	for( j=0; j<globbuf.gl_pathc; j++ ) {
		if( !strcmp( globbuf.gl_pathv[j], ((workp)works)->setup->KeyerDevice ) ) {
			((workp)works)->setup->cwKeyPort=j;
			break;
		}
	}
	mode=((workp)works)->setup->cwKeyPort;
	strcpy( buffer, globbuf.gl_pathv[mode]+5 );
	buttons[button].activated=180+mode*180/(globbuf.gl_pathc>0?globbuf.gl_pathc:1);
}
void setVorAuP( void *works, int button ) {
	return;
}
void upVorAuP( void *works, int button ) {
	((workp)works)->setup->vorAuP+=1;
	if( ((workp)works)->setup->vorAuP >= 100 ) {
		((workp)works)->setup->vorAuP = 100;
	}
	setVorAuP( works, button );
}
void downVorAuP( void *works, int button ) {
	((workp)works)->setup->vorAuP-=1;
	if( ((workp)works)->setup->vorAuP <= 0 ) {
		((workp)works)->setup->vorAuP = 0;
	}
	setVorAuP( works, button );
}
void getVorAuP( void *works, int button ) {
	static char *buffer;
	buttonp buttons=((workp)works)->buttons;
	int mode = ((workp)works)->setup->vorAuP;
	buttons[button].activated=-225+mode*270/(100);
	buffer=buttons[button].str1;
	sprintf( buffer, "%d", ((workp)works)->setup->vorAuP );
}
void setVotAuP( void *works, int button ) {
	return;
}
void upVotAuP( void *works, int button ) {
	((workp)works)->setup->votAuP+=1;
	if( ((workp)works)->setup->votAuP >= 100 ) {
		((workp)works)->setup->votAuP = 100;
	}
	setVotAuP( works, button );
}
void downVotAuP( void *works, int button ) {
	((workp)works)->setup->votAuP-=1;
	if( ((workp)works)->setup->votAuP <= 0 ) {
		((workp)works)->setup->votAuP = 0;
	}
	setVotAuP( works, button );
}
void getVotAuP( void *works, int button ) {
	static char *buffer;
	buttonp buttons=((workp)works)->buttons;
	int mode = ((workp)works)->setup->votAuP;
	buttons[button].activated=-225+mode*270/(100);
	buffer=buttons[button].str1;
	sprintf( buffer, "%d", ((workp)works)->setup->votAuP );
}
void setLangue( void *works, int button ) {
	strcpy( ((workp)works)->setup->myLangue, ((workp)works)->Languages[((workp)works)->setup->langue] );
	locale( (workp)works, ((workp)works)->setup->myLangue );
}
void upLangue( void *works, int button ) {
	((workp)works)->setup->langue+=1;
	if( ((workp)works)->setup->langue >= ((workp)works)->nLanguages-1 ) {
		((workp)works)->setup->langue = ((workp)works)->nLanguages-1;
	}
	setLangue( works, button );
}
void downLangue( void *works, int button ) {
	((workp)works)->setup->langue-=1;
	if( ((workp)works)->setup->langue <= 0 ) {
		((workp)works)->setup->langue = 0;
	}
	setLangue( works, button );
}
void getLangue( void *works, int button ) {
	static char *buffer;
	buttonp buttons=((workp)works)->buttons;
	int mode = ((workp)works)->setup->langue;
	buttons[button].activated=180+mode*180/(((workp)works)->nLanguages-1);
	buffer=buttons[button].str1;
	strcpy( buffer, ((workp)works)->Languages[mode] );
}
void setTxAtt( void *works, int button ) {
	sprintf( CATbuf, "ELADAT%01d;", ((workp)works)->linParms->txAtt );
	sendWebSockStatFrame( works, CATbuf, strlen(CATbuf) );
}
void upTxAtt( void *works, int button ) {
	((workp)works)->linParms->txAtt+=1;
	if( ((workp)works)->linParms->txAtt >= 4 ) {
		((workp)works)->linParms->txAtt = 4;
	}
	setTxAtt( works, button );
}
void downTxAtt( void *works, int button ) {
	((workp)works)->linParms->txAtt-=1;
	if( ((workp)works)->linParms->txAtt <= 0 ) {
		((workp)works)->linParms->txAtt = 0;
	}
	setTxAtt( works, button );
}
void getTxAtt( void *works, int button ) {
	static char *buffer;
	buttonp buttons=((workp)works)->buttons;
	int mode = ((workp)works)->linParms->txAtt;
	buttons[button].activated=180+mode*45;
	buffer=buttons[button].str1;
	strcpy( buffer, ((workp)works)->strings->txAttStr[mode] );
}
void setVolume( void *works, int button ) {
	gettimeofday(&(((workp)works)->volumeChanged) , NULL );
	sprintf( CATbuf, "VM%03d;", ((workp)works)->serParms->volume );
	sendWebSockSerFrame( works, CATbuf, strlen(CATbuf) );
}
void upVolume( void *works, int button ) {
	((workp)works)->serParms->volume+=10;
	if( ((workp)works)->serParms->volume >= 100 ) {
		((workp)works)->serParms->volume = 100;
	}
	setVolume( works, button );
}
void downVolume( void *works, int button ) {
	((workp)works)->serParms->volume-=10;
	if( ((workp)works)->serParms->volume <= 0 ) {
		((workp)works)->serParms->volume = 0;
	}
	setVolume( works, button );
}
void getVolume( void *works, int button ) {
	return;
}
void memVolume( void *works, int button ) {
	static char *buffer;
	buttonp buttons=((workp)works)->buttons;
	int mode = ((workp)works)->serParms->volume;
	buffer=buttons[button].str1;
	sprintf( buffer, "%d", mode );
	buttons[button].activated=120+mode*3;
}
void setSide( void *works, int button ) {
	sprintf( CATbuf, "VT%03d;", ((workp)works)->serParms->volumeSide );
	sendWebSockSerFrame( works, CATbuf, strlen(CATbuf) );
}
void upSide( void *works, int button ) {
	((workp)works)->serParms->volumeSide+=1;
	if( ((workp)works)->serParms->volumeSide >= 100 ) {
		((workp)works)->serParms->volumeSide = 100;
	}
	setSide( works, button );
}
void downSide( void *works, int button ) {
	((workp)works)->serParms->volumeSide-=1;
	if( ((workp)works)->serParms->volumeSide <= 0 ) {
		((workp)works)->serParms->volumeSide = 0;
	}
	setSide( works, button );
}
void getSide( void *works, int button ) {
	return;
}
void memSide( void *works, int button ) {
	static char *buffer;
	buttonp buttons=((workp)works)->buttons;
	int mode = ((workp)works)->serParms->volumeSide;
	buffer=buttons[button].str1;
	sprintf( buffer, "%d", mode );
	buttons[button].activated=120+mode*3;
}
void setBufTime( void *works, int button ) {
	((workp)works)->setup->bufferingTime=((workp)works)->strings->nbtime[((workp)works)->BufTime];
	((workp)works)->buffer_start=((workp)works)->setup->bufferingTime/((workp)works)->setup->rxChunkTime;
	if( ((workp)works)->buffer_start < 1 ) {
		((workp)works)->buffer_start = 1;
	}
	((workp)works)->bufferingChanged = 1;
	buildConfig( works );
}
void upBufTime( void *works, int button ) {
	((workp)works)->BufTime+=1;
	if( ((workp)works)->BufTime >= 12 ) {
		((workp)works)->BufTime = 12;
	}
	setBufTime( works, button );
}
void downBufTime( void *works, int button ) {
	((workp)works)->BufTime-=1;
	if( ((workp)works)->BufTime <= 0 ) {
		((workp)works)->BufTime = 0;
	}
	setBufTime( works, button );
}
void memBufTime( void *works, int button ) {
	int j, mode;
	static char *buffer;
	buttonp buttons=((workp)works)->buttons;
	for( j=0; j<=12; j++ ) {
		if( ((workp)works)->strings->nbtime[j]>=((workp)works)->setup->bufferingTime ) {
			mode = ((workp)works)->BufTime = j;
			break;
		}
	}
	buffer=buttons[button].str1;
	strcpy( buffer, ((workp)works)->strings->sbtime[mode] );
	buttons[button].activated=135+mode*22.5;
}
void setRTxChunk( void *works, int button ) {
        ((workp)works)->setup->rxChunkTime=((workp)works)->strings->nchunk[((workp)works)->RxChunk];
        ((workp)works)->setup->txChunkTime=((workp)works)->strings->nchunk[((workp)works)->TxChunk];
	((workp)works)->buffer_start=((workp)works)->setup->bufferingTime/((workp)works)->setup->rxChunkTime;
	((workp)works)->bufferingChanged = 1;
	buildConfig( works );
}
void upTxChunk( void *works, int button ) {
	((workp)works)->TxChunk+=1;
	if( ((workp)works)->TxChunk >= 4 ) {
		((workp)works)->TxChunk = 4;
	}
	if( ((workp)works)->txcompress == 0 ) {
		if( ((workp)works)->TxChunk >= 2 ) {
			((workp)works)->TxChunk = 2;
		}
	}
	setRTxChunk( works, button );
}
void downTxChunk( void *works, int button ) {
	((workp)works)->TxChunk-=1;
	if( ((workp)works)->TxChunk <= 0 ) {
		((workp)works)->TxChunk = 0;
	}
	if( ((workp)works)->txcompress != 0 ) {
		if( ((workp)works)->TxChunk <= 1 ) {
			((workp)works)->TxChunk = 1;
		}
	}
	setRTxChunk( works, button );
}
void memTxChunk( void *works, int button ) {
	int j, mode;
	static char *buffer;
	buttonp buttons=((workp)works)->buttons;
	for( j=0; j<5; j++ ) {
		if( ((workp)works)->strings->nchunk[j]>=((workp)works)->setup->txChunkTime ) {
			mode = ((workp)works)->TxChunk = j;
			break;
		}
	}
	buffer=buttons[button].str1;
	strcpy( buffer, ((workp)works)->strings->schunk[mode] );
	buttons[button].activated=136+mode*67;
}
void stCb( void *works, int button ) {
	((workp)works)->buttons[button].activated=((workp)works)->buttons[button].activated>0?-((workp)works)->buttons[button].activated:((workp)works)->buttons[button].activated;
}
void kbCb( void *works, int button ) {
	((workp)works)->kbcb( works, button-1 );
}
void upKbF1( void *works, int button ) {
	((workp)works)->setup->kbkeysidx[0]+=1;
	if( ((workp)works)->setup->kbkeysidx[0] >= ((workp)works)->tmateNbuttons-1 ) {
		((workp)works)->setup->kbkeysidx[0] = ((workp)works)->tmateNbuttons-1;
	}
	((workp)works)->setup->kbkeys[0]=((workp)works)->tmateButtons[((workp)works)->setup->kbkeysidx[0]];
}
void downKbF1( void *works, int button ) {
	((workp)works)->setup->kbkeysidx[0]-=1;
	if( ((workp)works)->setup->kbkeysidx[0] <= 0 ) {
		((workp)works)->setup->kbkeysidx[0] = 0;
	}
	((workp)works)->setup->kbkeys[0]=((workp)works)->tmateButtons[((workp)works)->setup->kbkeysidx[0]];
}
void memKbF1( void *works, int button ) {
	static char *buffer;
	buttonp buttons=((workp)works)->buttons;
	buffer=buttons[button].str1;
	sprintf( buffer, "%s", buttons[((workp)works)->setup->kbkeys[0]-1].name );
	buffer[8]=0;
	buttons[button].activated=135+((workp)works)->setup->kbkeysidx[0]*270.0/((workp)works)->tmateNbuttons;
	((workp)works)->kbaddcallback( works, 0 );
}
void upKbF2( void *works, int button ) {
	((workp)works)->setup->kbkeysidx[1]+=1;
	if( ((workp)works)->setup->kbkeysidx[1] >= ((workp)works)->tmateNbuttons-1 ) {
		((workp)works)->setup->kbkeysidx[1] = ((workp)works)->tmateNbuttons-1;
	}
	((workp)works)->setup->kbkeys[1]=((workp)works)->tmateButtons[((workp)works)->setup->kbkeysidx[1]];
}
void downKbF2( void *works, int button ) {
	((workp)works)->setup->kbkeysidx[1]-=1;
	if( ((workp)works)->setup->kbkeysidx[1] <= 0 ) {
		((workp)works)->setup->kbkeysidx[1] = 0;
	}
	((workp)works)->setup->kbkeys[1]=((workp)works)->tmateButtons[((workp)works)->setup->kbkeysidx[1]];
}
void memKbF2( void *works, int button ) {
	static char *buffer;
	buttonp buttons=((workp)works)->buttons;
	buffer=buttons[button].str1;
	sprintf( buffer, "%s", buttons[((workp)works)->setup->kbkeys[1]-1].name );
	buffer[8]=0;
	buttons[button].activated=135+((workp)works)->setup->kbkeysidx[1]*270.0/((workp)works)->tmateNbuttons;
	((workp)works)->kbaddcallback( works, 1 );
}
void upKbF3( void *works, int button ) {
	((workp)works)->setup->kbkeysidx[2]+=1;
	if( ((workp)works)->setup->kbkeysidx[2] >= ((workp)works)->tmateNbuttons-1 ) {
		((workp)works)->setup->kbkeysidx[2] = ((workp)works)->tmateNbuttons-1;
	}
	((workp)works)->setup->kbkeys[2]=((workp)works)->tmateButtons[((workp)works)->setup->kbkeysidx[2]];
}
void downKbF3( void *works, int button ) {
	((workp)works)->setup->kbkeysidx[2]-=1;
	if( ((workp)works)->setup->kbkeysidx[2] <= 0 ) {
		((workp)works)->setup->kbkeysidx[2] = 0;
	}
	((workp)works)->setup->kbkeys[2]=((workp)works)->tmateButtons[((workp)works)->setup->kbkeysidx[2]];
}
void memKbF3( void *works, int button ) {
	static char *buffer;
	buttonp buttons=((workp)works)->buttons;
	buffer=buttons[button].str1;
	sprintf( buffer, "%s", buttons[((workp)works)->setup->kbkeys[2]-1].name );
	buffer[8]=0;
	buttons[button].activated=135+((workp)works)->setup->kbkeysidx[2]*270.0/((workp)works)->tmateNbuttons;
	((workp)works)->kbaddcallback( works, 2 );
}
void upKbF4( void *works, int button ) {
	((workp)works)->setup->kbkeysidx[3]+=1;
	if( ((workp)works)->setup->kbkeysidx[3] >= ((workp)works)->tmateNbuttons-1 ) {
		((workp)works)->setup->kbkeysidx[3] = ((workp)works)->tmateNbuttons-1;
	}
	((workp)works)->setup->kbkeys[3]=((workp)works)->tmateButtons[((workp)works)->setup->kbkeysidx[3]];
}
void downKbF4( void *works, int button ) {
	((workp)works)->setup->kbkeysidx[3]-=1;
	if( ((workp)works)->setup->kbkeysidx[3] <= 0 ) {
		((workp)works)->setup->kbkeysidx[3] = 0;
	}
	((workp)works)->setup->kbkeys[3]=((workp)works)->tmateButtons[((workp)works)->setup->kbkeysidx[3]];
}
void memKbF4( void *works, int button ) {
	static char *buffer;
	buttonp buttons=((workp)works)->buttons;
	buffer=buttons[button].str1;
	sprintf( buffer, "%s", buttons[((workp)works)->setup->kbkeys[3]-1].name );
	buffer[8]=0;
	buttons[button].activated=135+((workp)works)->setup->kbkeysidx[3]*270.0/((workp)works)->tmateNbuttons;
	((workp)works)->kbaddcallback( works, 3 );
}
void upKbF5( void *works, int button ) {
	((workp)works)->setup->kbkeysidx[4]+=1;
	if( ((workp)works)->setup->kbkeysidx[4] >= ((workp)works)->tmateNbuttons-1 ) {
		((workp)works)->setup->kbkeysidx[4] = ((workp)works)->tmateNbuttons-1;
	}
	((workp)works)->setup->kbkeys[4]=((workp)works)->tmateButtons[((workp)works)->setup->kbkeysidx[4]];
}
void downKbF5( void *works, int button ) {
	((workp)works)->setup->kbkeysidx[4]-=1;
	if( ((workp)works)->setup->kbkeysidx[4] <= 0 ) {
		((workp)works)->setup->kbkeysidx[4] = 0;
	}
	((workp)works)->setup->kbkeys[4]=((workp)works)->tmateButtons[((workp)works)->setup->kbkeysidx[4]];
}
void memKbF5( void *works, int button ) {
	static char *buffer;
	buttonp buttons=((workp)works)->buttons;
	buffer=buttons[button].str1;
	sprintf( buffer, "%s", buttons[((workp)works)->setup->kbkeys[4]-1].name );
	buffer[8]=0;
	buttons[button].activated=135+((workp)works)->setup->kbkeysidx[4]*270.0/((workp)works)->tmateNbuttons;
	((workp)works)->kbaddcallback( works, 4 );
}
void upKbF6( void *works, int button ) {
	((workp)works)->setup->kbkeysidx[5]+=1;
	if( ((workp)works)->setup->kbkeysidx[5] >= ((workp)works)->tmateNbuttons-1 ) {
		((workp)works)->setup->kbkeysidx[5] = ((workp)works)->tmateNbuttons-1;
	}
	((workp)works)->setup->kbkeys[5]=((workp)works)->tmateButtons[((workp)works)->setup->kbkeysidx[5]];
}
void downKbF6( void *works, int button ) {
	((workp)works)->setup->kbkeysidx[5]-=1;
	if( ((workp)works)->setup->kbkeysidx[5] <= 0 ) {
		((workp)works)->setup->kbkeysidx[5] = 0;
	}
	((workp)works)->setup->kbkeys[5]=((workp)works)->tmateButtons[((workp)works)->setup->kbkeysidx[5]];
}
void memKbF6( void *works, int button ) {
	static char *buffer;
	buttonp buttons=((workp)works)->buttons;
	buffer=buttons[button].str1;
	sprintf( buffer, "%s", buttons[((workp)works)->setup->kbkeys[5]-1].name );
	buffer[8]=0;
	buttons[button].activated=135+((workp)works)->setup->kbkeysidx[5]*270.0/((workp)works)->tmateNbuttons;
	((workp)works)->kbaddcallback( works, 5 );
}
void upKbF7( void *works, int button ) {
	((workp)works)->setup->kbkeysidx[6]+=1;
	if( ((workp)works)->setup->kbkeysidx[6] >= ((workp)works)->tmateNbuttons-1 ) {
		((workp)works)->setup->kbkeysidx[6] = ((workp)works)->tmateNbuttons-1;
	}
	((workp)works)->setup->kbkeys[6]=((workp)works)->tmateButtons[((workp)works)->setup->kbkeysidx[6]];
}
void downKbF7( void *works, int button ) {
	((workp)works)->setup->kbkeysidx[6]-=1;
	if( ((workp)works)->setup->kbkeysidx[6] <= 0 ) {
		((workp)works)->setup->kbkeysidx[6] = 0;
	}
	((workp)works)->setup->kbkeys[6]=((workp)works)->tmateButtons[((workp)works)->setup->kbkeysidx[6]];
}
void memKbF7( void *works, int button ) {
	static char *buffer;
	buttonp buttons=((workp)works)->buttons;
	buffer=buttons[button].str1;
	sprintf( buffer, "%s", buttons[((workp)works)->setup->kbkeys[6]-1].name );
	buffer[8]=0;
	buttons[button].activated=135+((workp)works)->setup->kbkeysidx[6]*270.0/((workp)works)->tmateNbuttons;
	((workp)works)->kbaddcallback( works, 6 );
}
void upKbF8( void *works, int button ) {
	((workp)works)->setup->kbkeysidx[7]+=1;
	if( ((workp)works)->setup->kbkeysidx[7] >= ((workp)works)->tmateNbuttons-1 ) {
		((workp)works)->setup->kbkeysidx[7] = ((workp)works)->tmateNbuttons-1;
	}
	((workp)works)->setup->kbkeys[7]=((workp)works)->tmateButtons[((workp)works)->setup->kbkeysidx[7]];
}
void downKbF8( void *works, int button ) {
	((workp)works)->setup->kbkeysidx[7]-=1;
	if( ((workp)works)->setup->kbkeysidx[7] <= 0 ) {
		((workp)works)->setup->kbkeysidx[7] = 0;
	}
	((workp)works)->setup->kbkeys[7]=((workp)works)->tmateButtons[((workp)works)->setup->kbkeysidx[7]];
}
void memKbF8( void *works, int button ) {
	static char *buffer;
	buttonp buttons=((workp)works)->buttons;
	buffer=buttons[button].str1;
	sprintf( buffer, "%s", buttons[((workp)works)->setup->kbkeys[7]-1].name );
	buffer[8]=0;
	buttons[button].activated=135+((workp)works)->setup->kbkeysidx[7]*270.0/((workp)works)->tmateNbuttons;
	((workp)works)->kbaddcallback( works, 7 );
}
void upKbF9( void *works, int button ) {
	((workp)works)->setup->kbkeysidx[8]+=1;
	if( ((workp)works)->setup->kbkeysidx[8] >= ((workp)works)->tmateNbuttons-1 ) {
		((workp)works)->setup->kbkeysidx[8] = ((workp)works)->tmateNbuttons-1;
	}
	((workp)works)->setup->kbkeys[8]=((workp)works)->tmateButtons[((workp)works)->setup->kbkeysidx[8]];
}
void downKbF9( void *works, int button ) {
	((workp)works)->setup->kbkeysidx[8]-=1;
	if( ((workp)works)->setup->kbkeysidx[8] <= 0 ) {
		((workp)works)->setup->kbkeysidx[8] = 0;
	}
	((workp)works)->setup->kbkeys[8]=((workp)works)->tmateButtons[((workp)works)->setup->kbkeysidx[8]];
}
void memKbF9( void *works, int button ) {
	static char *buffer;
	buttonp buttons=((workp)works)->buttons;
	buffer=buttons[button].str1;
	sprintf( buffer, "%s", buttons[((workp)works)->setup->kbkeys[8]-1].name );
	buffer[8]=0;
	buttons[button].activated=135+((workp)works)->setup->kbkeysidx[8]*270.0/((workp)works)->tmateNbuttons;
	((workp)works)->kbaddcallback( works, 8 );
}
void upKbF10( void *works, int button ) {
	((workp)works)->setup->kbkeysidx[9]+=1;
	if( ((workp)works)->setup->kbkeysidx[9] >= ((workp)works)->tmateNbuttons-1 ) {
		((workp)works)->setup->kbkeysidx[9] = ((workp)works)->tmateNbuttons-1;
	}
	((workp)works)->setup->kbkeys[9]=((workp)works)->tmateButtons[((workp)works)->setup->kbkeysidx[9]];
}
void downKbF10( void *works, int button ) {
	((workp)works)->setup->kbkeysidx[9]-=1;
	if( ((workp)works)->setup->kbkeysidx[9] <= 0 ) {
		((workp)works)->setup->kbkeysidx[9] = 0;
	}
	((workp)works)->setup->kbkeys[9]=((workp)works)->tmateButtons[((workp)works)->setup->kbkeysidx[9]];
}
void memKbF10( void *works, int button ) {
	static char *buffer;
	buttonp buttons=((workp)works)->buttons;
	buffer=buttons[button].str1;
	sprintf( buffer, "%s", buttons[((workp)works)->setup->kbkeys[9]-1].name );
	buffer[8]=0;
	buttons[button].activated=135+((workp)works)->setup->kbkeysidx[9]*270.0/((workp)works)->tmateNbuttons;
	((workp)works)->kbaddcallback( works, 9 );
}
void upKbF11( void *works, int button ) {
	((workp)works)->setup->kbkeysidx[10]+=1;
	if( ((workp)works)->setup->kbkeysidx[10] >= ((workp)works)->tmateNbuttons-1 ) {
		((workp)works)->setup->kbkeysidx[10] = ((workp)works)->tmateNbuttons-1;
	}
	((workp)works)->setup->kbkeys[10]=((workp)works)->tmateButtons[((workp)works)->setup->kbkeysidx[10]];
}
void downKbF11( void *works, int button ) {
	((workp)works)->setup->kbkeysidx[10]-=1;
	if( ((workp)works)->setup->kbkeysidx[10] <= 0 ) {
		((workp)works)->setup->kbkeysidx[10] = 0;
	}
	((workp)works)->setup->kbkeys[10]=((workp)works)->tmateButtons[((workp)works)->setup->kbkeysidx[10]];
}
void memKbF11( void *works, int button ) {
	static char *buffer;
	buttonp buttons=((workp)works)->buttons;
	buffer=buttons[button].str1;
	sprintf( buffer, "%s", buttons[((workp)works)->setup->kbkeys[10]-1].name );
	buffer[8]=0;
	buttons[button].activated=135+((workp)works)->setup->kbkeysidx[10]*270.0/((workp)works)->tmateNbuttons;
	((workp)works)->kbaddcallback( works, 10 );
}
void upKbF12( void *works, int button ) {
	((workp)works)->setup->kbkeysidx[11]+=1;
	if( ((workp)works)->setup->kbkeysidx[11] >= ((workp)works)->tmateNbuttons-1 ) {
		((workp)works)->setup->kbkeysidx[11] = ((workp)works)->tmateNbuttons-1;
	}
	((workp)works)->setup->kbkeys[11]=((workp)works)->tmateButtons[((workp)works)->setup->kbkeysidx[11]];
}
void downKbF12( void *works, int button ) {
	((workp)works)->setup->kbkeysidx[11]-=1;
	if( ((workp)works)->setup->kbkeysidx[11] <= 0 ) {
		((workp)works)->setup->kbkeysidx[11] = 0;
	}
	((workp)works)->setup->kbkeys[11]=((workp)works)->tmateButtons[((workp)works)->setup->kbkeysidx[11]];
}
void memKbF12( void *works, int button ) {
	static char *buffer;
	buttonp buttons=((workp)works)->buttons;
	buffer=buttons[button].str1;
	sprintf( buffer, "%s", buttons[((workp)works)->setup->kbkeys[11]-1].name );
	buffer[8]=0;
	buttons[button].activated=135+((workp)works)->setup->kbkeysidx[11]*270.0/((workp)works)->tmateNbuttons;
	((workp)works)->kbaddcallback( works, 11 );
}
void upTmE1( void *works, int button ) {
	((workp)works)->setup->t2keysidx[9]+=1;
	if( ((workp)works)->setup->t2keysidx[9] >= ((workp)works)->tmateNencoders-1 ) {
		((workp)works)->setup->t2keysidx[9] = ((workp)works)->tmateNencoders-1;
	}
	((workp)works)->setup->t2keys[9]=((workp)works)->tmateEncoders[((workp)works)->setup->t2keysidx[9]];
}
void downTmE1( void *works, int button ) {
	((workp)works)->setup->t2keysidx[9]-=1;
	if( ((workp)works)->setup->t2keysidx[9] <= 0 ) {
		((workp)works)->setup->t2keysidx[9] = 0;
	}
	((workp)works)->setup->t2keys[9]=((workp)works)->tmateEncoders[((workp)works)->setup->t2keysidx[9]];
}
void memTmE1( void *works, int button ) {
	static char *buffer;
	buttonp buttons=((workp)works)->buttons;
	buffer=buttons[button].str1;
	sprintf( buffer, "%s", buttons[((workp)works)->setup->t2keys[9]-1].name );
	buffer[8]=0;
	buttons[button].activated=135+((workp)works)->setup->t2keysidx[9]*270.0/((workp)works)->tmateNencoders;
	((workp)works)->tmateaddcallback( works, 9 );
}
void upTmE2( void *works, int button ) {
	((workp)works)->setup->t2keysidx[10]+=1;
	if( ((workp)works)->setup->t2keysidx[10] >= ((workp)works)->tmateNencoders-1 ) {
		((workp)works)->setup->t2keysidx[10] = ((workp)works)->tmateNencoders-1;
	}
	((workp)works)->setup->t2keys[10]=((workp)works)->tmateEncoders[((workp)works)->setup->t2keysidx[10]];
}
void downTmE2( void *works, int button ) {
	((workp)works)->setup->t2keysidx[10]-=1;
	if( ((workp)works)->setup->t2keysidx[10] <= 0 ) {
		((workp)works)->setup->t2keysidx[10] = 0;
	}
	((workp)works)->setup->t2keys[10]=((workp)works)->tmateEncoders[((workp)works)->setup->t2keysidx[10]];
}
void memTmE2( void *works, int button ) {
	static char *buffer;
	buttonp buttons=((workp)works)->buttons;
	buffer=buttons[button].str1;
	sprintf( buffer, "%s", buttons[((workp)works)->setup->t2keys[10]-1].name );
	buffer[8]=0;
	buttons[button].activated=135+((workp)works)->setup->t2keysidx[10]*270.0/((workp)works)->tmateNencoders;
	((workp)works)->tmateaddcallback( works, 10 );
}
void upTmE3( void *works, int button ) {
	((workp)works)->setup->t2keysidx[11]+=1;
	if( ((workp)works)->setup->t2keysidx[11] >= ((workp)works)->tmateNencoders-1 ) {
		((workp)works)->setup->t2keysidx[11] = ((workp)works)->tmateNencoders-1;
	}
	((workp)works)->setup->t2keys[11]=((workp)works)->tmateEncoders[((workp)works)->setup->t2keysidx[11]];
}
void downTmE3( void *works, int button ) {
	((workp)works)->setup->t2keysidx[11]-=1;
	if( ((workp)works)->setup->t2keysidx[11] <= 0 ) {
		((workp)works)->setup->t2keysidx[11] = 0;
	}
	((workp)works)->setup->t2keys[11]=((workp)works)->tmateEncoders[((workp)works)->setup->t2keysidx[11]];
}
void memTmE3( void *works, int button ) {
	static char *buffer;
	buttonp buttons=((workp)works)->buttons;
	buffer=buttons[button].str1;
	sprintf( buffer, "%s", buttons[((workp)works)->setup->t2keys[11]-1].name );
	buffer[8]=0;
	buttons[button].activated=135+((workp)works)->setup->t2keysidx[11]*270.0/((workp)works)->tmateNencoders;
	((workp)works)->tmateaddcallback( works, 11 );
}
void upTmF1( void *works, int button ) {
	((workp)works)->setup->t2keysidx[0]+=1;
	if( ((workp)works)->setup->t2keysidx[0] >= ((workp)works)->tmateNbuttons-1 ) {
		((workp)works)->setup->t2keysidx[0] = ((workp)works)->tmateNbuttons-1;
	}
	((workp)works)->setup->t2keys[0]=((workp)works)->tmateButtons[((workp)works)->setup->t2keysidx[0]];
}
void downTmF1( void *works, int button ) {
	((workp)works)->setup->t2keysidx[0]-=1;
	if( ((workp)works)->setup->t2keysidx[0] <= 0 ) {
		((workp)works)->setup->t2keysidx[0] = 0;
	}
	((workp)works)->setup->t2keys[0]=((workp)works)->tmateButtons[((workp)works)->setup->t2keysidx[0]];
}
void memTmF1( void *works, int button ) {
	static char *buffer;
	buttonp buttons=((workp)works)->buttons;
	buffer=buttons[button].str1;
	sprintf( buffer, "%s", buttons[((workp)works)->setup->t2keys[0]-1].name );
	buffer[8]=0;
	buttons[button].activated=135+((workp)works)->setup->t2keysidx[0]*270.0/((workp)works)->tmateNbuttons;
	((workp)works)->tmateaddcallback( works, 0 );
}
void upTmF2( void *works, int button ) {
	((workp)works)->setup->t2keysidx[1]+=1;
	if( ((workp)works)->setup->t2keysidx[1] >= ((workp)works)->tmateNbuttons-1 ) {
		((workp)works)->setup->t2keysidx[1] = ((workp)works)->tmateNbuttons-1;
	}
	((workp)works)->setup->t2keys[1]=((workp)works)->tmateButtons[((workp)works)->setup->t2keysidx[1]];
}
void downTmF2( void *works, int button ) {
	((workp)works)->setup->t2keysidx[1]-=1;
	if( ((workp)works)->setup->t2keysidx[1] <= 0 ) {
		((workp)works)->setup->t2keysidx[1] = 0;
	}
	((workp)works)->setup->t2keys[1]=((workp)works)->tmateButtons[((workp)works)->setup->t2keysidx[1]];
}
void memTmF2( void *works, int button ) {
	static char *buffer;
	buttonp buttons=((workp)works)->buttons;
	buffer=buttons[button].str1;
	sprintf( buffer, "%s", buttons[((workp)works)->setup->t2keys[1]-1].name );
	buffer[8]=0;
	buttons[button].activated=135+((workp)works)->setup->t2keysidx[1]*270.0/((workp)works)->tmateNbuttons;
	((workp)works)->tmateaddcallback( works, 1 );
}
void upTmF3( void *works, int button ) {
	((workp)works)->setup->t2keysidx[2]+=1;
	if( ((workp)works)->setup->t2keysidx[2] >= ((workp)works)->tmateNbuttons-1 ) {
		((workp)works)->setup->t2keysidx[2] = ((workp)works)->tmateNbuttons-1;
	}
	((workp)works)->setup->t2keys[2]=((workp)works)->tmateButtons[((workp)works)->setup->t2keysidx[2]];
}
void downTmF3( void *works, int button ) {
	((workp)works)->setup->t2keysidx[2]-=1;
	if( ((workp)works)->setup->t2keysidx[2] <= 0 ) {
		((workp)works)->setup->t2keysidx[2] = 0;
	}
	((workp)works)->setup->t2keys[2]=((workp)works)->tmateButtons[((workp)works)->setup->t2keysidx[2]];
}
void memTmF3( void *works, int button ) {
	static char *buffer;
	buttonp buttons=((workp)works)->buttons;
	buffer=buttons[button].str1;
	sprintf( buffer, "%s", buttons[((workp)works)->setup->t2keys[2]-1].name );
	buffer[8]=0;
	buttons[button].activated=135+((workp)works)->setup->t2keysidx[2]*270.0/((workp)works)->tmateNbuttons;
	((workp)works)->tmateaddcallback( works, 2 );
}
void upTmF4( void *works, int button ) {
	((workp)works)->setup->t2keysidx[3]+=1;
	if( ((workp)works)->setup->t2keysidx[3] >= ((workp)works)->tmateNbuttons-1 ) {
		((workp)works)->setup->t2keysidx[3] = ((workp)works)->tmateNbuttons-1;
	}
	((workp)works)->setup->t2keys[3]=((workp)works)->tmateButtons[((workp)works)->setup->t2keysidx[3]];
}
void downTmF4( void *works, int button ) {
	((workp)works)->setup->t2keysidx[3]-=1;
	if( ((workp)works)->setup->t2keysidx[3] <= 0 ) {
		((workp)works)->setup->t2keysidx[3] = 0;
	}
	((workp)works)->setup->t2keys[3]=((workp)works)->tmateButtons[((workp)works)->setup->t2keysidx[3]];
}
void memTmF4( void *works, int button ) {
	static char *buffer;
	buttonp buttons=((workp)works)->buttons;
	buffer=buttons[button].str1;
	sprintf( buffer, "%s", buttons[((workp)works)->setup->t2keys[3]-1].name );
	buffer[8]=0;
	buttons[button].activated=135+((workp)works)->setup->t2keysidx[3]*270.0/((workp)works)->tmateNbuttons;
	((workp)works)->tmateaddcallback( works, 3 );
}
void upTmF5( void *works, int button ) {
	((workp)works)->setup->t2keysidx[4]+=1;
	if( ((workp)works)->setup->t2keysidx[4] >= ((workp)works)->tmateNbuttons-1 ) {
		((workp)works)->setup->t2keysidx[4] = ((workp)works)->tmateNbuttons-1;
	}
	((workp)works)->setup->t2keys[4]=((workp)works)->tmateButtons[((workp)works)->setup->t2keysidx[4]];
}
void downTmF5( void *works, int button ) {
	((workp)works)->setup->t2keysidx[4]-=1;
	if( ((workp)works)->setup->t2keysidx[4] <= 0 ) {
		((workp)works)->setup->t2keysidx[4] = 0;
	}
	((workp)works)->setup->t2keys[4]=((workp)works)->tmateButtons[((workp)works)->setup->t2keysidx[4]];
}
void memTmF5( void *works, int button ) {
	static char *buffer;
	buttonp buttons=((workp)works)->buttons;
	buffer=buttons[button].str1;
	sprintf( buffer, "%s", buttons[((workp)works)->setup->t2keys[4]-1].name );
	buffer[8]=0;
	buttons[button].activated=135+((workp)works)->setup->t2keysidx[4]*270.0/((workp)works)->tmateNbuttons;
	((workp)works)->tmateaddcallback( works, 4 );
}
void upTmF6( void *works, int button ) {
	((workp)works)->setup->t2keysidx[5]+=1;
	if( ((workp)works)->setup->t2keysidx[5] >= ((workp)works)->tmateNbuttons-1 ) {
		((workp)works)->setup->t2keysidx[5] = ((workp)works)->tmateNbuttons-1;
	}
	((workp)works)->setup->t2keys[5]=((workp)works)->tmateButtons[((workp)works)->setup->t2keysidx[5]];
}
void downTmF6( void *works, int button ) {
	((workp)works)->setup->t2keysidx[5]-=1;
	if( ((workp)works)->setup->t2keysidx[5] <= 0 ) {
		((workp)works)->setup->t2keysidx[5] = 0;
	}
	((workp)works)->setup->t2keys[5]=((workp)works)->tmateButtons[((workp)works)->setup->t2keysidx[5]];
}
void memTmF6( void *works, int button ) {
	static char *buffer;
	buttonp buttons=((workp)works)->buttons;
	buffer=buttons[button].str1;
	sprintf( buffer, "%s", buttons[((workp)works)->setup->t2keys[5]-1].name );
	buffer[8]=0;
	buttons[button].activated=135+((workp)works)->setup->t2keysidx[5]*270.0/((workp)works)->tmateNbuttons;
	((workp)works)->tmateaddcallback( works, 5 );
}
void upTmF7( void *works, int button ) {
	((workp)works)->setup->t2keysidx[6]+=1;
	if( ((workp)works)->setup->t2keysidx[6] >= ((workp)works)->tmateNbuttons-1 ) {
		((workp)works)->setup->t2keysidx[6] = ((workp)works)->tmateNbuttons-1;
	}
	((workp)works)->setup->t2keys[6]=((workp)works)->tmateButtons[((workp)works)->setup->t2keysidx[6]];
}
void downTmF7( void *works, int button ) {
	((workp)works)->setup->t2keysidx[6]-=1;
	if( ((workp)works)->setup->t2keysidx[6] <= 0 ) {
		((workp)works)->setup->t2keysidx[6] = 0;
	}
	((workp)works)->setup->t2keys[6]=((workp)works)->tmateButtons[((workp)works)->setup->t2keysidx[6]];
}
void memTmF7( void *works, int button ) {
	static char *buffer;
	buttonp buttons=((workp)works)->buttons;
	buffer=buttons[button].str1;
	sprintf( buffer, "%s", buttons[((workp)works)->setup->t2keys[6]-1].name );
	buffer[8]=0;
	buttons[button].activated=135+((workp)works)->setup->t2keysidx[6]*270.0/((workp)works)->tmateNbuttons;
	((workp)works)->tmateaddcallback( works, 6 );
}
void upTmF8( void *works, int button ) {
	((workp)works)->setup->t2keysidx[7]+=1;
	if( ((workp)works)->setup->t2keysidx[7] >= ((workp)works)->tmateNbuttons-1 ) {
		((workp)works)->setup->t2keysidx[7] = ((workp)works)->tmateNbuttons-1;
	}
	((workp)works)->setup->t2keys[7]=((workp)works)->tmateButtons[((workp)works)->setup->t2keysidx[7]];
}
void downTmF8( void *works, int button ) {
	((workp)works)->setup->t2keysidx[7]-=1;
	if( ((workp)works)->setup->t2keysidx[7] <= 0 ) {
		((workp)works)->setup->t2keysidx[7] = 0;
	}
	((workp)works)->setup->t2keys[7]=((workp)works)->tmateButtons[((workp)works)->setup->t2keysidx[7]];
}
void memTmF8( void *works, int button ) {
	static char *buffer;
	buttonp buttons=((workp)works)->buttons;
	buffer=buttons[button].str1;
	sprintf( buffer, "%s", buttons[((workp)works)->setup->t2keys[7]-1].name );
	buffer[8]=0;
	buttons[button].activated=135+((workp)works)->setup->t2keysidx[7]*270.0/((workp)works)->tmateNbuttons;
	((workp)works)->tmateaddcallback( works, 7 );
}
void upTmF9( void *works, int button ) {
	((workp)works)->setup->t2keysidx[8]+=1;
	if( ((workp)works)->setup->t2keysidx[8] >= ((workp)works)->tmateNbuttons-1 ) {
		((workp)works)->setup->t2keysidx[8] = ((workp)works)->tmateNbuttons-1;
	}
	((workp)works)->setup->t2keys[8]=((workp)works)->tmateButtons[((workp)works)->setup->t2keysidx[8]];
}
void downTmF9( void *works, int button ) {
	((workp)works)->setup->t2keysidx[8]-=1;
	if( ((workp)works)->setup->t2keysidx[8] <= 0 ) {
		((workp)works)->setup->t2keysidx[8] = 0;
	}
	((workp)works)->setup->t2keys[8]=((workp)works)->tmateButtons[((workp)works)->setup->t2keysidx[8]];
}
void memTmF9( void *works, int button ) {
	static char *buffer;
	buttonp buttons=((workp)works)->buttons;
	buffer=buttons[button].str1;
	sprintf( buffer, "%s", buttons[((workp)works)->setup->t2keys[8]-1].name );
	buffer[8]=0;
	buttons[button].activated=135+((workp)works)->setup->t2keysidx[8]*270.0/((workp)works)->tmateNbuttons;
	((workp)works)->tmateaddcallback( works, 8 );
}
void upTmRxR( void *works, int button ) {
	((workp)works)->setup->rxcolor[0]+=1;
	if( ((workp)works)->setup->rxcolor[0] >= 254 ) {
		((workp)works)->setup->rxcolor[0] = 254;
	}
}
void downTmRxR( void *works, int button ) {
	((workp)works)->setup->rxcolor[0]-=1;
	if( ((workp)works)->setup->rxcolor[0] <= 1 ) {
		((workp)works)->setup->rxcolor[0] = 1;
	}
}
void memTmRxR( void *works, int button ) {
	static char *buffer;
	buttonp buttons=((workp)works)->buttons;
	buffer=buttons[button].str1;
	sprintf( buffer, "0X%02X", ((workp)works)->setup->rxcolor[0] );
	buttons[button].activated=127+((workp)works)->setup->rxcolor[0];
}
void upTmRxG( void *works, int button ) {
	((workp)works)->setup->rxcolor[1]+=1;
	if( ((workp)works)->setup->rxcolor[1] >= 254 ) {
		((workp)works)->setup->rxcolor[1] = 254;
	}
}
void downTmRxG( void *works, int button ) {
	((workp)works)->setup->rxcolor[1]-=1;
	if( ((workp)works)->setup->rxcolor[1] <= 1 ) {
		((workp)works)->setup->rxcolor[1] = 1;
	}
}
void memTmRxG( void *works, int button ) {
	static char *buffer;
	buttonp buttons=((workp)works)->buttons;
	buffer=buttons[button].str1;
	sprintf( buffer, "0X%02X", ((workp)works)->setup->rxcolor[1] );
	buttons[button].activated=127+((workp)works)->setup->rxcolor[1];
}
void upTmRxB( void *works, int button ) {
	((workp)works)->setup->rxcolor[2]+=1;
	if( ((workp)works)->setup->rxcolor[2] >= 254 ) {
		((workp)works)->setup->rxcolor[2] = 254;
	}
}
void downTmRxB( void *works, int button ) {
	((workp)works)->setup->rxcolor[2]-=1;
	if( ((workp)works)->setup->rxcolor[2] <= 1 ) {
		((workp)works)->setup->rxcolor[2] = 1;
	}
}
void memTmRxB( void *works, int button ) {
	static char *buffer;
	buttonp buttons=((workp)works)->buttons;
	buffer=buttons[button].str1;
	sprintf( buffer, "0X%02X", ((workp)works)->setup->rxcolor[2] );
	buttons[button].activated=127+((workp)works)->setup->rxcolor[2];
}
void upTmTxR( void *works, int button ) {
	((workp)works)->setup->txcolor[0]+=1;
	if( ((workp)works)->setup->txcolor[0] >= 254 ) {
		((workp)works)->setup->txcolor[0] = 254;
	}
}
void downTmTxR( void *works, int button ) {
	((workp)works)->setup->txcolor[0]-=1;
	if( ((workp)works)->setup->txcolor[0] <= 1 ) {
		((workp)works)->setup->txcolor[0] = 1;
	}
}
void memTmTxR( void *works, int button ) {
	static char *buffer;
	buttonp buttons=((workp)works)->buttons;
	buffer=buttons[button].str1;
	sprintf( buffer, "0X%02X", ((workp)works)->setup->txcolor[0] );
	buttons[button].activated=127+((workp)works)->setup->txcolor[0];
}
void upTmTxG( void *works, int button ) {
	((workp)works)->setup->txcolor[1]+=1;
	if( ((workp)works)->setup->txcolor[1] >= 254 ) {
		((workp)works)->setup->txcolor[1] = 254;
	}
}
void downTmTxG( void *works, int button ) {
	((workp)works)->setup->txcolor[1]-=1;
	if( ((workp)works)->setup->txcolor[1] <= 1 ) {
		((workp)works)->setup->txcolor[1] = 1;
	}
}
void memTmTxG( void *works, int button ) {
	static char *buffer;
	buttonp buttons=((workp)works)->buttons;
	buffer=buttons[button].str1;
	sprintf( buffer, "0X%02X", ((workp)works)->setup->txcolor[1] );
	buttons[button].activated=127+((workp)works)->setup->txcolor[1];
}
void upTmTxB( void *works, int button ) {
	((workp)works)->setup->txcolor[2]+=1;
	if( ((workp)works)->setup->txcolor[2] >= 254 ) {
		((workp)works)->setup->txcolor[2] = 254;
	}
}
void downTmTxB( void *works, int button ) {
	((workp)works)->setup->txcolor[2]-=1;
	if( ((workp)works)->setup->txcolor[2] <= 1 ) {
		((workp)works)->setup->txcolor[2] = 1;
	}
}
void memTmTxB( void *works, int button ) {
	static char *buffer;
	buttonp buttons=((workp)works)->buttons;
	buffer=buttons[button].str1;
	sprintf( buffer, "0X%02X", ((workp)works)->setup->txcolor[2] );
	buttons[button].activated=127+((workp)works)->setup->txcolor[2];
}
void upRxChunk( void *works, int button ) {
	((workp)works)->RxChunk+=1;
	if( ((workp)works)->RxChunk >= 4 ) {
		((workp)works)->RxChunk = 4;
	}
	if( ((workp)works)->rxcompress == 0 ) {
		if( ((workp)works)->RxChunk >= 2 ) {
			((workp)works)->RxChunk = 2;
		}
	}
	setRTxChunk( works, button );
}
void downRxChunk( void *works, int button ) {
	((workp)works)->RxChunk-=1;
	if( ((workp)works)->RxChunk <= 0 ) {
		((workp)works)->RxChunk = 0;
	}
	if( ((workp)works)->rxcompress != 0 ) {
		if( ((workp)works)->RxChunk <= 1 ) {
			((workp)works)->RxChunk = 1;
		}
	}
	setRTxChunk( works, button );
}
void memRxChunk( void *works, int button ) {
	int j, mode;
	static char *buffer;
	buttonp buttons=((workp)works)->buttons;
	for( j=0; j<5; j++ ) {
		if( ((workp)works)->strings->nchunk[j]>=((workp)works)->setup->rxChunkTime ) {
			mode = ((workp)works)->RxChunk = j;
			break;
		}
	}
	buffer=buttons[button].str1;
	strcpy( buffer, ((workp)works)->strings->schunk[mode] );
	buttons[button].activated=136+mode*67;
}
void setRTxCompr( void *works, int button ) {
        ((workp)works)->rxcompress=((workp)works)->strings->ncompress[((workp)works)->RxCompr];
        ((workp)works)->txcompress=((workp)works)->strings->ncompress[((workp)works)->TxCompr];
	buildConfig( works );
}
void upRxCompr( void *works, int button ) {
	((workp)works)->RxCompr+=1;
	if( ((workp)works)->RxCompr >= 12 ) {
		((workp)works)->RxCompr = 12;
	}
	if( ((workp)works)->RxCompr == 0 ) {
		if( ((workp)works)->RxChunk > 2 ) {
			((workp)works)->RxChunk = 2;
			((workp)works)->setup->rxChunkTime=((workp)works)->strings->nchunk[((workp)works)->RxChunk];
			((workp)works)->bufferingChanged = 1;
		}
	}
	if( ((workp)works)->RxCompr != 0 ) {
		if( ((workp)works)->RxChunk < 1 ) {
			((workp)works)->RxChunk = 1;
			((workp)works)->setup->rxChunkTime=((workp)works)->strings->nchunk[((workp)works)->RxChunk];
			((workp)works)->bufferingChanged = 1;
		}
	}
	setRTxChunk( works, button );
	setRTxCompr( works, button );
}
void downRxCompr( void *works, int button ) {
	((workp)works)->RxCompr-=1;
	if( ((workp)works)->RxCompr <= 0 ) {
		((workp)works)->RxCompr = 0;
	}
	if( ((workp)works)->RxCompr == 0 ) {
		if( ((workp)works)->RxChunk > 2 ) {
			((workp)works)->RxChunk = 2;
			((workp)works)->setup->rxChunkTime=((workp)works)->strings->nchunk[((workp)works)->RxChunk];
			((workp)works)->bufferingChanged = 1;
		}
	}
	if( ((workp)works)->RxCompr != 0 ) {
		if( ((workp)works)->RxChunk < 1 ) {
			((workp)works)->RxChunk = 1;
			((workp)works)->setup->rxChunkTime=((workp)works)->strings->nchunk[((workp)works)->RxChunk];
			((workp)works)->bufferingChanged = 1;
		}
	}
	setRTxChunk( works, button );
	setRTxCompr( works, button );
}
void memRxCompr( void *works, int button ) {
	int j, mode;
	static char *buffer;
	buttonp buttons=((workp)works)->buttons;
	for( j=0; j<13; j++ ) {
		if( ((workp)works)->strings->ncompress[j]>=((workp)works)->rxcompress ) {
			mode = ((workp)works)->RxCompr = j;
			break;
		}
	}
	buffer=buttons[button].str1;
	strcpy( buffer, ((workp)works)->strings->scompress[mode] );
	buttons[button].activated=137+mode*22;
}
void upTxCompr( void *works, int button ) {
	((workp)works)->TxCompr+=1;
	if( ((workp)works)->TxCompr >= 12 ) {
		((workp)works)->TxCompr = 12;
	}
	if( ((workp)works)->TxCompr == 0 ) {
		if( ((workp)works)->TxChunk >= 2 ) {
			((workp)works)->TxChunk = 2;
			((workp)works)->setup->txChunkTime=((workp)works)->strings->nchunk[((workp)works)->TxChunk];
		}
	}
	if( ((workp)works)->TxCompr != 0 ) {
		if( ((workp)works)->TxChunk <= 1 ) {
			((workp)works)->TxChunk = 1;
			((workp)works)->setup->txChunkTime=((workp)works)->strings->nchunk[((workp)works)->TxChunk];
		}
	}
	setRTxChunk( works, button );
	setRTxCompr( works, button );
}
void downTxCompr( void *works, int button ) {
	((workp)works)->TxCompr-=1;
	if( ((workp)works)->TxCompr <= 0 ) {
		((workp)works)->TxCompr = 0;
	}
	if( ((workp)works)->TxCompr == 0 ) {
		if( ((workp)works)->TxChunk >= 2 ) {
			((workp)works)->TxChunk = 2;
			((workp)works)->setup->txChunkTime=((workp)works)->strings->nchunk[((workp)works)->TxChunk];
		}
	}
	if( ((workp)works)->TxCompr != 0 ) {
		if( ((workp)works)->TxChunk <= 1 ) {
			((workp)works)->TxChunk = 1;
			((workp)works)->setup->txChunkTime=((workp)works)->strings->nchunk[((workp)works)->TxChunk];
		}
	}
	setRTxCompr( works, button );
}
void memTxCompr( void *works, int button ) {
	int j, mode;
	static char *buffer;
	buttonp buttons=((workp)works)->buttons;
	for( j=0; j<13; j++ ) {
		if( ((workp)works)->strings->ncompress[j]>=((workp)works)->txcompress ) {
			mode = ((workp)works)->TxCompr = j;
			break;
		}
	}
	buffer=buttons[button].str1;
	strcpy( buffer, ((workp)works)->strings->scompress[mode] );
	buttons[button].activated=137+mode*22;
}
void setTXBW( void *works, int button ) {
	sprintf( CATbuf, "TB0%02d;", ((workp)works)->TXBW );
	sendWebSockCatFrame( works, CATbuf, strlen(CATbuf) );
}
void upTXBW( void *works, int button ) {
	((workp)works)->TXBW+=1;
	if( ((workp)works)->TXBW >= 12 ) {
		((workp)works)->TXBW = 12;
	}
	setTXBW( works, button );
}
void downTXBW( void *works, int button ) {
	((workp)works)->TXBW-=1;
	if( ((workp)works)->TXBW <= 0 ) {
		((workp)works)->TXBW = 0;
	}
	setTXBW( works, button );
}
void getTXBW( void *works, int button ) {
	static struct timeval mytime;
	struct timeval now;
	static int isFirst=1;
	gettimeofday(&now , NULL );
	if( isFirst ) {
		isFirst=0;
		gettimeofday(&mytime , NULL );
	} else {
		if( mytime.tv_sec > now.tv_sec-5 ) {
			return;
		}
	}
	gettimeofday(&mytime , NULL );
	sprintf( CATbuf, "TB0;" );
	sendWebSockCatFrame( works, CATbuf, strlen(CATbuf) );
}
void memTXBW( void *works, int button ) {
	static char *buffer;
	buttonp buttons=((workp)works)->buttons;
	int mode = ((workp)works)->TXBW;
	buffer=buttons[button].str1;
	strcpy( buffer, ((workp)works)->strings->decodeTXBW[mode] );
	buttons[button].activated=135+mode*25;
}
void setTXPwr( void *works, int button ) {
	sprintf( CATbuf, "TQ%04d;", ((workp)works)->TXPwr==5100?0:((workp)works)->TXPwr);
	sendWebSockCatFrame( works, CATbuf, strlen(CATbuf) );
}
void upTXPwr( void *works, int button ) {
	((workp)works)->TXPwr+=100;
	if( ((workp)works)->TXPwr >= 5100 ) {
		((workp)works)->TXPwr = 5100;
	}
	setTXPwr( works, button );
}
void downTXPwr( void *works, int button ) {
	((workp)works)->TXPwr-=100;
	if( ((workp)works)->TXPwr <= 100 ) {
		((workp)works)->TXPwr = 100;
	}
	setTXPwr( works, button );
}
void getTXPwr( void *works, int button ) {
	static struct timeval mytime;
	struct timeval now;
	static int isFirst=1;
	gettimeofday(&now , NULL );
	if( isFirst ) {
		isFirst=0;
		gettimeofday(&mytime , NULL );
	} else {
		if( mytime.tv_sec > now.tv_sec-5 ) {
			return;
		}
	}
	gettimeofday(&mytime , NULL );
	sprintf( CATbuf, "TQ;" );
	sendWebSockCatFrame( works, CATbuf, strlen(CATbuf) );
}
void memTXPwr( void *works, int button ) {
	static char *buffer;
	buttonp buttons=((workp)works)->buttons;
	int mode = ((workp)works)->TXPwr;
	buffer=buttons[button].str1;
	if( mode==5100 ) {
		sprintf( buffer, "%s", ((workp)works)->strings->messages[19] );
	} else {
		sprintf( buffer, "%d %s", mode, ((workp)works)->strings->messages[20] );
	}
	buttons[button].activated=140+mode/20;
}
void setTuPwr( void *works, int button ) {
	sprintf( CATbuf, "TL%02d;", ((workp)works)->TuPwr );
	sendWebSockCatFrame( works, CATbuf, strlen(CATbuf) );
}
void upTuPwr( void *works, int button ) {
	((workp)works)->TuPwr+=1;
	if( ((workp)works)->TuPwr >= 9 ) {
		((workp)works)->TuPwr = 9;
	}
	setTuPwr( works, button );
}
void downTuPwr( void *works, int button ) {
	((workp)works)->TuPwr-=1;
	if( ((workp)works)->TuPwr <= 0 ) {
		((workp)works)->TuPwr = 0;
	}
	setTuPwr( works, button );
}
void getTuPwr( void *works, int button ) {
	static struct timeval mytime;
	struct timeval now;
	static int isFirst=1;
	gettimeofday(&now , NULL );
	if( isFirst ) {
		isFirst=0;
		gettimeofday(&mytime , NULL );
	} else {
		if( mytime.tv_sec > now.tv_sec-5 ) {
			return;
		}
	}
	gettimeofday(&mytime , NULL );
	sprintf( CATbuf, "TL;" );
	sendWebSockCatFrame( works, CATbuf, strlen(CATbuf) );
}
void memTuPwr( void *works, int button ) {
	static char *buffer;
	buttonp buttons=((workp)works)->buttons;
	int mode = ((workp)works)->TuPwr;
	buffer=buttons[button].str1;
	strcpy( buffer, ((workp)works)->strings->decodePwr[mode] );
	buttons[button].activated=135+mode*30;
}
void setTXOut( void *works, int button ) {
	int mode = ((workp)works)->TXOut;
	if( mode ==1 ) {
		mode=0;
	} else {
		mode=1;
	}
	sprintf( CATbuf, "TT%1d;TT;", mode );
	sendWebSockCatFrame( works, CATbuf, strlen(CATbuf) );
}
void getTXOut( void *works, int button ) {
	static struct timeval mytime;
	struct timeval now;
	static int isFirst=1;
	int mode = ((workp)works)->TXOut;
	buttonp buttons=((workp)works)->buttons;
	gettimeofday(&now , NULL );
	if( isFirst ) {
		isFirst=0;
		gettimeofday(&mytime , NULL );
	} else {
		if( mytime.tv_sec > now.tv_sec-5 ) {
			buttons[button].activated=mode+1;
			buttons[button].decode=((workp)works)->strings->decodeTXOut;
			return;
		}
	}
	gettimeofday(&mytime , NULL );
	sprintf( CATbuf, "TT;" );
	sendWebSockCatFrame( works, CATbuf, strlen(CATbuf) );
}
void setTXIn( void *works, int button ) {
	sprintf( CATbuf, "TI%1d;", ((workp)works)->TXIn );
	sendWebSockCatFrame( works, CATbuf, strlen(CATbuf) );
}
void upTXIn( void *works, int button ) {
	((workp)works)->TXIn+=1;
	if( ((workp)works)->TXIn >= 2 ) {
		((workp)works)->TXIn = 2;
	}
	setTXIn( works, button );
}
void downTXIn( void *works, int button ) {
	((workp)works)->TXIn-=1;
	if( ((workp)works)->TXIn <= 0 ) {
		((workp)works)->TXIn = 0;
	}
	setTXIn( works, button );
}
void getTXIn( void *works, int button ) {
	static struct timeval mytime;
	struct timeval now;
	static int isFirst=1;
	gettimeofday(&now , NULL );
	if( isFirst ) {
		isFirst=0;
		gettimeofday(&mytime , NULL );
	} else {
		if( mytime.tv_sec > now.tv_sec-5 ) {
			return;
		}
	}
	gettimeofday(&mytime , NULL );
	sprintf( CATbuf, "TI;" );
	sendWebSockCatFrame( works, CATbuf, strlen(CATbuf) );
}
void memTXIn( void *works, int button ) {
	static char *buffer;
	buttonp buttons=((workp)works)->buttons;
	int mode = ((workp)works)->TXIn;
	buffer=buttons[button].str1;
	strcpy( buffer, ((workp)works)->strings->decodeTXIn[mode] );
	buttons[button].activated=180+mode*90;
}
void setDebug( void *works, int button ) {
        ((workp)works)->setup->hwdebug=1-((workp)works)->setup->hwdebug;
}
void getDebug( void *works, int button ) {
	int mode=((workp)works)->setup->hwdebug>0?1:0;
	buttonp buttons=((workp)works)->buttons;
	buttons[button].activated=mode+1;
	buttons[button].decode=((workp)works)->strings->decodeDebug;
}

void setTXEna( void *works, int button ) {
	int mode = ((workp)works)->TXEna;
	if( mode <=0 ) {
		mode =1;
	} else {
		mode=0;
	}
	sprintf( CATbuf, "TE%1d;TE;", mode );
	sendWebSockCatFrame( works, CATbuf, strlen(CATbuf) );
}
void getTXEna( void *works, int button ) {
	static struct timeval mytime;
	struct timeval now;
	static int isFirst=1;
	buttonp buttons=((workp)works)->buttons;
	gettimeofday(&now , NULL );
	if( isFirst ) {
		isFirst=0;
		gettimeofday(&mytime , NULL );
	} else {
		if( mytime.tv_sec > now.tv_sec-5 ) {
			buttons[button].activated=((workp)works)->TXEna;
			return;
		}
	}
	gettimeofday(&mytime , NULL );
	sprintf( CATbuf, "TE;" );
	sendWebSockCatFrame( works, CATbuf, strlen(CATbuf) );
}
void setOffset( void *works, int button ) {
	int mode = ((workp)works)->Offset;
	if( mode <=0 ) {
		mode =1;
	} else {
		mode=0;
	}
	sprintf( CATbuf, "OS%1d;OS;", mode );
	sendWebSockCatFrame( works, CATbuf, strlen(CATbuf) );
}
void getOffset( void *works, int button ) {
	static struct timeval mytime;
	struct timeval now;
	static int isFirst=1;
	buttonp buttons=((workp)works)->buttons;
	gettimeofday(&now , NULL );
	if( isFirst ) {
		isFirst=0;
		gettimeofday(&mytime , NULL );
	} else {
		if( mytime.tv_sec > now.tv_sec-5 ) {
			buttons[button].activated=((workp)works)->Offset;
			return;
		}
	}
	gettimeofday(&mytime , NULL );
	sprintf( CATbuf, "OS;" );
	sendWebSockCatFrame( works, CATbuf, strlen(CATbuf) );
}
void setCWMut( void *works, int button ) {
	int mode = ((workp)works)->CWMut;
	if( mode ==1 ) {
		mode=0;
	} else {
		mode=1;
	}
	sprintf( CATbuf, "MT%1d%1d;MT;", mode, ((workp)works)->SSBMu );
	sendWebSockCatFrame( works, CATbuf, strlen(CATbuf) );
}
void getCWMut( void *works, int button ) {
	static struct timeval mytime;
	struct timeval now;
	static int isFirst=1;
	int mode = ((workp)works)->CWMut;
	buttonp buttons=((workp)works)->buttons;
	gettimeofday(&now , NULL );
	if( isFirst ) {
		isFirst=0;
		gettimeofday(&mytime , NULL );
	} else {
		if( mytime.tv_sec > now.tv_sec-5 ) {
			buttons[button].activated=mode+1;
			buttons[button].decode=((workp)works)->strings->decodeMute;
			return;
		}
	}
	gettimeofday(&mytime , NULL );
	sprintf( CATbuf, "MT;" );
	sendWebSockCatFrame( works, CATbuf, strlen(CATbuf) );
}
void setSSBMu( void *works, int button ) {
	int mode = ((workp)works)->SSBMu;
	if( mode ==1 ) {
		mode=0;
	} else {
		mode=1;
	}
	sprintf( CATbuf, "MT%1d%1d;MT;", ((workp)works)->CWMut, mode );
	sendWebSockCatFrame( works, CATbuf, strlen(CATbuf) );
}
void getSSBMu( void *works, int button ) {
	static struct timeval mytime;
	struct timeval now;
	static int isFirst=1;
	int mode = ((workp)works)->SSBMu;
	buttonp buttons=((workp)works)->buttons;
	gettimeofday(&now , NULL );
	if( isFirst ) {
		isFirst=0;
		gettimeofday(&mytime , NULL );
	} else {
		if( mytime.tv_sec > now.tv_sec-5 ) {
			buttons[button].activated=mode+1;
			buttons[button].decode=((workp)works)->strings->decodeMute;
			return;
		}
	}
	gettimeofday(&mytime , NULL );
	sprintf( CATbuf, "MT;" );
	sendWebSockCatFrame( works, CATbuf, strlen(CATbuf) );
}
void setKePad( void *works, int button ) {
	int mode = ((workp)works)->KePad;
	if( mode ==1 ) {
		mode=0;
	} else {
		mode=1;
	}
	sprintf( CATbuf, "CI%01d;CI;", mode );
	sendWebSockCatFrame( works, CATbuf, strlen(CATbuf) );
}
void getKePad( void *works, int button ) {
	static struct timeval mytime;
	struct timeval now;
	static int isFirst=1;
	int mode = ((workp)works)->KePad;
	buttonp buttons=((workp)works)->buttons;
	gettimeofday(&now , NULL );
	if( isFirst ) {
		isFirst=0;
		gettimeofday(&mytime , NULL );
	} else {
		if( mytime.tv_sec > now.tv_sec-5 ) {
			buttons[button].activated=mode+1;
			buttons[button].decode=((workp)works)->strings->decodeKePad;
			return;
		}
	}
	gettimeofday(&mytime , NULL );
	sprintf( CATbuf, "CI;" );
	sendWebSockCatFrame( works, CATbuf, strlen(CATbuf) );
}
void setFMdev( void *works, int button ) {
	int mode = ((workp)works)->FMdev;
	if( mode ==1 ) {
		mode=0;
	} else {
		mode=1;
	}
	sprintf( CATbuf, "FD%02d;FD;", mode );
	sendWebSockCatFrame( works, CATbuf, strlen(CATbuf) );
}
void getFMdev( void *works, int button ) {
	static struct timeval mytime;
	struct timeval now;
	static int isFirst=1;
	int mode = ((workp)works)->FMdev;
	buttonp buttons=((workp)works)->buttons;
	gettimeofday(&now , NULL );
	if( isFirst ) {
		isFirst=0;
		gettimeofday(&mytime , NULL );
	} else {
		if( mytime.tv_sec > now.tv_sec-5 ) {
			buttons[button].activated=mode+1;
			buttons[button].decode=((workp)works)->strings->decodeFMdev;
			return;
		}
	}
	gettimeofday(&mytime , NULL );
	sprintf( CATbuf, "FD;" );
	sendWebSockCatFrame( works, CATbuf, strlen(CATbuf) );
}
void setTuTO( void *works, int button ) {
	sprintf( CATbuf, "TU%03d;", ((workp)works)->TuTO );
	sendWebSockCatFrame( works, CATbuf, strlen(CATbuf) );
}
void upTuTO( void *works, int button ) {
	((workp)works)->TuTO+=5;
	if( ((workp)works)->TuTO == 8 ) {
		((workp)works)->TuTO = 5;
	}
	if( ((workp)works)->TuTO >= 120 ) {
		((workp)works)->TuTO = 120;
	}
	setTuTO( works, button );
}
void downTuTO( void *works, int button ) {
	((workp)works)->TuTO-=5;
	if( ((workp)works)->TuTO <= 3 ) {
		((workp)works)->TuTO = 3;
	}
	setTuTO( works, button );
}
void getTuTO( void *works, int button ) {
	static struct timeval mytime;
	struct timeval now;
	static int isFirst=1;
	gettimeofday(&now , NULL );
	if( isFirst ) {
		isFirst=0;
		gettimeofday(&mytime , NULL );
	} else {
		if( mytime.tv_sec > now.tv_sec-5 ) {
			return;
		}
	}
	gettimeofday(&mytime , NULL );
	sprintf( CATbuf, "TU;" );
	sendWebSockCatFrame( works, CATbuf, strlen(CATbuf) );
}
void memTuTO( void *works, int button ) {
	static char *buffer;
	buttonp buttons=((workp)works)->buttons;
	int mode = ((workp)works)->TuTO;
	buffer=buttons[button].str1;
	buttons[button].activated=100+mode*2.83;
	sprintf( buffer, "%d %s", mode, ((workp)works)->strings->messages[21] );
}
void setNThre( void *works, int button ) {
	sprintf( CATbuf, "MT0%03d;", ((workp)works)->NThre );
	sendWebSockCatFrame( works, CATbuf, strlen(CATbuf) );
}
void upNThre( void *works, int button ) {
	((workp)works)->NThre+=1;
	if( ((workp)works)->NThre >= 10 ) {
		((workp)works)->NThre = 10;
	}
	setNThre( works, button );
}
void downNThre( void *works, int button ) {
	((workp)works)->NThre-=1;
	if( ((workp)works)->NThre <= 0 ) {
		((workp)works)->NThre = 0;
	}
	setNThre( works, button );
}
void getNThre( void *works, int button ) {
	static struct timeval mytime;
	struct timeval now;
	static int isFirst=1;
	gettimeofday(&now , NULL );
	if( isFirst ) {
		isFirst=0;
		gettimeofday(&mytime , NULL );
	} else {
		if( mytime.tv_sec > now.tv_sec-5 ) {
			return;
		}
	}
	gettimeofday(&mytime , NULL );
	sprintf( CATbuf, "MT0;" );
	sendWebSockCatFrame( works, CATbuf, strlen(CATbuf) );
}
void memNThre( void *works, int button ) {
	static char *buffer;
	buttonp buttons=((workp)works)->buttons;
	int mode = ((workp)works)->NThre;
	buffer=buttons[button].str1;
	buttons[button].activated=120+mode*30;
	sprintf( buffer, "%d", mode );
}
void setCGain( void *works, int button ) {
	sprintf( CATbuf, "CG0%03d;", ((workp)works)->CGain );
	sendWebSockCatFrame( works, CATbuf, strlen(CATbuf) );
}
void upCGain( void *works, int button ) {
	((workp)works)->CGain+=1;
	if( ((workp)works)->CGain >= 10 ) {
		((workp)works)->CGain = 10;
	}
	setCGain( works, button );
}
void downCGain( void *works, int button ) {
	((workp)works)->CGain-=1;
	if( ((workp)works)->CGain <= 0 ) {
		((workp)works)->CGain = 0;
	}
	setCGain( works, button );
}
void getCGain( void *works, int button ) {
	static struct timeval mytime;
	struct timeval now;
	static int isFirst=1;
	gettimeofday(&now , NULL );
	if( isFirst ) {
		isFirst=0;
		gettimeofday(&mytime , NULL );
	} else {
		if( mytime.tv_sec > now.tv_sec-5 ) {
			return;
		}
	}
	gettimeofday(&mytime , NULL );
	sprintf( CATbuf, "CG0;" );
	sendWebSockCatFrame( works, CATbuf, strlen(CATbuf) );
}
void memCGain( void *works, int button ) {
	static char *buffer;
	buttonp buttons=((workp)works)->buttons;
	int mode = ((workp)works)->CGain;
	buffer=buttons[button].str1;
	buttons[button].activated=120+mode*30;
	sprintf( buffer, "%d", mode );
}
void setMGain( void *works, int button ) {
	sprintf( CATbuf, "MG%03d;", ((workp)works)->MGain );
	sendWebSockCatFrame( works, CATbuf, strlen(CATbuf) );
}
void upMGain( void *works, int button ) {
	((workp)works)->MGain+=1;
	if( ((workp)works)->MGain >= 74 ) {
		((workp)works)->MGain = 74;
	}
	setMGain( works, button );
}
void downMGain( void *works, int button ) {
	((workp)works)->MGain-=1;
	if( ((workp)works)->MGain <= 26 ) {
		((workp)works)->MGain = 26;
	}
	setMGain( works, button );
}
void getMGain( void *works, int button ) {
	static struct timeval mytime;
	struct timeval now;
	static int isFirst=1;
	gettimeofday(&now , NULL );
	if( isFirst ) {
		isFirst=0;
		gettimeofday(&mytime , NULL );
	} else {
		if( mytime.tv_sec > now.tv_sec-5 ) {
			return;
		}
	}
	gettimeofday(&mytime , NULL );
	sprintf( CATbuf, "MG;" );
	sendWebSockCatFrame( works, CATbuf, strlen(CATbuf) );
}
void memMGain( void *works, int button ) {
	static char *buffer;
	buttonp buttons=((workp)works)->buttons;
	int mode = ((workp)works)->MGain;
	buffer=buttons[button].str1;
	buttons[button].activated=270+((double)mode/2-25)*11;
	sprintf( buffer, "%5.1f %s", (double)mode/2-25, ((workp)works)->strings->messages[22] );
}
void setAntN( void *works, int button ) {
	int mode = ((workp)works)->AntN;
	if( mode ==1 ) {
		mode=2;
	} else {
		mode=1;
	}
	sprintf( CATbuf, "AN%01d;AN;", mode );
	sendWebSockCatFrame( works, CATbuf, strlen(CATbuf) );
}
void getAntN( void *works, int button ) {
	static struct timeval mytime;
	struct timeval now;
	static int isFirst=1;
	int mode = ((workp)works)->AntN;
	buttonp buttons=((workp)works)->buttons;
	gettimeofday(&now , NULL );
	if( isFirst ) {
		isFirst=0;
		gettimeofday(&mytime , NULL );
	} else {
		if( mytime.tv_sec > now.tv_sec-5 ) {
			buttons[button].activated=mode;
			buttons[button].decode=((workp)works)->strings->decodeAntN;
			return;
		}
	}
	gettimeofday(&mytime , NULL );
	sprintf( CATbuf, "AN;" );
	sendWebSockCatFrame( works, CATbuf, strlen(CATbuf) );
}
void setType( void *works, int button ) {
	sprintf( CATbuf, "ELADFT%02d;", ((workp)works)->FFTtype );
	sendWebSockStatFrame( works, CATbuf, strlen(CATbuf) );
}
void upType( void *works, int button ) {
	((workp)works)->FFTtype+=1;
	if( ((workp)works)->FFTtype >= 2 ) {
		((workp)works)->FFTtype = 2;
	}
	sprintf( CATbuf, "ELADFT%02d;", ((workp)works)->FFTtype );
	sendWebSockStatFrame( works, CATbuf, strlen(CATbuf) );
}
void downType( void *works, int button ) {
	((workp)works)->FFTtype-=1;
	if( ((workp)works)->FFTtype <= 0 ) {
		((workp)works)->FFTtype = 0;
	}
	sprintf( CATbuf, "ELADFT%02d;", ((workp)works)->FFTtype );
	sendWebSockStatFrame( works, CATbuf, strlen(CATbuf) );
}
void getType( void *works, int button ) {
	buttonp buttons=((workp)works)->buttons;
	int mode = ((workp)works)->FFTtype;
	buttons[button].activated=180+mode*90;
}
void memType( void *works, int button ) {
	static char *buffer;
	buttonp buttons=((workp)works)->buttons;
	int mode = ((workp)works)->FFTtype;
	buffer=buttons[button].str1;
	strcpy( buffer, ((workp)works)->strings->decodeFFTtype[mode] );
	buttons[button].activated=180;
}
void setDelay( void *works, int button ) {
	sprintf( CATbuf, "ELADFD%d;", ((workp)works)->FFTdelay+2 );
	sendWebSockStatFrame( works, CATbuf, strlen(CATbuf) );
}
void upDelay( void *works, int button ) {
	((workp)works)->FFTdelay+=2;
	if( ((workp)works)->FFTdelay >= 60 ) {
		((workp)works)->FFTdelay = 60;
	}
	sprintf( CATbuf, "ELADFD%d;", ((workp)works)->FFTdelay+2 );
	sendWebSockStatFrame( works, CATbuf, strlen(CATbuf) );
}
void downDelay( void *works, int button ) {
	((workp)works)->FFTdelay-=2;
	if( ((workp)works)->FFTdelay <= 0 ) {
		((workp)works)->FFTdelay = 0;
	}
	sprintf( CATbuf, "ELADFD%d;", ((workp)works)->FFTdelay+2 );
	sendWebSockStatFrame( works, CATbuf, strlen(CATbuf) );
}
void calcDelay( void *works, int button ) {
	((workp)works)->FFTdelay=((workp)works)->Drawrythm/((workp)works)->FFTrythm-1;
	//printf( "%f\n", ((workp)works)->Drawrythm/((workp)works)->FFTrythm );
	if( ((workp)works)->FFTdelay >= 60 ) {
		((workp)works)->FFTdelay = 60;
	}
	if( ((workp)works)->FFTdelay <= 0 ) {
		((workp)works)->FFTdelay = 0;
	}
	sprintf( CATbuf, "ELADFD%d;", ((workp)works)->FFTdelay+1 );
	sendWebSockStatFrame( works, CATbuf, strlen(CATbuf) );
}
void getDelay( void *works, int button ) {
	buttonp buttons=((workp)works)->buttons;
	int mode = ((workp)works)->FFTdelay;
	buttons[button].activated=135+mode*4.51;
}
void memDelay( void *works, int button ) {
	static char *buffer;
	buttonp buttons=((workp)works)->buttons;
	int mode = ((workp)works)->FFTdelay;
	buffer=buttons[button].str1;
	sprintf( buffer, "%d", mode/2 );
}
void upLevel( void *works, int button ) {
	((workp)works)->FFTlevel+=10;
	if( ((workp)works)->FFTlevel >= 20 ) {
		((workp)works)->FFTlevel = 20;
	}
}
void downLevel( void *works, int button ) {
	((workp)works)->FFTlevel-=10;
	if( ((workp)works)->FFTlevel <= -200 ) {
		((workp)works)->FFTlevel = -200;
	}
}
void getLevel( void *works, int button ) {
	buttonp buttons=((workp)works)->buttons;
	int mode = ((workp)works)->FFTlevel;
	buttons[button].activated=316+mode*1.2;
}
void memLevel( void *works, int button ) {
	static char *buffer;
	buttonp buttons=((workp)works)->buttons;
	int mode = ((workp)works)->FFTlevel;
	buffer=buttons[button].str1;
	sprintf( buffer, "%d %s", mode, ((workp)works)->strings->messages[22] );
}
void upAlpha( void *works, int button ) {
	((workp)works)->FFTalpha+=1;
	if( ((workp)works)->FFTalpha >= 20 ) {
		((workp)works)->FFTalpha = 20;
	}
}
void downAlpha( void *works, int button ) {
	((workp)works)->FFTalpha-=1;
	if( ((workp)works)->FFTalpha <= 1 ) {
		((workp)works)->FFTalpha = 1;
	}
}
void getAlpha( void *works, int button ) {
	buttonp buttons=((workp)works)->buttons;
	int mode = ((workp)works)->FFTalpha;
	buttons[button].activated=120+mode*15;
}
void memAlpha( void *works, int button ) {
	static char *buffer;
	buttonp buttons=((workp)works)->buttons;
	int mode = ((workp)works)->FFTalpha;
	buffer=buttons[button].str1;
	sprintf( buffer, "%d", mode );
}
void upSpan( void *works, int button ) {
	((workp)works)->FFTspan+=10;
	if( ((workp)works)->FFTspan >= 200 ) {
		((workp)works)->FFTspan = 200;
	}
}
void downSpan( void *works, int button ) {
	((workp)works)->FFTspan-=10;
	if( ((workp)works)->FFTspan <= 10 ) {
		((workp)works)->FFTspan = 10;
	}
}
void getSpan( void *works, int button ) {
	buttonp buttons=((workp)works)->buttons;
	int mode = ((workp)works)->FFTspan;
	buttons[button].activated=120+mode*1.5;
}
void memSpan( void *works, int button ) {
	static char *buffer;
	buttonp buttons=((workp)works)->buttons;
	int mode = ((workp)works)->FFTspan;
	buffer=buttons[button].str1;
	sprintf( buffer, "%d %s", mode, ((workp)works)->strings->messages[22] );
}
void agcMlvl( void *works, int value ) {
	gettimeofday(&(((workp)works)->agcMlvlChanged) , NULL );
	((workp)works)->serParms->agcMlvl=value;
	if( value<0 ) {
		value=0;
	}
	memset( CATbuf, 0, XtNumber( CATbuf ) );
	sprintf( CATbuf, "GS1%03d;", value );
	sendWebSockSerFrame( works, CATbuf, strlen(CATbuf) );
}
void upMgain( void *works, int button ) {
	int mode = ((workp)works)->serParms->agcAuto;
	if( mode <= 0 ) {
		return;
	}
	mode = ((workp)works)->serParms->agcMlvl;
	mode++;
	if( mode >= 10 ) {
		mode = 10;
	}
	agcMlvl( works, mode );
}
void downMgain( void *works, int button ) {
	int mode = ((workp)works)->serParms->agcAuto;
	if( mode <= 0 ) {
		return;
	}
	mode = ((workp)works)->serParms->agcMlvl;
	mode--;
	if( mode <= 0 ) {
		mode = 0;
	}
	agcMlvl( works, mode );
}
void getMgain( void *works, int button ) {
	buttonp buttons=((workp)works)->buttons;
	int mode = ((workp)works)->serParms->agcMlvl;
	if( mode <= 0 ) {
		mode *= -1;
	}
	buttons[button].activated=135+mode*27.2;
}
void memMgain( void *works, int button ) {
	static char *buffer;
	buttonp buttons=((workp)works)->buttons;
	int mode = ((workp)works)->serParms->agcMlvl;
	buffer=buttons[button].str1;
	if( mode <= 0 ) {
		mode *= -1;
	}
	sprintf( buffer, "%s %d", ((workp)works)->strings->messages[23], mode );
}
void agcAlvl( void *works, int value ) {
	gettimeofday(&(((workp)works)->agcAlvlChanged) , NULL );
	((workp)works)->serParms->agcAlvl=value;
	if( value<0 ) {
		value=0;
	}
	memset( CATbuf, 0, XtNumber( CATbuf ) );
	sprintf( CATbuf, "GS0%03d;", value -1);
	sendWebSockSerFrame( works, CATbuf, strlen(CATbuf) );
}
void upAgain( void *works, int button ) {
	int mode = ((workp)works)->serParms->agcAuto;
	if( mode > 0 ) {
		return;
	}
	mode = ((workp)works)->serParms->agcAlvl;
	mode++;
	if( mode >= 3 ) {
		mode = 3;
	}
	agcAlvl( works, mode );
}
void downAgain( void *works, int button ) {
	int mode = ((workp)works)->serParms->agcAuto;
	if( mode > 0 ) {
		return;
	}
	mode = ((workp)works)->serParms->agcAlvl;
	mode--;
	if( mode <= 1 ) {
		mode = 1;
	}
	agcAlvl( works, mode );
}
void getAgain( void *works, int button ) {
	buttonp buttons=((workp)works)->buttons;
	int mode = ((workp)works)->serParms->agcAlvl;
	if( mode <= 0 ) {
		mode *=-1;
	}
	buttons[button].activated=90+mode*90;
}
void memAgain( void *works, int button ) {
	static char *buffer;
	buttonp buttons=((workp)works)->buttons;
	int mode = ((workp)works)->serParms->agcAlvl;
	if( mode < 0 ) {
		mode *=-1;
	}
	buffer=buttons[button].str1;
	sprintf( buffer, "%s", ((workp)works)->strings->fast[mode] );
}
void threshold( void *works, int value ) {
	gettimeofday(&(((workp)works)->thresholdChanged) , NULL );
	((workp)works)->serParms->agcThr=value;
	if( value<0 ) {
		value=0;
	}
	memset( CATbuf, 0, XtNumber( CATbuf ) );
	sprintf( CATbuf, "TH%02d;", value );
	sendWebSockSerFrame( works, CATbuf, strlen(CATbuf) );
}
void upThresh( void *works, int button ) {
	int mode = ((workp)works)->serParms->agcAuto;
	if( mode > 0 ) {
		return;
	}
	mode = ((workp)works)->serParms->agcThr;
	mode++;
	if( mode >= 10 ) {
		mode = 10;
	}
	threshold( works, mode );
}
void downThresh( void *works, int button ) {
	int mode = ((workp)works)->serParms->agcAuto;
	if( mode > 0 ) {
		return;
	}
	mode = ((workp)works)->serParms->agcThr;
	mode--;
	if( mode <= 1 ) {
		mode = 1;
	}
	threshold( works, mode );
}
void getThresh( void *works, int button ) {
	buttonp buttons=((workp)works)->buttons;
	int mode = ((workp)works)->serParms->agcThr;
	if( mode < 0 ) {
		mode *=-1;
	}
	buttons[button].activated=105+mode*30;
}
void memThresh( void *works, int button ) {
	static char *buffer;
	buttonp buttons=((workp)works)->buttons;
	int mode = ((workp)works)->serParms->agcThr;
	if( mode < 0 ) {
		mode *=-1;
	}
	buffer=buttons[button].str1;
	sprintf( buffer, "Thr: %d", mode );
}
void bwWrite( void *works, int value ) {
	gettimeofday(&(((workp)works)->bwChanged) , NULL );
	memset( CATbuf, 0, XtNumber( CATbuf ) );
	sprintf( CATbuf, "RF%01d%02d;", ((workp)works)->strings->filterMode[((workp)works)->serParms->mode], value );
	sendWebSockSerFrame( works, CATbuf, strlen(CATbuf) );
	int mode=((workp)works)->serParms->mode;
	switch( mode ) {
		case 1:
			((workp)works)->serParms->AMbw=value+1;
			break;
		case 2:
			((workp)works)->serParms->LSBbw=value+1;
			break;
		case 3:
			((workp)works)->serParms->USBbw=value+1;
			break;
		case 4:
		case 6:
			((workp)works)->serParms->CWbw=17-value;
			break;
		case 5:
			((workp)works)->serParms->FMbw=value+1;
			break;
	}
}
void bwDecode( void *works, long *value, char **desc ) {
	if( *value < 1000*((workp)works)->serParms->mode+((workp)works)->strings->filterMin[((workp)works)->serParms->mode] ) {
		 *value = 1000*((workp)works)->serParms->mode+((workp)works)->strings->filterMin[((workp)works)->serParms->mode];
	}
	if( *value > 1000*((workp)works)->serParms->mode+((workp)works)->strings->filterMax[((workp)works)->serParms->mode] ) {
		 *value = 1000*((workp)works)->serParms->mode+((workp)works)->strings->filterMax[((workp)works)->serParms->mode];
	}
	if( ((workp)works)->serParms->mode==4 || ((workp)works)->serParms->mode==6 ) {
		*desc=((workp)works)->strings->filterDesc[((workp)works)->serParms->mode][((workp)works)->strings->filterMax[((workp)works)->serParms->mode]+1-*value+1000*((workp)works)->serParms->mode];
	} else if( ((workp)works)->serParms->mode>0 && ((workp)works)->serParms->mode<7 ) {
		*desc=((workp)works)->strings->filterDesc[((workp)works)->serParms->mode][*value+1-((workp)works)->strings->filterMin[((workp)works)->serParms->mode]-1000*((workp)works)->serParms->mode];
	}

}
void bwRead( void *works, int button ) {
	buttonp buttons=((workp)works)->buttons;
	int mode=((workp)works)->serParms->mode;
	switch( mode ) {
		case 1:
			buttons[button].activated=((workp)works)->serParms->AMbw;
			buttons[button].decode=((workp)works)->strings->bwAM;
			break;
		case 2:
			buttons[button].activated=((workp)works)->serParms->LSBbw;
			buttons[button].decode=((workp)works)->strings->bwSSB;
			break;
		case 3:
			buttons[button].activated=((workp)works)->serParms->USBbw;
			buttons[button].decode=((workp)works)->strings->bwSSB;
			break;
		case 4:
			buttons[button].activated=((workp)works)->serParms->CWbw;
			buttons[button].decode=((workp)works)->strings->bwCW;
			break;
		case 5:
			buttons[button].activated=((workp)works)->serParms->FMbw;
			buttons[button].decode=((workp)works)->strings->bwFM;
			break;
		case 6:
			buttons[button].activated=((workp)works)->serParms->CWbw;
			buttons[button].decode=((workp)works)->strings->bwCW;
			break;
		default:
			buttons[button].activated=1;
			buttons[button].decode=((workp)works)->strings->empty;
			break;
	}
}
void bwDN( void *works, int value ) {
	memset( CATbuf, 0, XtNumber( CATbuf ) );
	sprintf( CATbuf, "GM060;" );
	sendWebSockSerFrame( works, CATbuf, strlen(CATbuf) );
}
void bwUP( void *works, int value ) {
	memset( CATbuf, 0, XtNumber( CATbuf ) );
	sprintf( CATbuf, "GM020;" );
	sendWebSockSerFrame( works, CATbuf, strlen(CATbuf) );
}
void upBW( void *works, int button ) {
	int bw = 0;
	int mode=((workp)works)->serParms->mode;
	int max=0;
	switch( mode ) {
		case 1:
			bw = ((workp)works)->serParms->AMbw;
			max=7;
			break;
		case 2:
			bw = ((workp)works)->serParms->LSBbw;
			max=21;
			break;
		case 3:
			bw = ((workp)works)->serParms->USBbw;
			max=21;
			break;
		case 4:
		case 6:
			bw = 18-((workp)works)->serParms->CWbw;
			max=16;
			break;
		case 5:
			bw = ((workp)works)->serParms->FMbw;
			max=2;
			break;
	}
	if( bw >= max ) {
		bw = max;
	}
	bwWrite( works, bw );
}
void downBW( void *works, int button ) {
	int bw = 0;
	int mode=((workp)works)->serParms->mode;
	int min=0;
	switch( mode ) {
		case 1:
			bw = ((workp)works)->serParms->AMbw-2;
			min=0;
			break;
		case 2:
			bw = ((workp)works)->serParms->LSBbw-2;
			min=0;
			break;
		case 3:
			bw = ((workp)works)->serParms->USBbw-2;
			min=0;
			break;
		case 4:
		case 6:
			bw = 16-((workp)works)->serParms->CWbw;
			min=7;
			break;
		case 5:
			bw = ((workp)works)->serParms->FMbw-2;
			min=0;
			break;
	}
	if( bw <= min ) {
		bw = min;
	}
	bwWrite( works, bw );
}
void getBW( void *works, int button ) {
	int bw = 0;
	int mode=((workp)works)->serParms->mode;
	buttonp buttons=((workp)works)->buttons;
	int max=1;
	switch( mode ) {
		case 1:
			bw = ((workp)works)->serParms->AMbw-1;
			max=7;
			break;
		case 2:
			bw = ((workp)works)->serParms->LSBbw-1;
			max=21;
			break;
		case 3:
			bw = ((workp)works)->serParms->USBbw-1;
			max=21;
			break;
		case 4:
		case 6:
			bw = 10-((workp)works)->serParms->CWbw;
			max=9;
			break;
		case 5:
			bw = ((workp)works)->serParms->FMbw-1;
			max=2;
			break;
	}
	buttons[button].activated=135+bw*270/max;
}
void sqlRead( void *works, int button ) {
	buttonp buttons=((workp)works)->buttons;
	int mode=((workp)works)->serParms->squelch;
	buttons[button].activated=mode;
}
void squelch( void *works, int value ) {
	gettimeofday(&(((workp)works)->squelchChanged) , NULL );
	((workp)works)->serParms->squelch=value;
	memset( CATbuf, 0, XtNumber( CATbuf ) );
	if( value<0 ) {
		sprintf( CATbuf, "SQ0000;" );
	} else {
		sprintf( CATbuf, "SQ0%03d;", ((workp)works)->serParms->squelch );
	}
	sendWebSockSerFrame( works, CATbuf, strlen(CATbuf) );
}
void sqDN( void *works, int value ) {
	memset( CATbuf, 0, XtNumber( CATbuf ) );
	sprintf( CATbuf, "GM021;" );
	sendWebSockSerFrame( works, CATbuf, strlen(CATbuf) );
}
void sqUP( void *works, int value ) {
	memset( CATbuf, 0, XtNumber( CATbuf ) );
	sprintf( CATbuf, "GM020;" );
	sendWebSockSerFrame( works, CATbuf, strlen(CATbuf) );
}
void upSQ( void *works, int button ) {
	int mode = ((workp)works)->serParms->squelch;
	if( mode < 0 ) {
		return;
	}
	mode++;
	if( mode >= 10 ) {
		mode = 10;
	}
	squelch( works, mode );
}
void downSQ( void *works, int button ) {
	int mode = ((workp)works)->serParms->squelch;
	if( mode < 0 ) {
		return;
	}
	mode--;
	if( mode <= 1 ) {
		mode = 1;
	}
	squelch( works, mode );
}
void getSQ( void *works, int button ) {
	buttonp buttons=((workp)works)->buttons;
	int mode = ((workp)works)->serParms->squelch;
	if( mode < 0 ) {
		mode *=-1;
	}
	buttons[button].activated=105+mode*30;
}
void memSQ( void *works, int button ) {
	static char *buffer;
	buttonp buttons=((workp)works)->buttons;
	int mode = ((workp)works)->serParms->squelch;
	if( mode < 0 ) {
		mode *=-1;
	}
	buffer=buttons[button].str1;
	sprintf( buffer, "%d", mode );
}
void anRead( void *works, int button ) {
	buttonp buttons=((workp)works)->buttons;
	int mode=((workp)works)->serParms->an;
	buttons[button].activated=mode;
}
void autoNotch( void *works, int value ) {
	gettimeofday(&(((workp)works)->anChanged) , NULL );
	((workp)works)->serParms->an=value;
	if( value<0 ) {
		value=0;
	}
	memset( CATbuf, 0, XtNumber( CATbuf ) );
	sprintf( CATbuf, "NO0%03d;", value );
	sendWebSockSerFrame( works, CATbuf, strlen(CATbuf) );
}
void anDN( void *works, int value ) {
	memset( CATbuf, 0, XtNumber( CATbuf ) );
	sprintf( CATbuf, "GM027;" );
	sendWebSockSerFrame( works, CATbuf, strlen(CATbuf) );
}
void anUP( void *works, int value ) {
	memset( CATbuf, 0, XtNumber( CATbuf ) );
	sprintf( CATbuf, "GM020;" );
	sendWebSockSerFrame( works, CATbuf, strlen(CATbuf) );
}
void upAN( void *works, int button ) {
	int mode = ((workp)works)->serParms->an;
	if( mode < 0 ) {
		return;
	}
	mode++;
	if( mode >= 2 ) {
		mode = 2;
	}
	autoNotch( works, mode );
}
void downAN( void *works, int button ) {
	int mode = ((workp)works)->serParms->an;
	if( mode < 0 ) {
		return;
	}
	mode--;
	if( mode <= 1 ) {
		mode = 1;
	}
	autoNotch( works, mode );
}
void getAN( void *works, int button ) {
	buttonp buttons=((workp)works)->buttons;
	int mode = ((workp)works)->serParms->an;
	if( mode < 0 ) {
		mode *=-1;
	}
	buttons[button].activated=mode*180;
}
void memAN( void *works, int button ) {
	static char *buffer;
	buttonp buttons=((workp)works)->buttons;
	int mode = ((workp)works)->serParms->an;
	if( mode < 0 ) {
		mode *=-1;
	}
	buffer=buttons[button].str1;
	sprintf( buffer, "%d", mode );
}
void nbRead( void *works, int button ) {
	buttonp buttons=((workp)works)->buttons;
	int nb=((workp)works)->serParms->nb;
	buttons[button].activated=nb;
}
void noiseBlanker( void *works, int value ) {
	gettimeofday(&(((workp)works)->nbChanged) , NULL );
	((workp)works)->serParms->nb=value;
	if( value<0 ) {
		value=0;
	}
	memset( CATbuf, 0, XtNumber( CATbuf ) );
	sprintf( CATbuf, "NK0%03d;", value );
	sendWebSockSerFrame( works, CATbuf, strlen(CATbuf) );
}
void nbDN( void *works, int value ) {
	memset( CATbuf, 0, XtNumber( CATbuf ) );
	sprintf( CATbuf, "GM026;" );
	sendWebSockSerFrame( works, CATbuf, strlen(CATbuf) );
}
void nbUP( void *works, int value ) {
	memset( CATbuf, 0, XtNumber( CATbuf ) );
	sprintf( CATbuf, "GM020;" );
	sendWebSockSerFrame( works, CATbuf, strlen(CATbuf) );
}
void upNB( void *works, int button ) {
	int mode = ((workp)works)->serParms->nb;
	if( mode < 0 ) {
		return;
	}
	mode++;
	if( mode >= 10 ) {
		mode = 10;
	}
	noiseBlanker( works, mode );
}
void downNB( void *works, int button ) {
	int mode = ((workp)works)->serParms->nb;
	if( mode < 0 ) {
		return;
	}
	mode--;
	if( mode <= 1 ) {
		mode = 1;
	}
	noiseBlanker( works, mode );
}
void getNB( void *works, int button ) {
	buttonp buttons=((workp)works)->buttons;
	int mode = ((workp)works)->serParms->nb;
	if( mode < 0 ) {
		mode *=-1;
	}
	buttons[button].activated=105+mode*30;
}
void memNB( void *works, int button ) {
	static char *buffer;
	buttonp buttons=((workp)works)->buttons;
	int mode = ((workp)works)->serParms->nb;
	if( mode < 0 ) {
		mode *=-1;
	}
	buffer=buttons[button].str1;
	sprintf( buffer, "%d", mode );
}
void nrRead( void *works, int button ) {
	buttonp buttons=((workp)works)->buttons;
	int mode=((workp)works)->serParms->nr;
	buttons[button].activated=mode;
}
void noiseReduction( void *works, int value ) {
	gettimeofday(&(((workp)works)->nrChanged) , NULL );
	((workp)works)->serParms->nr=value;
	if( value<0 ) {
		value=0;
	}
	memset( CATbuf, 0, XtNumber( CATbuf ) );
	sprintf( CATbuf, "NC0%03d;", value );
	sendWebSockSerFrame( works, CATbuf, strlen(CATbuf) );
}
void nrDN( void *works, int value ) {
	memset( CATbuf, 0, XtNumber( CATbuf ) );
	sprintf( CATbuf, "GM025;" );
	sendWebSockSerFrame( works, CATbuf, strlen(CATbuf) );
}
void nrUP( void *works, int value ) {
	memset( CATbuf, 0, XtNumber( CATbuf ) );
	sprintf( CATbuf, "GM020;" );
	sendWebSockSerFrame( works, CATbuf, strlen(CATbuf) );
}
void upNR( void *works, int button ) {
	int mode = ((workp)works)->serParms->nr;
	if( mode < 0 ) {
		return;
	}
	mode++;
	if( mode >= 10 ) {
		mode = 10;
	}
	noiseReduction( works, mode );
}
void downNR( void *works, int button ) {
	int mode = ((workp)works)->serParms->nr;
	if( mode < 0 ) {
		return;
	}
	mode--;
	if( mode <= 1 ) {
		mode = 1;
	}
	noiseReduction( works, mode );
}
void getNR( void *works, int button ) {
	buttonp buttons=((workp)works)->buttons;
	int mode = ((workp)works)->serParms->nr;
	if( mode < 0 ) {
		mode *=-1;
	}
	buttons[button].activated=105+mode*30;
}
void memNR( void *works, int button ) {
	static char *buffer;
	buttonp buttons=((workp)works)->buttons;
	int mode = ((workp)works)->serParms->nr;
	if( mode < 0 ) {
		mode *=-1;
	}
	buffer=buttons[button].str1;
	sprintf( buffer, "%d", mode );
}
void modeChange( void *works, int mode ) {
	static int transcode[]={0,5,1,2,3,4,7};
	int done=1;
	if( mode < 0 ) {
		done=0;
		mode*=-1;
	}
	memset( CATbuf, 0, XtNumber( CATbuf ) );
	sprintf( CATbuf, "MD%d;", transcode[mode] );
	gettimeofday(&(((workp)works)->modeChanged) , NULL );
	sendWebSockSerFrame( works, CATbuf, strlen(CATbuf) );
	((workp)works)->serParms->mode=mode;
	resetMods( works, mode );
	if( done && ((workp)works)->setup->autoReturn ) {
		memset( ((workp)works)->plotter->data, 0, sizeof( ((workp)works)->plotter->data ) );
		((workp)works)->plotter->layer=((workp)works)->plotter->baseLayer;
	}
}
void upMode( void *works, int button ) {
	int mode = ((workp)works)->serParms->mode;
	mode++;
	if( mode >= 6 ) {
		mode = 6;
	}
	modeChange( works, -mode );
}
void downMode( void *works, int button ) {
	int mode = ((workp)works)->serParms->mode;
	mode--;
	if( mode <= 1 ) {
		mode = 1;
	}
	modeChange( works, -mode );
}
void getMode( void *works, int button ) {
	buttonp buttons=((workp)works)->buttons;
	buttons[button].activated=90+((workp)works)->serParms->mode*50;
}
void getAuxVol( void *works, int button ) {
	buttonp buttons=((workp)works)->buttons;
	buttons[button].activated=-240+(((workp)works)->setup->auxVol)*3;
}
void upAuxVol( void *works, int button ) {
	((workp)works)->setup->auxVol+=((workp)works)->auxVolIncr;
	if( ((workp)works)->setup->auxVol >= 100 ) {
		((workp)works)->setup->auxVol = 100;
	}
}
void downAuxVol( void *works, int button ) {
	((workp)works)->setup->auxVol-=((workp)works)->auxVolIncr;
	if( ((workp)works)->setup->auxVol <= 0 ) {
		((workp)works)->setup->auxVol = 0;
	}
}
void upAVolInc( void *works, int button ) {
	((workp)works)->auxVolIncr *= 10;
	if( ((workp)works)->auxVolIncr >= 10 ) {
		((workp)works)->auxVolIncr = 10;
	}
}
void downAVolInc( void *works, int button ) {
	((workp)works)->auxVolIncr /= 10;
	if( ((workp)works)->auxVolIncr <= 1 ) {
		((workp)works)->auxVolIncr = 1;
	}
}
void getAVolInc( void *works, int button ) {
	static char *buffer;
	buttonp buttons=((workp)works)->buttons;
	buffer=buttons[button].str1;
	sprintf( buffer, "%s %d", ((workp)works)->strings->messages[24], ((workp)works)->auxVolIncr );
}
void riDN( void *works, int value ) {
	memset( CATbuf, 0, XtNumber( CATbuf ) );
	sprintf( CATbuf, "GM063;" );
	sendWebSockSerFrame( works, CATbuf, strlen(CATbuf) );
}
void riUP( void *works, int value ) {
	memset( CATbuf, 0, XtNumber( CATbuf ) );
	sprintf( CATbuf, "GM020;" );
	sendWebSockSerFrame( works, CATbuf, strlen(CATbuf) );
}
void ritWrite( void *works, int value ) {
	memset( CATbuf, 0, XtNumber( CATbuf ) );
	sprintf( CATbuf, "RV%+07d;", value );
	sendWebSockSerFrame( works, CATbuf, strlen(CATbuf) );
	gettimeofday(&(((workp)works)->ritChanged) , NULL );
	sendWebSockSerFrame( works, CATbuf, strlen(CATbuf) );
	((workp)works)->serParms->ritFreq=value;
}
void ritRead( void *works, int button ) {
	buttonp buttons=((workp)works)->buttons;
	int mode=((workp)works)->serParms->rit;
	int freq;
	buttons[button].activated=mode;
	if( ((workp)works)->FFTtype==0 && ((workp)works)->serParms->ritFreq>9000 ) {
		freq=9000;
		ritWrite( works, freq );
	}
	if( ((workp)works)->FFTtype==0 && ((workp)works)->serParms->ritFreq<-9000 ) {
		freq=-9000;
		ritWrite( works, freq );
	}
}
void rit( void *works, int value ) {
	((workp)works)->serParms->rit=value;
	memset( CATbuf, 0, XtNumber( CATbuf ) );
	if( value <0 ) {	
		sprintf( CATbuf, "RT0;" );
	} else {
		sprintf( CATbuf, "RT1;" );
		((workp)works)->serParms->ritFreq=1;
	}
	sendWebSockSerFrame( works, CATbuf, strlen(CATbuf) );
}
void getRitIncr( void *works, int button ) {
	static char *buffer;
	buttonp buttons=((workp)works)->buttons;
	buffer=buttons[button].str1;
	if( ((workp)works)->freqRitIncr >= 1000 ) {
		sprintf( buffer, "%s %d %s", ((workp)works)->strings->messages[25], ((workp)works)->freqRitIncr/1000, ((workp)works)->strings->messages[26] );
	} else {
		sprintf( buffer, "%s %d %s", ((workp)works)->strings->messages[25], ((workp)works)->freqRitIncr, ((workp)works)->strings->messages[27] );
	}
}
void upRitFrInc( void *works, int button ) {
	if( ((workp)works)->freqRitIncr == 0 ) {
		((workp)works)->freqIncr = 1;
	} else {
		((workp)works)->freqRitIncr *= 10;
		if( ((workp)works)->freqRitIncr >= 10000 ) {
			((workp)works)->freqRitIncr = 10000;
		}
	}
}
void downRitFrInc( void *works, int button ) {
	if( ((workp)works)->freqRitIncr == 0 ) {
		((workp)works)->freqRitIncr = 1;
	} else {
		((workp)works)->freqRitIncr /= 10;
		if( ((workp)works)->freqRitIncr <= 1 ) {
			((workp)works)->freqRitIncr = 1;
		}
	}
}
void getRitFreq( void *works, int button ) {
	buttonp buttons=((workp)works)->buttons;
	int val=((workp)works)->freqRitIncr*100;
	buttons[button].activated=(((workp)works)->serParms->ritFreq%val)*360/val;
}
void upRitFreq( void *works, int button ) {
	if( ((workp)works)->freqRitIncr == 0 ) {
		((workp)works)->freqRitIncr = 1;
	}
	int freq=((workp)works)->serParms->ritFreq+((workp)works)->freqRitIncr;
	if( ((workp)works)->FFTtype==0 && freq>9000 ) {
		freq=9000;
	}
	if( freq > 50000 ) {
		freq=50000;
	}
	ritWrite( works, freq );
}
void downRitFreq( void *works, int button ) {
	if( ((workp)works)->freqRitIncr == 0 ) {
		((workp)works)->freqRitIncr = 1;
	}
	int freq=((workp)works)->serParms->ritFreq-((workp)works)->freqRitIncr;
	if( ((workp)works)->FFTtype==0 && freq<-9000 ) {
		freq=-9000;
	}
	if( freq < -50000 ) {
		freq=-50000;
	}
	ritWrite( works, freq );
}
void getIncrA( void *works, int button ) {
	static char *buffer;
	buttonp buttons=((workp)works)->buttons;
	buffer=buttons[button].str1;
	if( ((workp)works)->freqIncr >= 1000000 ) {
		sprintf( buffer, "%s %d %s", ((workp)works)->strings->messages[28], ((workp)works)->freqIncr/1000000, ((workp)works)->strings->messages[29] );
	} else if( ((workp)works)->freqIncr >= 1000 ) {
		sprintf( buffer, "%s %d %s", ((workp)works)->strings->messages[28], ((workp)works)->freqIncr/1000, ((workp)works)->strings->messages[26] );
	} else {
		sprintf( buffer, "%s %d %s", ((workp)works)->strings->messages[28], ((workp)works)->freqIncr, ((workp)works)->strings->messages[27] );
	}
}
void getIncr( void *works, int button ) {
	static char *buffer;
	buttonp buttons=((workp)works)->buttons;
	buffer=buttons[button].str1;
	if( ((workp)works)->freqIncr >= 1000000 ) {
		sprintf( buffer, "%s %d %s", ((workp)works)->strings->messages[24], ((workp)works)->freqIncr/1000000, ((workp)works)->strings->messages[29] );
	} else if( ((workp)works)->freqIncr >= 1000 ) {
		sprintf( buffer, "%s %d %s", ((workp)works)->strings->messages[24], ((workp)works)->freqIncr/1000, ((workp)works)->strings->messages[26] );
	} else {
		sprintf( buffer, "%s %d %s", ((workp)works)->strings->messages[24], ((workp)works)->freqIncr, ((workp)works)->strings->messages[27] );
	}
}
void upFrInc( void *works, int button ) {
	if( ((workp)works)->freqIncr == 0 ) {
		((workp)works)->freqIncr = 1;
	} else {
		((workp)works)->freqIncr *= 10;
		if( ((workp)works)->freqIncr >= 10000000 ) {
			((workp)works)->freqIncr = 10000000;
		}
	}
}
void downFrInc( void *works, int button ) {
	if( ((workp)works)->freqIncr == 0 ) {
		((workp)works)->freqIncr = 1;
	} else {
		((workp)works)->freqIncr /= 10;
		if( ((workp)works)->freqIncr <= 1 ) {
			((workp)works)->freqIncr = 1;
		}
	}
}
void getAutoSnap( void *works, int button ) {
	static char *buffer;
	buttonp buttons=((workp)works)->buttons;
	buffer=buttons[button].str1;
	if( ((workp)works)->setup->AutoSnap >= 1000000 ) {
		sprintf( buffer, "%d %s", ((workp)works)->setup->AutoSnap/1000000, ((workp)works)->strings->messages[29] );
	} else if( ((workp)works)->setup->AutoSnap >= 1000 ) {
		sprintf( buffer, "%d %s", ((workp)works)->setup->AutoSnap/1000, ((workp)works)->strings->messages[26] );
	} else {
		sprintf( buffer, "%d %s", ((workp)works)->setup->AutoSnap, ((workp)works)->strings->messages[27] );
	}
}
void memAutoSnap( void *works, int button ) {
	buttonp buttons=((workp)works)->buttons;
	buttons[button].activated=135+log10(((workp)works)->setup->AutoSnap)*38.571;
}
void upAutoSnap( void *works, int button ) {
	if( ((workp)works)->setup->AutoSnap == 0 ) {
		((workp)works)->setup->AutoSnap = 1;
	} else {
		((workp)works)->setup->AutoSnap *= 10;
		if( ((workp)works)->setup->AutoSnap >= 10000000 ) {
			((workp)works)->setup->AutoSnap = 10000000;
		}
	}
}
void downAutoSnap( void *works, int button ) {
	if( ((workp)works)->setup->AutoSnap == 0 ) {
		((workp)works)->setup->AutoSnap = 1;
	} else {
		((workp)works)->setup->AutoSnap /= 10;
		if( ((workp)works)->setup->AutoSnap <= 1 ) {
			((workp)works)->setup->AutoSnap = 1;
		}
	}
}
void getFreq( void *works, int button ) {
	buttonp buttons=((workp)works)->buttons;
	int val=((workp)works)->freqIncr*100;
	buttons[button].activated=(((workp)works)->serParms->freq%val)*360/val;
}
void upFreq( void *works, int button ) {
	gettimeofday(&(((workp)works)->freqChanged) , NULL );
	if( ((workp)works)->freqIncr == 0 ) {
		((workp)works)->freqIncr = 1;
	}
	int freq=((workp)works)->serParms->freq+((workp)works)->freqIncr;
	freq=((workp)works)->freqIncr*(freq/((workp)works)->freqIncr);
	((workp)works)->sintonia( works, freq );
}
void downFreq( void *works, int button ) {
	gettimeofday(&(((workp)works)->freqChanged) , NULL );
	if( ((workp)works)->freqIncr == 0 ) {
		((workp)works)->freqIncr = 1;
	}
	int freq=((workp)works)->serParms->freq-((workp)works)->freqIncr;
	freq=((workp)works)->freqIncr*ceil((double)freq/(double)((workp)works)->freqIncr);
	((workp)works)->sintonia( works, freq );
}
void modeRead( void *works, int button ) {
	buttonp buttons=((workp)works)->buttons;
	int mode=((workp)works)->serParms->mode;
	// mode is always positive
	if( buttons[button].toggle == 4 ) {
		buttons[button].activated=mode;
		buttons[button].decode=((workp)works)->strings->modes;
	} else {
		if( buttons[button].activated == -mode ) {
			buttons[button].activated=mode;
		}
		if( buttons[button].activated>0 && buttons[button].activated != mode ) {
			buttons[button].activated*=-1;
		}
	}
}
void antOut( void *works, int value ) {
	memset( CATbuf, 0, XtNumber( CATbuf ) );
	if( value >0 ) {
		sprintf( CATbuf, "TT0;" );
	} else {
		sprintf( CATbuf, "TT1;" );
	}
	sendWebSockSerFrame( works, CATbuf, strlen(CATbuf) );
}
void auxRead( void *works, int button ) {
	static char buffer[20];
	static char *buf[2]={ "", buffer };
	buttonp buttons=((workp)works)->buttons;
	int mode=((workp)works)->setup->auxVol;
	if( ((workp)works)->serParms->volumeAux > 0 ) {	
		sprintf( buffer, "%d", mode );
		buttons[button].activated=1;
		buttons[button].decode=buf;
	} else {
		buttons[button].activated=2;
		buttons[button].decode=((workp)works)->strings->decodeMute;
	}
}
static char agcbuf[20];
static char *decodeAgcString[]={ " ", agcbuf };
void agcDRead( void *works, int button ) {
	buttonp buttons=((workp)works)->buttons;
	int mode=((workp)works)->serParms->agcAuto;
	int alvl=((workp)works)->serParms->agcAlvl;
	int mlvl=((workp)works)->serParms->agcMlvl;
	int thr=((workp)works)->serParms->agcThr;
	if( mode == 0 ) {
		sprintf( agcbuf, "%s %d/%s", ((workp)works)->strings->messages[30], thr, ((workp)works)->strings->fast[alvl] );
	} else {		
		sprintf( agcbuf, "%s %d", ((workp)works)->strings->messages[31], mlvl );
	}
	buttons[button].activated=1;
	buttons[button].decode=decodeAgcString;
}
void agcRead( void *works, int button ) {
	buttonp buttons=((workp)works)->buttons;
	int mode=((workp)works)->serParms->agcAuto+1;
	buttons[button].activated=mode;
	buttons[button].decode=((workp)works)->strings->agcString;
}
void agcThr( void *works, int value ) {
	if( value<0 ) {
		value=0;
}
	memset( CATbuf, 0, XtNumber( CATbuf ) );
	sprintf( CATbuf, "TH%02d;", value );
	sendWebSockSerFrame( works, CATbuf, strlen(CATbuf) );
}
void agcres( void *works, impostp imp ) {
	if( imp->agcAuto  ) {
		sprintf( CATbuf, "GC1;" );
		sendWebSockSerFrame( works, CATbuf, strlen(CATbuf) );
		usleep( 100000 );
		memset( CATbuf, 0, XtNumber( CATbuf ) );
		sprintf( CATbuf, "GS1%03d;", imp->agcMlvl );
		sendWebSockSerFrame( works, CATbuf, strlen(CATbuf) );
	} else {
		sprintf( CATbuf, "GC0;" );
		sendWebSockSerFrame( works, CATbuf, strlen(CATbuf) );
		usleep( 100000 );
		memset( CATbuf, 0, XtNumber( CATbuf ) );
		sprintf( CATbuf, "GS0%03d;", imp->agcAlvl-1 );
		sendWebSockSerFrame( works, CATbuf, strlen(CATbuf) );
		usleep( 100000 );
		memset( CATbuf, 0, XtNumber( CATbuf ) );
		sprintf( CATbuf, "TH%02d;", imp->agcThr );
		sendWebSockSerFrame( works, CATbuf, strlen(CATbuf) );

	}
}
void agc( void *works, int value ) {
	if( value<0 ) {
		value=0;
	}
	memset( CATbuf, 0, XtNumber( CATbuf ) );
	if( ((workp)works)->serParms->agcAuto  ) {
		sprintf( CATbuf, "GC0;" );
	} else {
		sprintf( CATbuf, "GC1;" );
	}
	sendWebSockSerFrame( works, CATbuf, strlen(CATbuf) );
}
void agDN( void *works, int value ) {
	memset( CATbuf, 0, XtNumber( CATbuf ) );
	if( ((workp)works)->serParms->agc < 5 ) {
		sprintf( CATbuf, "GM024;" );
	} else {
		sprintf( CATbuf, "GM023;" );
	}
	sendWebSockSerFrame( works, CATbuf, strlen(CATbuf) );
}
void agUP( void *works, int value ) {
	memset( CATbuf, 0, XtNumber( CATbuf ) );
	sprintf( CATbuf, "GM020;" );
	sendWebSockSerFrame( works, CATbuf, strlen(CATbuf) );
}
void setMute( void *works, int value ) {
	memset( CATbuf, 0, XtNumber( CATbuf ) );
	if( ((workp)works)->serParms->volumeAux > 0 ) {	
		sprintf( CATbuf, "VA000;" );
	} else {
		sprintf( CATbuf, "VA085;" );
	}
	((workp)works)->serParms->volumeAux*=-1;
	sendWebSockSerFrame( works, CATbuf, strlen(CATbuf) );
}
void attRead( void *works, int button ) {
	buttonp buttons=((workp)works)->buttons;
	int mode=((workp)works)->serParms->att;
	buttons[button].activated=mode;
}
void lpfRead( void *works, int button ) {
	buttonp buttons=((workp)works)->buttons;
	int mode=((workp)works)->serParms->lp;
	buttons[button].activated=mode;
}
void altLowPassFilter( void *works, int value ) {
	int mode = -((workp)works)->serParms->lp;
	if( mode<0 ) {
		mode=0;
	}
	memset( CATbuf, 0, XtNumber( CATbuf ) );
	sprintf( CATbuf, "LP%d;", mode );
	sendWebSockSerFrame( works, CATbuf, strlen(CATbuf) );
}
void lowPassFilter( void *works, int value ) {
	((workp)works)->serParms->lp=value;
	if( value<0 ) {
		value=0;
	}
	memset( CATbuf, 0, XtNumber( CATbuf ) );
	sprintf( CATbuf, "LP%d;", value );
	sendWebSockSerFrame( works, CATbuf, strlen(CATbuf) );
}
void readTX( void *works, int button ) {
	int ab=((workp)works)->serParms->vfoUsed;
	int txab=((workp)works)->txab;
	buttonp buttons=((workp)works)->buttons;
	int mode=((workp)works)->serParms->ptt;
	if( ((workp)works)->serParms->tune > 0 ) {
		mode= -1;
	}
	if( txab != ab ) {
		mode= -1;
	}
	buttons[button].activated=mode;
}
void readTXr( void *works, int button ) {
	int ab=((workp)works)->serParms->vfoUsed;
	int txab=((workp)works)->txab;
	buttonp buttons=((workp)works)->buttons;
	int mode=((workp)works)->serParms->ptt;
	if( ((workp)works)->serParms->tune > 0 ) {
		mode= -1;
	}
	if( txab == ab ) {
		mode= -1;
	}
	buttons[button].activated=mode;
}
void cwTx( void *works, int value ) {
	static int transcode[]={0,5,1,2,3,4,7};
	int mode;
	long freq;
	int j;
	if( value>0 ) {
		((workp)works)->txCwLock=1;
		if( ((workp)works)->serParms->tune > 0 ) {
			sprintf( CATbuf, "RX;" );
			sendWebSockSerFrame( works, CATbuf, strlen(CATbuf) );
		}
		((workp)works)->serParms->oldMode=((workp)works)->serParms->mode;
		((workp)works)->serParms->oldFreq=((workp)works)->serParms->freq;
		if( ((workp)works)->serParms->mode == 4 ) { 	// CW+
			mode = 3;				// USB
			freq = ((workp)works)->serParms->freq - ((workp)works)->serParms->pitch;
		} else {		 			// CW-
			mode = 2;				// LSB
			freq = ((workp)works)->serParms->freq = ((workp)works)->serParms->pitch;
		}
		memset( CATbuf, 0, XtNumber( CATbuf ) );
		sprintf( CATbuf, "MD%d;", transcode[mode] );
		sendWebSockSerFrame( works, CATbuf, strlen(CATbuf) );
		memset( CATbuf, 0, XtNumber( CATbuf ) );
		sprintf( CATbuf, "CF%011ld;",freq );
		sendWebSockSerFrame( works, CATbuf, strlen(CATbuf) );
		memset( CATbuf, 0, XtNumber( CATbuf ) );
		sprintf( CATbuf, "TX0;" );
		sendWebSockSerFrame( works, CATbuf, strlen(CATbuf) );
	} else {
		for( j=0; j< 3; j++ ) {
			memset( CATbuf, 0, XtNumber( CATbuf ) );
			sprintf( CATbuf, "RX;" );
			sendWebSockSerFrame( works, CATbuf, strlen(CATbuf) );
			usleep( 10000 );
			memset( CATbuf, 0, XtNumber( CATbuf ) );
			sprintf( CATbuf, "CF%011ld;", ((workp)works)->serParms->oldFreq );
			sendWebSockSerFrame( works, CATbuf, strlen(CATbuf) );
			memset( CATbuf, 0, XtNumber( CATbuf ) );
			sprintf( CATbuf, "MD%d;", transcode[((workp)works)->serParms->oldMode] );
			sendWebSockSerFrame( works, CATbuf, strlen(CATbuf) );
		}
		//((workp)works)->serParms->mode=((workp)works)->serParms->oldMode;
		//((workp)works)->serParms->freq=((workp)works)->serParms->oldFreq;
		((workp)works)->txCwLock=0;
	}
}
void goTX( void *works, int value ) {
	int mode = 1-((workp)works)->serParms->ptt;
	if( mode>0 ) {
		if( ((workp)works)->serParms->tune > 0 ) {
			sprintf( CATbuf, "RX;" );
			sendWebSockSerFrame( works, CATbuf, strlen(CATbuf) );
		}
		sprintf( CATbuf, "TX0;" );
	} else {
		sprintf( CATbuf, "RX;" );
	}
	sendWebSockSerFrame( works, CATbuf, strlen(CATbuf) );
	((workp)works)->txab=((workp)works)->serParms->vfoUsed;
}
/*
void goTX( void *works, int value ) {
	if( value>0 ) {
		if( ((workp)works)->serParms->tune > 0 ) {
			sprintf( CATbuf, "RX;" );
			sendWebSockSerFrame( works, CATbuf, strlen(CATbuf) );
		}
		sprintf( CATbuf, "TX0;" );
	} else {
		sprintf( CATbuf, "RX;" );
	}
	sendWebSockSerFrame( works, CATbuf, strlen(CATbuf) );
	((workp)works)->txab=((workp)works)->serParms->vfoUsed;
}
*/
void TXdxdn( void *works, int value ) {
	((workp)works)->tximm=1;
	goTX( works, -value );
}
void TXup( void *works, int value ) {
	if( ((workp)works)->tximm == 1 ) {
		((workp)works)->tximm=0;
		sprintf( CATbuf, "RX;" );
		sendWebSockSerFrame( works, CATbuf, strlen(CATbuf) );
		((workp)works)->txCwLock=0;
		sprintf( CATbuf, "PT00;" );
		sendWebSockSerFrame( works, CATbuf, strlen(CATbuf) );
		if( ((workp)works)->serParms->savemode > 1 ) {
			usleep( 200000 );
			((workp)works)->serParms->mode = ((workp)works)->serParms->savemode;
			modeChange( works, ((workp)works)->serParms->savemode );
			((workp)works)->serParms->savemode = 1;
		}
	}
}
void goTXr( void *works, int value ) {
	int ab=((workp)works)->serParms->vfoUsed;
	((workp)works)->txab=((workp)works)->serParms->vfoUsed;
	if( value>0 ) {
		if( ((workp)works)->serParms->ptt > 0 && ((workp)works)->serParms->tune > 0) {
			sprintf( CATbuf, "RX;" );
			sendWebSockSerFrame( works, CATbuf, strlen(CATbuf) );
		}
		if( ab>0 ) {
			if( ((workp)works)->serParms->tuningFrequencyB > 64000000 &&  ((workp)works)->serParms->tuningFrequencyA <= 64000000 ) {
				sprintf( CATbuf, "FR0;FT0;TX0;" );
				sendWebSockSerFrame( works, CATbuf, strlen(CATbuf) );
				lowPassFilter( works, 1 );
				antOut( works, 1 );
			} else if( ((workp)works)->serParms->tuningFrequencyB <= 64000000 &&  ((workp)works)->serParms->tuningFrequencyA > 64000000 ) {
				lowPassFilter( works, 0 );
				antOut( works, 0 );
				sprintf( CATbuf, "FR0;FT0;TX0;" );
				sendWebSockSerFrame( works, CATbuf, strlen(CATbuf) );
			} else {
				sprintf( CATbuf, "FR0;FT0;TX0;" );
				sendWebSockSerFrame( works, CATbuf, strlen(CATbuf) );
			}
		} else {
			if( ((workp)works)->serParms->tuningFrequencyB > 64000000 &&  ((workp)works)->serParms->tuningFrequencyA <= 64000000 ) {
				lowPassFilter( works, 0 );
				antOut( works, 0 );
				sprintf( CATbuf, "FR1;FT1;TX0;" );
				sendWebSockSerFrame( works, CATbuf, strlen(CATbuf) );
			} else if( ((workp)works)->serParms->tuningFrequencyB <= 64000000 &&  ((workp)works)->serParms->tuningFrequencyA > 64000000 ) {
				sprintf( CATbuf, "FR1;FT1;TX0;" );
				sendWebSockSerFrame( works, CATbuf, strlen(CATbuf) );
				lowPassFilter( works, 1 );
				antOut( works, 1 );
			} else {
				sprintf( CATbuf, "FR1;FT1;TX0;" );
				sendWebSockSerFrame( works, CATbuf, strlen(CATbuf) );
			}
		}
	} else {
		sprintf( CATbuf, "RX;" );
		sendWebSockSerFrame( works, CATbuf, strlen(CATbuf) );
		if( ab>0 ) {
			if( ((workp)works)->serParms->tuningFrequencyB > 64000000 &&  ((workp)works)->serParms->tuningFrequencyA <= 64000000 ) {
				sprintf( CATbuf, "RX;FR0;FT0;" );
				sendWebSockSerFrame( works, CATbuf, strlen(CATbuf) );
				lowPassFilter( works, 1 );
				antOut( works, 1 );
			} else if( ((workp)works)->serParms->tuningFrequencyB <= 64000000 &&  ((workp)works)->serParms->tuningFrequencyA > 64000000 ) {
				lowPassFilter( works, 0 );
				antOut( works, 0 );
				sprintf( CATbuf, "RX;FR0;FT0;" );
				sendWebSockSerFrame( works, CATbuf, strlen(CATbuf) );
			} else {
				sprintf( CATbuf, "RX;FR0;FT0;" );
				sendWebSockSerFrame( works, CATbuf, strlen(CATbuf) );
			}
		} else {
			if( ((workp)works)->serParms->tuningFrequencyB > 64000000 &&  ((workp)works)->serParms->tuningFrequencyA <= 64000000 ) {
				lowPassFilter( works, 0 );
				antOut( works, 0 );
				sprintf( CATbuf, "RX;FR1;FT1;" );
				sendWebSockSerFrame( works, CATbuf, strlen(CATbuf) );
			} else if( ((workp)works)->serParms->tuningFrequencyB <= 64000000 &&  ((workp)works)->serParms->tuningFrequencyA > 64000000 ) {
				sprintf( CATbuf, "RX;FR1;FT1;" );
				sendWebSockSerFrame( works, CATbuf, strlen(CATbuf) );
				lowPassFilter( works, 1 );
				antOut( works, 1 );
			} else {
				sprintf( CATbuf, "RX;FR1;FT1;" );
				sendWebSockSerFrame( works, CATbuf, strlen(CATbuf) );
			}
		}
	}
}
void TXrdxdn( void *works, int value ) {
	((workp)works)->tximm=1;
	goTXr( works, -value );
}
void TXru( void *works, int value ) {
	int ab=((workp)works)->serParms->vfoUsed;
	if( ((workp)works)->tximm == 1 ) {
		sprintf( CATbuf, "RX;" );
		sendWebSockSerFrame( works, CATbuf, strlen(CATbuf) );
		if( ab>0 ) {
			if( ((workp)works)->serParms->tuningFrequencyB > 64000000 &&  ((workp)works)->serParms->tuningFrequencyA <= 64000000 ) {
				sprintf( CATbuf, "RX;FR0;FT0;" );
				sendWebSockSerFrame( works, CATbuf, strlen(CATbuf) );
				lowPassFilter( works, 1 );
				antOut( works, 1 );
			} else if( ((workp)works)->serParms->tuningFrequencyB <= 64000000 &&  ((workp)works)->serParms->tuningFrequencyA > 64000000 ) {
				lowPassFilter( works, 0 );
				antOut( works, 0 );
				sprintf( CATbuf, "RX;FR0;FT0;" );
				sendWebSockSerFrame( works, CATbuf, strlen(CATbuf) );
			} else {
				sprintf( CATbuf, "RX;FR0;FT0;" );
				sendWebSockSerFrame( works, CATbuf, strlen(CATbuf) );
			}
		} else {
			if( ((workp)works)->serParms->tuningFrequencyB > 64000000 &&  ((workp)works)->serParms->tuningFrequencyA <= 64000000 ) {
				lowPassFilter( works, 0 );
				antOut( works, 0 );
				sprintf( CATbuf, "RX;FR1;FT1;" );
				sendWebSockSerFrame( works, CATbuf, strlen(CATbuf) );
			} else if( ((workp)works)->serParms->tuningFrequencyB <= 64000000 &&  ((workp)works)->serParms->tuningFrequencyA > 64000000 ) {
				sprintf( CATbuf, "RX;FR1;FT1;" );
				sendWebSockSerFrame( works, CATbuf, strlen(CATbuf) );
				lowPassFilter( works, 1 );
				antOut( works, 1 );
			} else {
				sprintf( CATbuf, "RX;FR1;FT1;" );
				sendWebSockSerFrame( works, CATbuf, strlen(CATbuf) );
			}
		}
	}
	((workp)works)->tximm=0;
}
void readTune( void *works, int button ) {
	buttonp buttons=((workp)works)->buttons;
	int tune=((workp)works)->serParms->tune;
	buttons[button].activated=tune;
}
void goTune( void *works, int value ) {
	if( value>0 ) {
		if( ((workp)works)->serParms->ptt > 0 && ((workp)works)->serParms->tune > 0) {
			sprintf( CATbuf, "RX;" );
			sendWebSockSerFrame( works, CATbuf, strlen(CATbuf) );
		}
		sprintf( CATbuf, "PT00;" );
		sendWebSockSerFrame( works, CATbuf, strlen(CATbuf) );
		sprintf( CATbuf, "TX2;" );
	} else {
		sprintf( CATbuf, "RX;" );
	}
	sendWebSockSerFrame( works, CATbuf, strlen(CATbuf) );
}
void Tunedxdn( void *works, int value ) {
	if( ((workp)works)->serParms->ptt > 0 && ((workp)works)->serParms->tune > 0) {
		sprintf( CATbuf, "RX;" );
		sendWebSockSerFrame( works, CATbuf, strlen(CATbuf) );
	}
	((workp)works)->txCwLock=1;
	((workp)works)->tximm=1;
	((workp)works)->serParms->savemode=((workp)works)->serParms->mode;
	((workp)works)->serParms->mode=1; // AM
	modeChange( works, 1 ); // set AM
	goTX( works, -value );
}
void Attenuator( void *works, int value ) {
	memset( CATbuf, 0, XtNumber( CATbuf ) );
	sprintf( CATbuf, "AT%d;", value );
	sendWebSockSerFrame( works, CATbuf, strlen(CATbuf) );
}
void attenuator( void *works, int value ) {
	int mode = -((workp)works)->serParms->att;
	if( mode<0 ) {
		mode=0;
	}
	memset( CATbuf, 0, XtNumber( CATbuf ) );
	sprintf( CATbuf, "AT%d;", mode );
	sendWebSockSerFrame( works, CATbuf, strlen(CATbuf) );
}
void sintonia( void *works, int value ) {
	gettimeofday(&(((workp)works)->freqChanged) , NULL );
	((workp)works)->freqChanged.tv_sec-=2;
	((workp)works)->plotter->newFreq=-1;
	if( value < 0 ) {
		value=0;
	}
	if( value > 64000000 ) {
		lowPassFilter( works, 0 );
		antOut( works, 0 );
	} else {
		lowPassFilter( works, 1 );
		antOut( works, 1 );
	}
	((workp)works)->serParms->tuningFrequency=value;
	((workp)works)->serParms->oldfreq=value;
	((workp)works)->serParms->tuningFrequency=value;
	((workp)works)->serParms->freq=value;
	memset( CATbuf, 0, XtNumber( CATbuf ) );
	sprintf( CATbuf, "CF%011d;", value );
	sendWebSockSerFrame( works, CATbuf, strlen(CATbuf) );
}
void bandRead( void *works, int button ) {
	workp works1=(workp)works;
	buttonp buttons=works1->buttons;
	bandp bands=works1->bands;
	if( works1->serParms->freq >= bands[buttons[button].band].start && works1->serParms->freq <= bands[buttons[button].band].stop ) {
			buttons[button].activated=buttons[button].band+1;
	} else {
			buttons[button].activated=-buttons[button].band-1;
	}	
/*	
	int aband=((workp)works)->aband;
	int bband=((workp)works)->bband;
	int ab=((workp)works)->ab;
	// band is always positive
	if( ab<0 ) {
		if( buttons[button].activated == -aband ) {
			buttons[button].activated=aband;
		}
		if( buttons[button].activated>0 && buttons[button].activated != aband ) {
			buttons[button].activated*=-1;
		}
	} else {
		if( buttons[button].activated == -bband ) {
			buttons[button].activated=bband;
		}
		if( buttons[button].activated>0 && buttons[button].activated != bband ) {
			buttons[button].activated*=-1;
		}
	}
*/
}
void abRead( void *works, int button ) {
	buttonp buttons=((workp)works)->buttons;
	int ab=((workp)works)->serParms->vfoUsed;
	buttons[button].activated=ab+1;
	buttons[button].decode=((workp)works)->strings->decodeAB;
}
void setAB( void *works, int value ) {
	int ab=((workp)works)->serParms->vfoUsed;
	memset( CATbuf, 0, XtNumber( CATbuf ) );
	if( ab>0 ) {
		if( ((workp)works)->serParms->tuningFrequencyB > 64000000 &&  ((workp)works)->serParms->tuningFrequencyA <= 64000000 ) {
			sprintf( CATbuf, "FR0;FT0;" );
			sendWebSockSerFrame( works, CATbuf, strlen(CATbuf) );
			lowPassFilter( works, 1 );
			antOut( works, 1 );
		} else if( ((workp)works)->serParms->tuningFrequencyB <= 64000000 &&  ((workp)works)->serParms->tuningFrequencyA > 64000000 ) {
			lowPassFilter( works, 0 );
			antOut( works, 0 );
			sprintf( CATbuf, "FR0;FT0;" );
			sendWebSockSerFrame( works, CATbuf, strlen(CATbuf) );
		} else {
			sprintf( CATbuf, "FR0;FT0;" );
			sendWebSockSerFrame( works, CATbuf, strlen(CATbuf) );
		}
	} else {
		if( ((workp)works)->serParms->tuningFrequencyB > 64000000 &&  ((workp)works)->serParms->tuningFrequencyA <= 64000000 ) {
			lowPassFilter( works, 0 );
			antOut( works, 0 );
			sprintf( CATbuf, "FR1;FT1;" );
			sendWebSockSerFrame( works, CATbuf, strlen(CATbuf) );
		} else if( ((workp)works)->serParms->tuningFrequencyB <= 64000000 &&  ((workp)works)->serParms->tuningFrequencyA > 64000000 ) {
			sprintf( CATbuf, "FR1;FT1;" );
			sendWebSockSerFrame( works, CATbuf, strlen(CATbuf) );
			lowPassFilter( works, 1 );
			antOut( works, 1 );
		} else {
			sprintf( CATbuf, "FR1;FT1;" );
			sendWebSockSerFrame( works, CATbuf, strlen(CATbuf) );
		}
	}
	if( value && ((workp)works)->setup->autoReturn ) {
		memset( ((workp)works)->plotter->data, 0, sizeof( ((workp)works)->plotter->data ) );
		((workp)works)->plotter->layer=((workp)works)->plotter->baseLayer;
	}
}
void setBand( void *works, int value ) {
	workp works1= (workp)works;
	int j, bnd;
	for( j=0, bnd=-1; j< works1->nbands; j++ ) {
		if( works1->serParms->freq >=  works1->bands[j].start && works1->serParms->freq <=  works1->bands[j].stop ) {
			bnd=j;
			break;
		}
	}
	if( bnd>=0 ) {
		works1->imposts[bnd].freq=works1->serParms->freq;
		works1->imposts[bnd].mode=works1->serParms->mode;
		works1->imposts[bnd].nb=works1->serParms->nb==0?-1:works1->serParms->nb;
		works1->imposts[bnd].nr=works1->serParms->nr==0?-1:works1->serParms->nr;
		works1->imposts[bnd].an=works1->serParms->an==0?-1:works1->serParms->an;
		works1->imposts[bnd].bw=works1->serParms->bw;
		works1->imposts[bnd].att=works1->serParms->att==0?-1:works1->serParms->att;
		works1->imposts[bnd].rit=works1->serParms->rit;
		works1->imposts[bnd].ritFreq=works1->serParms->ritFreq;
		works1->imposts[bnd].agcAuto=works1->serParms->agcAuto;
		works1->imposts[bnd].agcAlvl=works1->serParms->agcAlvl;
		works1->imposts[bnd].agcMlvl=works1->serParms->agcMlvl;
		works1->imposts[bnd].agcThr=works1->serParms->agcThr;
		works1->imposts[bnd].squelch=works1->serParms->squelch;
	}
	value--;
	if( works1->imposts[value].sat == 0 ) {
		works1->imposts[value].sat=1;
		works1->imposts[value].freq=works1->bands[value].call;
		works1->imposts[value].mode=works1->bands[value].mode;
		works1->imposts[value].nb=works1->serParms->nb==0?-1:works1->serParms->nb;
		works1->imposts[value].nr=works1->serParms->nr==0?-1:works1->serParms->nr;
		works1->imposts[value].an=works1->serParms->an==0?-1:works1->serParms->an;
		works1->imposts[value].bw=works1->serParms->bw;
		works1->imposts[value].att=works1->serParms->att==0?-1:works1->serParms->att;
		works1->imposts[value].rit=works1->serParms->rit;
		works1->imposts[value].ritFreq=works1->serParms->ritFreq;
		works1->imposts[value].agcAuto=works1->serParms->agcAuto;
		works1->imposts[value].agcAlvl=works1->serParms->agcAlvl;
		works1->imposts[value].agcMlvl=works1->serParms->agcMlvl;
		works1->imposts[value].agcThr=works1->serParms->agcThr;
		works1->imposts[value].squelch=works1->serParms->squelch;
	}
	modeChange( works, works1->imposts[value].mode );
	usleep( 100000 );
	gettimeofday(&(((workp)works)->freqChanged) , NULL );
	sintonia( works, works1->imposts[value].freq ); 
	noiseBlanker( works, works1->imposts[value].nb ); 
	noiseReduction( works, works1->imposts[value].nr ); 
	autoNotch( works, works1->imposts[value].an ); 
	Attenuator( works, works1->imposts[value].att ); 
	works1->serParms->ritFreq = works1->imposts[value].ritFreq;
	rit( works, works1->imposts[value].rit ); 
	squelch( works, works1->imposts[value].squelch ); 
	agcres( works, works1->imposts+value ); 
	if( ((workp)works)->setup->autoReturn ) {
		memset( works1->plotter->data, 0, sizeof( works1->plotter->data ) );
		works1->plotter->layer=works1->plotter->baseLayer;
	}
}
void moveatob( void *works, int value ) {
/*
	workp works1= (workp)works;
	works1->blocked=1;
	works1->imposts[(works1->aband-1)*2+1]=works1->imposts[(works1->aband-1)*2];
	works1->bband=works1->aband;
	works1->blocked=0;
*/
}
void movebtoa( void *works, int value ) {
/*
	workp works1= (workp)works;
	works1->blocked=1;
	works1->imposts[(works1->bband-1)*2]=works1->imposts[(works1->bband-1)*2+1];
	works1->aband=works1->bband;
	works1->blocked=0;
*/
}
void setFreq( void *works, int value ) {
	workp works1=(workp)works;
	works1->plotter->layer=2;
	memset( ((workp)works)->plotter->data, 0, sizeof( ((workp)works)->plotter->data ) );
}
void setMods( void *works, int value ) {
	workp works1=(workp)works;
	works1->plotter->layer=4;
	memset( ((workp)works)->plotter->data, 0, sizeof( ((workp)works)->plotter->data ) );
}
void AddCipher( void *works, int value ) {
	workp works1=(workp)works;
	if( value=='#' ) {
		memset( works1->plotter->data, 0, sizeof( works1->plotter->data ) );
		if( works1->plotter->layer==2 ) {
			resetFreq( works, 0 );
		}
		return;
	} else if( value=='e' ) {
		if( works1->plotter->layer==1 ) { // from keyboard
			sintonia( works, atoi( works1->plotter->data ) );
			memset( works1->plotter->data, 0, sizeof( works1->plotter->data ) );
			works1->plotter->layer=works1->plotter->baseLayer;
			return;
		}
		if( works1->plotter->layer==8 ) { // from keyboard
			sintonia( works, atoi( works1->plotter->data ) );
			memset( works1->plotter->data, 0, sizeof( works1->plotter->data ) );
			works1->plotter->layer=works1->plotter->baseLayer;
			return;
		}
		if( works1->plotter->layer==2 ) {
			if( works1->serParms->rit > 0 ) {
				if( ( atoi( works1->plotter->data ) > 0 && atoi( works1->plotter->data ) < 50000 ) || ( atoi( works1->plotter->data ) < 0 && atoi( works1->plotter->data ) > -50000 ) ) {
					works1->serParms->ritFreq = atoi( works1->plotter->data );
					ritWrite( works, works1->serParms->ritFreq );
				}
			} else {
				sintonia( works, atoi( works1->plotter->data ) );
			}
			memset( works1->plotter->data, 0, sizeof( works1->plotter->data ) );
			resetFreq( works, 0 );
		}
		return;
	} else if( value=='k' ) {
		if( works1->plotter->layer==1 ) { // from keyboard
			sintonia( works, atoi( works1->plotter->data )*1000 );
			memset( works1->plotter->data, 0, sizeof( works1->plotter->data ) );
			works1->plotter->layer=works1->plotter->baseLayer;
			return;
		} else {
			if( works1->serParms->rit > 0 ) {
				if( ( atoi( works1->plotter->data ) > 0 && atoi( works1->plotter->data ) < 50 ) || ( atoi( works1->plotter->data ) < 0 && atoi( works1->plotter->data ) > -50 ) ) {
					works1->serParms->ritFreq = atoi( works1->plotter->data )*1000;
					ritWrite( works, works1->serParms->ritFreq );
				}
			} else {
				sintonia( works, atoi( works1->plotter->data )*1000 );
			}
			memset( works1->plotter->data, 0, sizeof( works1->plotter->data ) );
			works1->plotter->layer=works1->plotter->baseLayer;
			return;
		}
	} else if( value=='-' ) {
		if( works1->serParms->rit > 0 && !strlen(works1->plotter->data) ) {
			works1->plotter->data[strlen(works1->plotter->data)]=(char)value;
		}
	} else if( value=='<' ) {
		works1->plotter->data[strlen(works1->plotter->data)-1]=0;
	} else if( value=='.' ) {
		works1->plotter->data[strlen(works1->plotter->data)]='.';
	} else {
		works1->plotter->data[strlen(works1->plotter->data)]=(char)value+0x30;
	}
	if( works1->plotter->layer<=2 && strlen( works1->plotter->data ) > 9 ) {
		memset( works1->plotter->data+9, 0, sizeof( works1->plotter->data )-9 );
	}
	if( works1->plotter->layer==128 && strlen( works1->plotter->data ) > 15 ) {
		memset( works1->plotter->data+15, 0, sizeof( works1->plotter->data )-15 );
	}
}
