/*
	Copyright 2018-2019 Giovanni Franza - HB9EIK 

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <stdio.h>
#include <syslog.h>
#include <string.h>
#include <sys/ioctl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <errno.h>
#include <fcntl.h>
#include <unistd.h>

int main( int ac, char *av[], char **ev ) {

	int DTR_flag = TIOCM_DTR;
	int flag;
	int DOT=-1;
	int OLD_DOT=-1;
	int keyFd;

	if( ac <2 ) {
		fprintf( stderr, "Usage: cwtest /dev/ttyUSBx\n" );
		return 0;
	} else {
		fprintf( stderr, "CTRL-C to exit\n" );
	}
	keyFd = open( av[1], O_RDWR | O_NOCTTY );
	if( keyFd == -1 ) {
		fprintf( stderr, "unable to open keyer device %s, error %d\n", av[1], errno );
		return 0;
	}

	for( ;; ) {		
		usleep( 1000 );
		ioctl( keyFd, TIOCMGET, &flag );
		DOT=(flag&TIOCM_CTS)==TIOCM_CTS?1:0;
		if( OLD_DOT != DOT ) {
			OLD_DOT=DOT;
			fprintf( stderr, "%s\n", DOT? "pressed":"released" );
		}
	}
	
	ioctl( keyFd, TIOCMBIC, &DTR_flag );
	close( keyFd );
	syslog( LOG_INFO, "Keyer operations end\n" );
	return 0;
}

