/*
	Copyright 2018-2019 Giovanni Franza - HB9EIK 

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <stdio.h>
#include <GL/freeglut.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include <FTGL/ftgl.h>

#include <sys/time.h>

#include "struct.h"

#define UNITS_Hz   0
#define UNITS_kHz  1

static t2status statoTmate;

void etichetta( void *work, int x, int y, int z, int length, char *scritta, GLfloat *mat_dark, FTGLfont *font, float vspan, GLfloat *mat_back ) {

	float xfact;
	if( !font ) {
		return;
	}
	glPushMatrix();
	glTranslated( x, y, z );
	xfact=(float)((workp)work)->plotter->Ylength/(1024-85-85);
	glScaled( vspan==1?1.0:xfact, vspan, 1 );
	glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, mat_back);
	glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, mat_back);
	if( ((workp)work)->setup->Antialiased ) {
		glBegin( GL_POLYGON );
		glVertex3d( length*vspan, ftglGetFontAscender( font ), -0.5 );
		glVertex3d( length*vspan, ftglGetFontDescender( font )-2, -0.5 );
		glVertex3d( 0, ftglGetFontDescender( font )-2, -0.5 );
		glVertex3d( 0, ftglGetFontAscender( font ), -0.5 );
		glEnd();
	}
	glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, mat_dark);
	glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, mat_dark);
	glColorMaterial(GL_FRONT, GL_DIFFUSE);
	ftglRenderFont( font, scritta, FTGL_RENDER_ALL );
	glPopMatrix();
}

void DrawOTH( void *work ) {
	workp works=(workp)work;
	double left, top, width, height;
	char buffer[100];
	int lung, inf;

	if( works->linParms->stato == -1 ) {
		return;
	}
	left=works->plotter->OTHXpos;
	top=works->plotter->OTHYpos;
	width=works->plotter->OTHXsize;
	height=works->plotter->OTHYsize;
	glPushMatrix();
	glTranslated( left, top, 2 );
	glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, ((workp)works)->colors->mat_background);
	glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, ((workp)works)->colors->mat_background);
	glBegin( GL_POLYGON );
	glVertex3d( width, height, -0.5 );
	glVertex3d( width, 0, -0.5 );
	glVertex3d( 0, 0, -0.5 );
	glVertex3d( 0, height, -0.5 );
	glEnd();
	sprintf( buffer, works->strings->messages[0], works->serParms->vfoUsed==0?works->strings->decodeABn[2]:works->strings->decodeABn[1] );
	lung=ftglGetFontAdvance( works->font[1*2+works->setup->Antialiased], buffer );
	inf=lung;
	((workp)works)->etichetta( works, 2, -ftglGetFontAscender(works->font[2*2+works->setup->Antialiased])*1, 3, lung, buffer, works->colors->mat_mode_b, works->font[1*2+works->setup->Antialiased], 1, ((workp)works)->colors->mat_background );
	((workp)works)->FormatFreq( works->serParms->vfoUsed==0?works->serParms->tuningFrequencyB:works->serParms->tuningFrequencyA, UNITS_Hz, buffer );
	lung=ftglGetFontAdvance( works->font[2*2+works->setup->Antialiased], buffer );
	((workp)works)->etichetta( works, 2+inf+1, -ftglGetFontAscender(works->font[2*2+works->setup->Antialiased])*1, 3, lung, buffer, works->colors->mat_mode_b, works->font[2*2+works->setup->Antialiased], 1, ((workp)works)->colors->mat_background );
	glPopMatrix();
}

void DrawQTC( void *work ) {
	workp works=(workp)work;
	double left, top, width, height;
	char buffer[100];
	int lung;
	struct timeval now;

	if( works->linParms->stato == -1 ) {
		return;
	}
	left=works->plotter->MSGXpos;
	top=works->plotter->MSGYpos;
	width=works->plotter->MSGXsize;
	height=works->plotter->MSGYsize;
	glPushMatrix();
	glTranslated( left, top, 2 );
	glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, works->colors->mat_background);
	glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, works->colors->mat_background);
	glBegin( GL_POLYGON );
	glVertex3d( width, height, -0.5 );
	glVertex3d( width, 0, -0.5 );
	glVertex3d( 0, 0, -0.5 );
	glVertex3d( 0, height, -0.5 );
	glEnd();
	sprintf( buffer, "%s %s", works->strings->messages[1], works->linParms->banda );
	lung=ftglGetFontAdvance( works->font[3*2+works->setup->Antialiased], buffer );
	works->etichetta( works, 2, -ftglGetFontAscender(works->font[3*2+works->setup->Antialiased])*0.5, 3, lung, buffer, works->colors->mat_freq_small, works->font[3*2+works->setup->Antialiased], 1, works->colors->mat_background );
	if( works->linParms->stato >= 0 && works->linParms->stato < works->strings->nstatus ) {
		sprintf( buffer, "%s %s %s", works->strings->messages[2], works->strings->status[works->linParms->stato], works->linParms->versions );
		lung=ftglGetFontAdvance( works->font[3*2+works->setup->Antialiased], buffer );
		works->etichetta( works, 2, -ftglGetFontAscender(works->font[3*2+works->setup->Antialiased])*1.8, 3, lung, buffer, works->colors->mat_freq_small, works->font[3*2+works->setup->Antialiased], 1, works->colors->mat_background );
	}
	sprintf( buffer, works->strings->messages[3], works->linParms->temperatura );
	lung=ftglGetFontAdvance( works->font[3*2+works->setup->Antialiased], buffer );
	works->etichetta( works, 2, -ftglGetFontAscender(works->font[3*2+works->setup->Antialiased])*3.1, 3, lung, buffer, works->colors->mat_freq_small, works->font[3*2+works->setup->Antialiased], 1, works->colors->mat_background );
	sprintf( buffer, "%s %4.1f %s %s %4.1f %s", works->strings->messages[4], works->linParms->tensione, works->strings->messages[13], works->strings->messages[5], works->linParms->corrente, works->strings->messages[12] );
	lung=ftglGetFontAdvance( works->font[3*2+works->setup->Antialiased], buffer );
	works->etichetta( works, 2, -ftglGetFontAscender(works->font[3*2+works->setup->Antialiased])*4.4, 3, lung, buffer, works->colors->mat_freq_small, works->font[3*2+works->setup->Antialiased], 1, works->colors->mat_background );
	if( works->linParms->errore ) {
		if( works->linParms->errore < works->strings->nerror ) {
			sprintf( buffer, "%s", works->strings->error[works->linParms->errore] );
		} else {
			sprintf( buffer, "%s", works->strings->messages[48] );
		}
		lung=ftglGetFontAdvance( works->font[3*2+works->setup->Antialiased], buffer );
		works->etichetta( works, 2, -ftglGetFontAscender(works->font[3*2+works->setup->Antialiased])*5.7, 3, lung, buffer, works->colors->mat_rssi_evid, works->font[3*2+works->setup->Antialiased], 1, works->colors->mat_background );
		if( works->lastError == 0 ) {
			works->lastError=works->linParms->errore;
			gettimeofday( &(works->lastErrorReceived), NULL );
		} else {
			if( works->numSameError < works->setup->maxCleaning ) {
				gettimeofday( &now, NULL );
				if( 0.001*(now.tv_usec-works->lastErrorReceived.tv_usec)+1000*(now.tv_sec-works->lastErrorReceived.tv_sec) >works->setup->errorCleanTime ) {
					works->numSameError++;
					if( works->numSameError <= works->setup->maxCleaning || works->setup->maxCleaning == 0 ) {
						works->forget( (void *)works, 0 );
						works->lastError=0;
					}
				}
			}
		}
	} else {
		works->lastError=0;
	}
	glPopMatrix();
}

void DrawBack( void *works ) {
	glPushMatrix();
	glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, ((workp)works)->colors->mat_background);
	glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, ((workp)works)->colors->mat_background);
	glNormal3d( -1.0, 0.0, 0.0 );
	glBegin( GL_POLYGON );
	glVertex3d( 800, 640, -9 );
	glVertex3d( 800, 0, -9 );
	glVertex3d( 0, 0, -9 );
	glVertex3d( 0, 640, -9 );
	glEnd( );
	glPopMatrix();
}

void FormatFreq( int val, unsigned char units, char *str ) {
	char Sep2='\0';
	int MHz=val/1000000;
	int kHz=(val-MHz*1000000)/1000;
	int Hz=val-MHz*1000000-kHz*1000;
	if( val < 0 ) {
		if( MHz < 0 ) {
			if( kHz < 0 ) {
				kHz*=-1;
			}
			if( Hz < 0 ) {
				Hz*=-1;
			}
		} else {
			if( kHz < 0 ) {
				if( Hz < 0 ) {
					Hz*=-1;
				}
			}
		}
	}
	if(units==UNITS_Hz) {
		Sep2='.';
	}
	if(units==UNITS_kHz) {
		Sep2=',';
	}
	if((MHz==0)&&(kHz==0)) {
		sprintf(str,"%d",Hz);
	}
	if((MHz==0)&&(kHz!=0)) {
		sprintf(str,"%d%c%03d",kHz,Sep2,Hz);
	}
	if(MHz!=0) {
		sprintf(str,"%d.%03d%c%03d",MHz,kHz,Sep2,Hz);
	}
}

void DrawTune( void *work ) {
	workp works=(workp)work;
	double left, top, width, height;
	char buffer[30];
	int freq;
	int inc;
	int lung;
	int ritpos;
	GLfloat mat_fft_back[4];
	int bw=0;
	char **BW=NULL;
	int pos;

	memcpy( mat_fft_back, works->colors->mat_fft_back, sizeof( mat_fft_back ) );
	mat_fft_back[2]+=0.000025*works->plotter->WfallYsize*works->plotter->WfallYsize;
	if( works->plotter->newFreq>0 ) {
		glPushMatrix();
		top=works->plotter->WfallYpos>works->plotter->FFTYpos?works->plotter->WfallYpos:works->plotter->FFTYpos;
		height=works->plotter->WfallYsize+works->plotter->FFTYsize;
		width=works->plotter->WfallYsize;
		glTranslated( 0, top, 0 );
		if( works->plotter->lastY==-3 ) {
			glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, works->colors->mat_synt_ok);
			glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, works->colors->mat_synt_ok);
		} else {
			glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, works->colors->mat_synt_no);
			glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, works->colors->mat_synt_no);
		}
		glBegin( GL_POLYGON );
		glVertex3d( works->plotter->newFreq-0.4, 0, 1.5 );
		glVertex3d( works->plotter->newFreq-0.4, -height, 1.5 );
		glVertex3d( works->plotter->newFreq+0.4, -height, 1.5 );
		glVertex3d( works->plotter->newFreq+0.4, 0, 1.5 );
		glEnd( );
		glPopMatrix();
		freq=works->serParms->freq-80000+(works->plotter->newFreq-works->plotter->FFTXpos)*160000/(works->plotter->FFTXsize-1);
		inc=works->setup->AutoSnap;
		freq=(double)inc*round((double)freq/(double)inc);
		((workp)works)->FormatFreq( freq, UNITS_Hz, buffer );
		strcat( buffer, " Hz" );
		top=works->plotter->FFTYpos;
		if( works->plotter->newFreq-works->plotter->FFTXpos < works->plotter->FFTXsize/2 ) {
			lung=ftglGetFontAdvance( works->font[4*2+works->setup->Antialiased], buffer );
			((workp)works)->etichetta( works, works->plotter->newFreq, top-ftglGetFontAscender(works->font[4*2+works->setup->Antialiased])-5, 1, lung, buffer, works->colors->mat_freq_small, works->font[4*2+works->setup->Antialiased], 1, mat_fft_back );
		} else {
			lung=ftglGetFontAdvance( works->font[4*2+works->setup->Antialiased], buffer );
			((workp)works)->etichetta( works, works->plotter->newFreq-ftglGetFontAdvance( works->font[4*2+works->setup->Antialiased], buffer ), top-ftglGetFontAscender(works->font[4*2+works->setup->Antialiased])-5, 1, lung, buffer, works->colors->mat_freq_small, works->font[4*2+works->setup->Antialiased], 1, mat_fft_back );
		}
	}
	if( works->serParms->rit>0 ) {
		glPushMatrix();
		top=works->plotter->WfallYpos>works->plotter->FFTYpos?works->plotter->WfallYpos:works->plotter->FFTYpos;
		height=works->plotter->WfallYsize+works->plotter->FFTYsize;
		width=works->plotter->FFTXsize;
		glTranslated( 0, top, 0 );
		glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, works->colors->mat_synt_rit);
		glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, works->colors->mat_synt_rit);
		glBegin( GL_POLYGON );
		ritpos=works->plotter->WfallXpos+width/2-works->serParms->ritFreq*width/160000;
		glVertex3d( ritpos-0.4, 0, 1.5 );
		glVertex3d( ritpos-0.4, -height, 1.5 );
		glVertex3d( ritpos+0.4, -height, 1.5 );
		glVertex3d( ritpos+0.4, 0, 1.5 );
		glEnd( );
		glPopMatrix();
		((workp)works)->FormatFreq( works->serParms->freq-works->serParms->ritFreq, UNITS_Hz, buffer );
		strcat( buffer, " Hz" );
		if( works->serParms->rit > 0 ) {
			strcat( buffer, " " );
			strcat( buffer, works->strings->messages[38] );
			((workp)works)->FormatFreq( works->serParms->ritFreq, UNITS_Hz, buffer+strlen( buffer ) );
			strcat( buffer, " " );
			strcat( buffer, works->strings->messages[27]  );
		}
		top=works->plotter->FFTYpos;
		lung=ftglGetFontAdvance( works->font[4*2+works->setup->Antialiased], buffer );
		if( works->serParms->ritFreq > 0 ) {
			((workp)works)->etichetta( works, ritpos,  top-2*ftglGetFontAscender(works->font[4*2+works->setup->Antialiased])-5, 1, lung, buffer, works->colors->mat_freq_small, works->font[4*2+works->setup->Antialiased], 1, mat_fft_back );
		} else {
			((workp)works)->etichetta( works, ritpos-ftglGetFontAdvance( works->font[4*2+works->setup->Antialiased], buffer ), top-2*ftglGetFontAscender(works->font[4*2+works->setup->Antialiased])-5, 1, lung, buffer, works->colors->mat_freq_small, works->font[4*2+works->setup->Antialiased], 1, mat_fft_back );
		}
	}
	glPushMatrix();
	if( works->plotter->layer == works->setup->bareLayer ) {
		works->plotter->FreqXpos=works->plotter->FreqbXpos;
		works->plotter->FreqXsize=works->plotter->FreqbXsize;
		works->plotter->FreqYpos=works->plotter->FreqbYpos;
		works->plotter->FreqYsize=works->plotter->FreqbYsize;
	} else {
		works->plotter->FreqXpos=works->plotter->FreqaXpos;
		works->plotter->FreqXsize=works->plotter->FreqaXsize;
		works->plotter->FreqYpos=works->plotter->FreqaYpos;
		works->plotter->FreqYsize=works->plotter->FreqaYsize;
	}
	left=works->plotter->FreqXpos;
	width=works->plotter->FreqXsize;
	top=works->plotter->FreqYpos;
	height=works->plotter->FreqYsize;
	glTranslated( left, top, 0 );

	((workp)works)->FormatFreq( works->serParms->freq, UNITS_Hz, buffer );
	lung=ftglGetFontAdvance( works->font[5*2+works->setup->Antialiased], buffer );
	pos=(width-ftglGetFontAdvance( works->font[5*2+works->setup->Antialiased], buffer ))/2;
	((workp)works)->etichetta( works, (width-ftglGetFontAdvance( works->font[5*2+works->setup->Antialiased], buffer ))/2, -height*9/10, 1, lung, buffer, works->colors->mat_freq_big, works->font[5*2+works->setup->Antialiased], 1, ((workp)works)->colors->mat_background );

	if( works->plotter->layer == works->setup->bareLayer && works->connected && works->serReceived>4 ) {
		switch( works->serParms->mode ) {
			case 1:
				bw = works->serParms->AMbw;
				BW = works->strings->bwAM;
				break;
			case 2:
				bw = works->serParms->LSBbw;
				BW = works->strings->bwSSB;
				break;
			case 3:
				bw = works->serParms->USBbw;
				BW = works->strings->bwSSB;
				break;
			case 4:
			case 6:
				bw = works->serParms->CWbw;
				BW = works->strings->bwCW;
				break;
			case 5:
				bw = works->serParms->FMbw;
				BW = works->strings->bwFM;
				break;
			default:
				bw = 0;
				BW = works->strings->BWNULL;
		}
		sprintf( buffer, "%s - %s Hz", works->strings->modes[works->serParms->mode], BW[bw] );
		lung=ftglGetFontAdvance( works->font[6*2+works->setup->Antialiased], buffer );
		((workp)works)->etichetta( works, pos, -height*4/10, 1, lung, buffer, works->colors->mat_write, works->font[6*2+works->setup->Antialiased], 1, ((workp)works)->colors->mat_background );
		if( works->serParms->agcAuto>0 ) {
			sprintf( buffer, "%s%s %s%d", works->strings->messages[32], works->strings->agcString[2], works->strings->messages[44], works->serParms->agcMlvl );
		} else {
			sprintf( buffer, "%s%s %s%d %s%s", works->strings->messages[32], works->strings->agcString[1], works->strings->messages[45], works->serParms->agcThr, works->strings->messages[33], works->strings->fast[works->serParms->agcAlvl] );
		}
		lung=ftglGetFontAdvance( works->font[6*2+works->setup->Antialiased], buffer );
		((workp)works)->etichetta( works, pos, -height*12/10, 1, lung, buffer, works->colors->mat_write, works->font[6*2+works->setup->Antialiased], 1, ((workp)works)->colors->mat_background );
		if( works->serParms->nb <0 ) {
			sprintf( buffer, "%s%s ", works->strings->messages[35], works->strings->messages[34] );
		} else {
			sprintf( buffer, "%s%d ", works->strings->messages[35], works->serParms->nb );
		}
		if( works->serParms->nr <0 ) {
			sprintf( buffer+strlen( buffer ), "%s%s ", works->strings->messages[36], works->strings->messages[34] );
		} else {
			sprintf( buffer+strlen( buffer ), "%s%d ", works->strings->messages[36], works->serParms->nr );
		}
		if( works->serParms->an <0 ) {
			sprintf( buffer+strlen( buffer ), "%s%s ", works->strings->messages[37], works->strings->messages[34] );
		} else {
			sprintf( buffer+strlen( buffer ), "%s%d ", works->strings->messages[37], works->serParms->an );
		}
		lung=ftglGetFontAdvance( works->font[6*2+works->setup->Antialiased], buffer );
		((workp)works)->etichetta( works, pos, -height*15/10, 1, lung, buffer, works->colors->mat_write, works->font[6*2+works->setup->Antialiased], 1, ((workp)works)->colors->mat_background );
	}
	glPopMatrix();
}

void DrawAudioFFT( void *work ) {
	workp works=(workp)work;
	double left, top, width, height;
	int j;
	double jj;
	float val, oldval;
	//float div, start;
	//float scalefont;
	//float xfact;
	//char buffer[20];
	//int lung;
	GLfloat mat_fft_back[4];

	memcpy( mat_fft_back, works->colors->mat_fft_back, sizeof( mat_fft_back ) );

	if( works->plotter->layer == works->setup->bareLayer ) {
		works->plotter->AudioFFTXpos=works->plotter->AudioFFTbXpos;
		works->plotter->AudioFFTXsize=works->plotter->AudioFFTbXsize;
		works->plotter->AudioFFTYpos=works->plotter->AudioFFTbYpos;
		works->plotter->AudioFFTYsize=works->plotter->AudioFFTbYsize;
	} else {
		if( !((workp)works)->setup->audioFftEnabled ) {
			return;
		}
		works->plotter->AudioFFTXpos=works->plotter->AudioFFTaXpos;
		works->plotter->AudioFFTXsize=works->plotter->AudioFFTaXsize;
		works->plotter->AudioFFTYpos=works->plotter->AudioFFTaYpos;
		works->plotter->AudioFFTYsize=works->plotter->AudioFFTaYsize;
	}
	left=works->plotter->AudioFFTXpos;
	width=works->plotter->AudioFFTXsize;
	top=works->plotter->AudioFFTYpos;
	height=works->plotter->AudioFFTYsize;
	glPushMatrix();
	glTranslated( left, top, 7 );
	glNormal3d( -1.0, 0.0, 0.0 );

	for( j=0; j<height; j+=2 ) {
		mat_fft_back[2]+=0.0002*j;
		glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, mat_fft_back);
		glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, mat_fft_back);
		glBegin( GL_POLYGON );
		glVertex3d( width-1, -height+j+2, -2 );
		glVertex3d( width-1, -height+j, -2 );
		glVertex3d( 0, -height+j, -2 );
		glVertex3d( 0, -height+j+2, -2 );
		glEnd( );
	}
	glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, works->colors->mat_draw);
	glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, works->colors->mat_draw);
	for( jj=0; jj<width; jj+=(width-1)/6 ) {
		glBegin( GL_LINE_LOOP );
		glVertex3d( jj, 0, 0.5 );
		glVertex3d( jj, -height, 0.5 );
		glEnd(); 
	}
	glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, works->colors->mat_BW);
	glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, works->colors->mat_BW);
	jj=width*works->serParms->pitch/6000;
	glBegin( GL_LINE_LOOP );
	glVertex3d( jj, 0, 0.5 );
	glVertex3d( jj, -height, 0.5 );
	glEnd(); 
	glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, works->colors->mat_write);
	glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, works->colors->mat_write);
	glBegin( GL_LINE_LOOP );
	glVertex3d( 0, 0, 1.6 );
	glVertex3d( width-1, 0, 1.6 );
	glVertex3d( width-1, -height, 1.6 );
	glVertex3d( 0, -height, 1.6 );
	glEnd(); 
	glScaled( (width-1.15)/(sizeof(works->audioFftOut)/8), height/100, 1 );
	glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, works->colors->mat_draw);
	glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, works->colors->mat_draw);
	for( jj=0; jj>-100; jj-=10 ) {
		glBegin( GL_LINE_LOOP );
		glVertex3d( 0, jj, 1.5 );
		glVertex3d( (sizeof(works->audioFftOut)/8), jj, 1.5 );
		glEnd(); 
	}

	glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, works->colors->mat_FFT);
	glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, works->colors->mat_FFT);
	// Audio FFT tracing
	oldval=works->audioFftOut[1]-200;
	if( oldval>0 ) {
		oldval=0;
	}
	for( j=1; j<sizeof(works->audioFftOut)/8; j++ ) {
		val=works->audioFftOut[j]-200;
		if( val>0 ) {
			val=0;
		}
		if( val<-100 ) {
			val=-100;
		}
		glBegin( GL_LINE_LOOP );
		glVertex3d( 1*(j-2)+1, oldval, 1 );
		glVertex3d( 1*(j-1)+1, val, 1 );
		glEnd( );
		oldval=val;
	}
	glPopMatrix();
}

void DrawFFT( void *work ) {
	workp works=(workp)work;
	double left, top, width, height;
	int j;
	double jj;
	float val, oldval;
	float div, start;
	float scalefont;
	float xfact;
	char buffer[20];
	int lung;
	GLfloat mat_fft_back[4];

	memcpy( mat_fft_back, works->colors->mat_fft_back, sizeof( mat_fft_back ) );
	if( works->FFTspan<10 ) {
		div=1;
	} else if ( works->FFTspan<20 ) {
                div=2;
	} else if ( works->FFTspan<50 ) {
                div=5;
	} else if ( works->FFTspan<120 ) {
                div=10;
	} else {
                div=20;
	}
	start = div*ceil( works->FFTlevel/div );

	if( works->plotter->layer == works->setup->bareLayer ) {
		works->plotter->FFTXpos=works->plotter->FFTbXpos;
		works->plotter->FFTXsize=works->plotter->FFTbXsize;
		works->plotter->FFTYpos=works->plotter->FFTbYpos;
		works->plotter->FFTYsize=works->plotter->FFTbYsize;
	} else {
		works->plotter->FFTXpos=works->plotter->FFTaXpos;
		works->plotter->FFTXsize=works->plotter->FFTaXsize;
		works->plotter->FFTYpos=works->plotter->FFTaYpos;
		works->plotter->FFTYsize=works->plotter->FFTaYsize;
	}
	left=works->plotter->FFTXpos;
	width=works->plotter->FFTXsize;
	top=works->plotter->FFTYpos;
	height=works->plotter->FFTYsize;
	glPushMatrix();
	glTranslated( left, top, 0 );
	glNormal3d( -1.0, 0.0, 0.0 );
	for( j=0; j<height; j+=2 ) {
		mat_fft_back[2]+=0.0002*j;
		glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, mat_fft_back);
		glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, mat_fft_back);
		glBegin( GL_POLYGON );
		glVertex3d( width-1, -height+j+2, -2 );
		glVertex3d( width-1, -height+j, -2 );
		glVertex3d( 0, -height+j, -2 );
		glVertex3d( 0, -height+j+2, -2 );
		glEnd( );
	}
	for( jj=0; jj<width; jj+=(width-1)/8 ) {
		glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, works->colors->mat_draw);
		glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, works->colors->mat_draw);
		glBegin( GL_LINE_LOOP );
		glVertex3d( jj, 0, 0.5 );
		glVertex3d( jj, -height, 0.5 );
		glEnd(); 
	}
	glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, works->colors->mat_write);
	glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, works->colors->mat_write);
	glBegin( GL_LINE_LOOP );
	glVertex3d( 0, 0, 1.6 );
	glVertex3d( width-1, 0, 1.6 );
	glVertex3d( width-1, -height, 1.6 );
	glVertex3d( 0, -height, 1.6 );
	glEnd(); 
	glScaled( (width-1.15)/(works->plotter->Ylength), height/works->FFTspan, 1 );
	scalefont=works->FFTspan/height;
	xfact=(float)((workp)work)->plotter->Ylength/(1024-85-85);
	for( jj=start; jj<=works->FFTlevel+works->FFTspan; jj+=div ) {
		// horizontal line
		glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, works->colors->mat_draw);
		glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, works->colors->mat_draw);
		glBegin( GL_LINE_LOOP );
		glVertex3d( 0, -works->FFTspan-works->FFTlevel+jj, 0.5 );
		glVertex3d( works->plotter->Ylength-1, -works->FFTspan-works->FFTlevel+jj, 0.5 );
		glEnd(); 
		if( -works->FFTspan-works->FFTlevel+jj<0) {
			sprintf( buffer, "%4.0f", jj );
			lung=ftglGetFontAdvance( works->font[7*2+works->setup->Antialiased], buffer );
			((workp)works)->etichetta( works, (-8-(double)lung)*xfact, -works->FFTspan-works->FFTlevel+jj-ftglGetFontAscender(works->font[7*2+works->setup->Antialiased])*scalefont/2, 1, lung, buffer, works->colors->mat_write, works->font[7*2+works->setup->Antialiased], scalefont, ((workp)works)->colors->mat_background );
			((workp)works)->etichetta( works, (-8-(double)lung)*xfact, -works->FFTspan-works->FFTlevel+jj-ftglGetFontAscender(works->font[16*2+works->setup->Antialiased])*scalefont/2, 1, lung, buffer, works->colors->mat_write, works->font[16*2+works->setup->Antialiased], scalefont, ((workp)works)->colors->mat_background );
		}
	}
	sprintf( buffer, "%s", works->strings->messages[47] );
	lung=ftglGetFontAdvance( works->font[7*2+works->setup->Antialiased], buffer );
	jj=works->FFTlevel-div;
	((workp)works)->etichetta( works, (-8-(double)lung)*xfact, -works->FFTspan-works->FFTlevel+jj-ftglGetFontAscender(works->font[7*2+works->setup->Antialiased])*scalefont/2, 0, lung, buffer, works->colors->mat_write, works->font[7*2+works->setup->Antialiased], scalefont, ((workp)works)->colors->mat_background );
	((workp)works)->etichetta( works, (-8-(double)lung)*xfact, -works->FFTspan-works->FFTlevel+jj-ftglGetFontAscender(works->font[16*2+works->setup->Antialiased])*scalefont/2, 0, lung, buffer, works->colors->mat_write, works->font[16*2+works->setup->Antialiased], scalefont, ((workp)works)->colors->mat_background );
	glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, works->colors->mat_FFT);
	glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, works->colors->mat_FFT);
	// initial value
	oldval=works->plotter->Ydata[works->plotter->Ystart]-works->FFTlevel-works->FFTspan;
	if( oldval>0 ) {
		oldval=0;
	}
	if( oldval<-works->FFTspan ) {
		oldval=-works->FFTspan;
	}
	// FFT tracing
	for( j=1; j<works->plotter->Ylength; j++ ) {
		val=works->plotter->Ydata[j+works->plotter->Ystart]-works->FFTlevel-works->FFTspan;
		if( val>0 ) {
			val=0;
		}
		if( val<-works->FFTspan ) {
			val=-works->FFTspan;
		}
		glBegin( GL_LINE_LOOP );
		glVertex3d( j-1, oldval, 1 );
		glVertex3d( j, val, 1 );
		glEnd( );
		oldval=val;
	}
	switch( works->serParms->mode ) {
		case 1:
			works->serParms->startBw=works->strings->bwAMi[works->serParms->AMbw]-works->serParms->ritFreq;
			works->serParms->endBw=works->strings->bwAMf[works->serParms->AMbw]-works->serParms->ritFreq;
			break;
		case 2:
			works->serParms->startBw=-works->strings->bwSSBf[works->serParms->LSBbw]-works->serParms->ritFreq;
			works->serParms->endBw=-works->strings->bwSSBi[works->serParms->LSBbw]-works->serParms->ritFreq;
			break;
		case 3:
			works->serParms->startBw=works->strings->bwSSBi[works->serParms->USBbw]-works->serParms->ritFreq;
			works->serParms->endBw=works->strings->bwSSBf[works->serParms->USBbw]-works->serParms->ritFreq;
			break;
		case 4:
			works->serParms->startBw=works->strings->bwCWi[works->serParms->CWbw]-works->serParms->ritFreq;
			works->serParms->endBw=works->strings->bwCWf[works->serParms->CWbw]-works->serParms->ritFreq;
			break;
		case 5:
			works->serParms->startBw=works->strings->bwFMi[works->serParms->FMbw]-works->serParms->ritFreq;
			works->serParms->endBw=works->strings->bwFMf[works->serParms->FMbw]-works->serParms->ritFreq;
			break;
		case 6:
			works->serParms->startBw=-works->strings->bwCWf[works->serParms->CWbw]-works->serParms->ritFreq;
			works->serParms->endBw=-works->strings->bwCWi[works->serParms->CWbw]-works->serParms->ritFreq;
			break;
	}
	int startBW=works->plotter->Ylength/2+works->serParms->startBw*works->plotter->Ylength/160000;
	int endBW=works->plotter->Ylength/2+works->serParms->endBw*works->plotter->Ylength/160000;
	for( j=0; j<works->plotter->Ylength-1; j++ ) {
		glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, works->colors->mat_FRONT);
		glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, works->colors->mat_FRONT);
		if( j>=startBW && j<=endBW && works->serParms->ptt<=0 ) {
			glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, works->colors->mat_BW);
			glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, works->colors->mat_BW);
		}
		if( ( j>=startBW && j<=endBW ) ||  works->setup->BareFFT[0]=='0' ) {
			val=works->plotter->Ydata[j+works->plotter->Ystart]-works->FFTlevel-works->FFTspan;
			if( val>0 ) {
				val=0;
			}
			if( val<-works->FFTspan ) {
				val=-works->FFTspan;
			}
			glBegin( GL_POLYGON );
			glVertex3d( j, val, 1 );
			glVertex3d( j, -works->FFTspan, 1 );
			glVertex3d( j+1, -works->FFTspan, 1 );
			val=works->plotter->Ydata[j+works->plotter->Ystart+1]-works->FFTlevel-works->FFTspan;
			if( val>0 ) {
				val=0;
			}
			if( val<-works->FFTspan ) {
				val=-works->FFTspan;
			}
			glVertex3d( j+1, val, 1 );
			glEnd( );
		}
	}
	glPopMatrix();
}

#define THR_COLOR_LENGTH  17
float Thr_R_color[] = { 0.0, 0.0, 0.0, 1.0, 1.0 };
float Thr_G_color[] = { 0.0, 0.0, 0.1, 1.0, 1.0 };
float Thr_B_color[] = { 0.0, 0.0, 1.0, 1.0, 1.0 };

void ConvertMeasColor( int count, void *work, float val, unsigned char *r, unsigned char *g, unsigned char *b ) {
	workp works=(workp)work;
        float m;
        float dx;
        float delta_x;
        static float buffer[4*(1024-85-85)]={0};
        static float valt=0.0;
        static float valm=0;
        static float valmin=100;
        static float valmax=-200;
        int j;
	static int Ylength=-1;

	if( works->plotter->Ylength != Ylength ) {
		Ylength=works->plotter->Ylength;
		for( j=0; j<XtNumber( buffer ); j++ ) {
			buffer[j]=0;
		}
		valt=0.0;
		valm=0;
		valmin=100;
		valmax=-200;
	}
        if( count==(1024-86) ) {
                works->plotter->FFTVmin=8.0*((-9+(int)valmin)/8);
                works->plotter->FFTVmax=8.0*(((int)valmax)/8);
                valmin=works->FFTlevel;
                valmax=works->FFTlevel+works->FFTspan;
        }
        if( valmax < val ) {
                valmax=val;
        }
        if( valmin > val ) {
                valmin=val;
        }
        valt+=val;
        valt-=buffer[count];
        buffer[count]=val;
	valm=valt/works->plotter->Ylength;
        if( val > valm+15 ) {  // bianco saturo
                j=3;
                dx=delta_x=1;
        } else if ( val > valm+5 ) { // da blu a bianco
                j=2;
                dx=val-valm-5;
                delta_x=10;
        } else if( val> valm-15) { // da nero a blu
                j=1;
                dx=val-valm+15;
                delta_x=20;
        } else { // nero saturo
                j=0;
                dx=val+140;
                delta_x=valm+125;
        }
        m = (Thr_R_color[j+1] - Thr_R_color[j]) / delta_x;
        *r = (unsigned char)(m * dx + Thr_R_color[j]);
        m = (Thr_G_color[j+1] - (float)Thr_G_color[j]) / delta_x;
        *g = (unsigned char)(m * dx + Thr_G_color[j]);
        m = (Thr_B_color[j+1] - Thr_B_color[j]) / delta_x;
        *b = (unsigned char)(m * dx + Thr_B_color[j]);
}

void DrawWfall( void *work ) {
	workp works=(workp)work;
	double left, top, width, height;
	int j;
	unsigned char r,g,b;
	// pixel buffer
	static GLfloat mat_dark_v[200*4*(1024-85-85)*3] = { 0.0 };
	static int Ylength=-1;
	if( works->plotter->Ylength != Ylength ) {
		Ylength=works->plotter->Ylength;
		for( j=0; j<XtNumber( mat_dark_v ); j++ ) {
			mat_dark_v[j]=0;
		}
	}
	if( works->plotter->layer == works->setup->bareLayer ) {
		works->plotter->WfallXpos=works->plotter->WfallbXpos;
		works->plotter->WfallXsize=works->plotter->WfallbXsize;
		works->plotter->WfallYpos=works->plotter->WfallbYpos;
		works->plotter->WfallYsize=works->plotter->WfallbYsize;
	} else {
		works->plotter->WfallXpos=works->plotter->WfallaXpos;
		works->plotter->WfallXsize=works->plotter->WfallaXsize;
		works->plotter->WfallYpos=works->plotter->WfallaYpos;
		works->plotter->WfallYsize=works->plotter->WfallaYsize;
	}
	left=works->plotter->WfallXpos;
	width=works->plotter->WfallXsize;
	top=works->plotter->WfallYpos;
	height=works->plotter->WfallYsize;
	glPushMatrix();
	glTranslated( left, top, 0 );
	glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, works->colors->mat_write);
	glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, works->colors->mat_write);
	glBegin( GL_LINE_LOOP );
	glVertex3d( 0, 0, 0.5 );
	glVertex3d( width-2, 0, 0.5 );
	glVertex3d( width-2, -height+1, 0.5 );
	glVertex3d( 0, -height+1, 0.5 );
	glEnd(); 
	// resize area
	glScaled( (width-2.30)/(works->plotter->Ylength), (height-1)/200, 1 );
	glNormal3d( -1.0, 0.0, 0.0 );
	if( works->setup->FlippedFFT[0]=='1' ) {
		glTranslated( 0, -200, 0 );
		glRotated( 180, 1, 0, 0 );
	}
	// waterfalling
	if( works->lastFFTreceived.tv_sec >works->lastFFTshown.tv_sec || ( works->lastFFTreceived.tv_sec =works->lastFFTshown.tv_sec && works->lastFFTreceived.tv_usec >works->lastFFTshown.tv_usec ) ) {
		gettimeofday( &(works->lastFFTshown), NULL );
		memmove( ((char *)mat_dark_v)+3*(works->plotter->Ylength)*sizeof(GLfloat), (char *)mat_dark_v, 199*(works->plotter->Ylength)*3*sizeof( GLfloat ) );
		for( j=0; j<works->plotter->Ylength; j++ ) {
			((workp)works)->ConvertMeasColor( j, works, works->plotter->Ydata[j+works->plotter->Ystart], &r, &g, &b );
			mat_dark_v[3*j+0]=(float)r;
			mat_dark_v[3*j+1]=(float)g;
			mat_dark_v[3*j+2]=(float)b;
		}
	}
	gluBuild2DMipmaps(GL_TEXTURE_2D, GL_RGB, works->plotter->Ylength, 200, GL_RGB, GL_FLOAT, mat_dark_v);
	glEnable( GL_TEXTURE_2D );
	glColor3f( 1.0, 1.0, 1.0 );
	// scale and draw
	glScaled( works->plotter->Ylength, 200, 1 );
	glBegin( GL_QUADS );
	glTexCoord2d( 0, 0 ); glVertex2d( 0,  0 );
	glTexCoord2d( 1, 0 ); glVertex2d( 1,  0 );
	glTexCoord2d( 1, 1 ); glVertex2d( 1, -1 );
	glTexCoord2d( 0, 1 ); glVertex2d( 0, -1 );
	glEnd( );
	glDisable( GL_TEXTURE_2D );
	glPopMatrix();
}

void DrawScale( void *work ) {
	workp works=(workp)work;
	double left, top, width, height;
	int j;
	float jj;
	char buffer[50];
	int lung;

	if( works->plotter->layer == works->setup->bareLayer ) {
		works->plotter->SyntXpos=works->plotter->SyntbXpos;
		works->plotter->SyntXsize=works->plotter->SyntbXsize;
		works->plotter->SyntYpos=works->plotter->SyntbYpos;
		works->plotter->SyntYsize=works->plotter->SyntbYsize;
	} else {
		works->plotter->SyntXpos=works->plotter->SyntaXpos;
		works->plotter->SyntXsize=works->plotter->SyntaXsize;
		works->plotter->SyntYpos=works->plotter->SyntaYpos;
		works->plotter->SyntYsize=works->plotter->SyntaYsize;
	}
	left=works->plotter->SyntXpos;
	width=works->plotter->SyntXsize;
	top=works->plotter->SyntYpos;
	height=works->plotter->SyntYsize;
	glPushMatrix();
	glTranslated( left, top, 0 );
	glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, works->colors->mat_draw);
	glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, works->colors->mat_draw);
	for( j=-60,jj=(width-1)/8; j<80; jj+=(width-1)/8, j+=20 ) {
		if( works->plotter->layer == works->setup->bareLayer ) {
			((workp)works)->FormatFreq( works->serParms->freq+j*1000, UNITS_Hz, buffer );
		} else {
			sprintf( buffer, "%02d", j );
		}
		lung=ftglGetFontAdvance( works->font[8*2+works->setup->Antialiased], buffer );
		((workp)works)->etichetta( works, jj-ftglGetFontAdvance( works->font[8*2+works->setup->Antialiased], buffer )/2, -height*9/10, 1, lung, buffer, works->colors->mat_write, works->font[8*2+works->setup->Antialiased], 1, works->colors->mat_background );
	}
	if( works->plotter->layer != works->setup->bareLayer ) {
		sprintf( buffer, "%s", works->strings->messages[26] );
		lung=ftglGetFontAdvance( works->font[8*2+works->setup->Antialiased], buffer );
		((workp)works)->etichetta( works, width-5-ftglGetFontAdvance( works->font[8*2+works->setup->Antialiased], buffer ), -height*9/10, 1, lung, buffer, works->colors->mat_write, works->font[8*2+works->setup->Antialiased], 1, works->colors->mat_background );
	}
	glPopMatrix();

	if( works->plotter->layer == works->setup->bareLayer ) {
		works->plotter->ScaleXpos=works->plotter->ScalebXpos;
		works->plotter->ScaleXsize=works->plotter->ScalebXsize;
		works->plotter->ScaleYpos=works->plotter->ScalebYpos;
		works->plotter->ScaleYsize=works->plotter->ScalebYsize;
	} else {
		works->plotter->ScaleXpos=works->plotter->ScaleaXpos;
		works->plotter->ScaleXsize=works->plotter->ScaleaXsize;
		works->plotter->ScaleYpos=works->plotter->ScaleaYpos;
		works->plotter->ScaleYsize=works->plotter->ScaleaYsize;
	}
	left=works->plotter->ScaleXpos;
	width=works->plotter->ScaleXsize;
	top=works->plotter->ScaleYpos;
	height=works->plotter->ScaleYsize;
	glPushMatrix();
	glTranslated( left, top, 0 );
	glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, works->colors->mat_draw);
	glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, works->colors->mat_draw);
	if( strlen( works->plotter->data ) ) {
		if( works->serParms->rit>0 ) {
			sprintf( buffer, "%s   %s", works->strings->messages[38], works->plotter->data );
		} else {
			sprintf( buffer, "%s  %s", works->strings->messages[40], works->plotter->data );
		}
		lung=ftglGetFontAdvance( works->font[8*2+works->setup->Antialiased], buffer );
		//((workp)works)->etichetta( works, width-5-ftglGetFontAdvance( works->font[8*2+works->setup->Antialiased], buffer ), -height*9/10+ftglGetFontAscender(works->font[8*2+works->setup->Antialiased])*1.5, 1, lung, buffer, works->colors->mat_freq_big, works->font[8*2+works->setup->Antialiased], 1, works->colors->mat_background );
		((workp)works)->etichetta( works, (width-5-ftglGetFontAdvance( works->font[8*2+works->setup->Antialiased], buffer ))/2, -height*9/10+ftglGetFontAscender(works->font[8*2+works->setup->Antialiased])*1.5, 1, lung, buffer, works->colors->mat_freq_big, works->font[8*2+works->setup->Antialiased], 1, works->colors->mat_background );
	}

	((workp)works)->FormatFreq( works->serParms->freq-80000, UNITS_Hz, buffer );
	strcat( buffer, " " );
	strcat( buffer, works->strings->messages[27] );
	lung=ftglGetFontAdvance( works->font[8*2+works->setup->Antialiased], buffer );
	((workp)works)->etichetta( works, 5, -height*9/10, 1, lung, buffer, works->colors->mat_write, works->font[8*2+works->setup->Antialiased], 1, works->colors->mat_background );
	((workp)works)->FormatFreq( works->serParms->freq, UNITS_Hz, buffer );
	strcat( buffer, " " );
	strcat( buffer, works->strings->messages[27] );
	lung=ftglGetFontAdvance( works->font[8*2+works->setup->Antialiased], buffer );
	lung=ftglGetFontAdvance( works->font[8*2+works->setup->Antialiased], buffer );
	((workp)works)->etichetta( works, (width-ftglGetFontAdvance( works->font[8*2+works->setup->Antialiased], buffer ))/2, -height*9/10, 1, lung, buffer, works->colors->mat_write, works->font[8*2+works->setup->Antialiased], 1, works->colors->mat_background );
	((workp)works)->FormatFreq( works->serParms->freq+80000, UNITS_Hz, buffer );
	strcat( buffer, " " );
	strcat( buffer, works->strings->messages[27] );
	lung=ftglGetFontAdvance( works->font[8*2+works->setup->Antialiased], buffer );
	((workp)works)->etichetta( works, width-5-ftglGetFontAdvance( works->font[8*2+works->setup->Antialiased], buffer ), -height*9/10, 1, lung, buffer, works->colors->mat_write, works->font[8*2+works->setup->Antialiased], 1, works->colors->mat_background );
	glPopMatrix();
}

void DrawPwr( void *work ) {
	workp works=(workp)work;
	double left, top, width, height;
	int s,d;
	float val;
	char buffer[100];
	int center;
	static struct timeval start, stop;
	float interval;
	if( works->plotter->layer == works->setup->bareLayer ) {
		works->plotter->RSSIXpos=works->plotter->RSSIbXpos;
		works->plotter->RSSIXsize=works->plotter->RSSIbXsize;
		works->plotter->RSSIYpos=works->plotter->RSSIbYpos;
		works->plotter->RSSIYsize=works->plotter->RSSIbYsize;
	} else {
		works->plotter->RSSIXpos=works->plotter->RSSIaXpos;
		works->plotter->RSSIXsize=works->plotter->RSSIaXsize;
		works->plotter->RSSIYpos=works->plotter->RSSIaYpos;
		works->plotter->RSSIYsize=works->plotter->RSSIaYsize;
	}
	float alpha,beta,j;
	left=works->plotter->RSSIXpos;
	width=works->plotter->RSSIXsize;
	top=works->plotter->RSSIYpos;
	height=works->plotter->RSSIYsize;
	int lung;

	glPushMatrix();
	glTranslated( left, top, 0 );

	gettimeofday( &stop, NULL );
	interval=1.0*(stop.tv_sec-start.tv_sec)+0.000001*(stop.tv_usec-start.tv_usec);
	if( works->plotter->layer == works->setup->bareLayer ) {
		sprintf( buffer, "%s %s  %s%4.0f %s%4.0f %s", works->strings->messages[16], works->setup->server, works->strings->messages[8], (float)works->bytesIn*8/interval/1000, works->strings->messages[9], (float)works->bytesOut*8/interval/1000, works->strings->messages[17] );
	} else {
		sprintf( buffer, "%s %s  %s%4.0f %s%4.0f", works->strings->messages[6], works->setup->server, works->strings->messages[8], (float)works->bytesIn*8/interval/1000, works->strings->messages[9], (float)works->bytesOut*8/interval/1000 );
	}
	if( interval > 2 ) {
		gettimeofday( &start, NULL );
		works->bytesIn=works->bytesOut=0;
	}
	lung=ftglGetFontAdvance( works->font[9*2+works->setup->Antialiased], buffer );
	((workp)works)->etichetta( works, 0, -height-13, 3, lung, buffer, works->colors->mat_write, works->font[9*2+works->setup->Antialiased], 1, works->colors->mat_background );
	((workp)works)->etichetta( works, 0, -height-13, 3, lung, buffer, works->colors->mat_write, works->font[0*2+works->setup->Antialiased], 1, works->colors->mat_background );
	if( strlen( works->message ) ) {
		sprintf( buffer, "%s", works->message );
		((workp)works)->etichetta( works, 0, -height-23, 3, lung, buffer, works->colors->mat_mode_b, works->font[17*2+works->setup->Antialiased], 1, works->colors->mat_background );
	} else {
		sprintf( buffer, "%s %5.1f %s %s %5.1f %s %s", works->strings->messages[7], works->irttmax, works->strings->messages[14], works->strings->messages[10], works->irttmed, works->strings->messages[14], works->strings->messages[11] );
		((workp)works)->etichetta( works, 0, -height-23, 3, lung, buffer, works->colors->mat_write, works->font[12*2+works->setup->Antialiased], 1, works->colors->mat_background );
		((workp)works)->etichetta( works, 0, -height-23, 3, lung, buffer, works->colors->mat_write, works->font[17*2+works->setup->Antialiased], 1, works->colors->mat_background );
	}

	glPushMatrix();
	glTexEnvf(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_REPLACE);
	if( works->plotter->layer == works->setup->bareLayer ) {
		gluBuild2DMipmaps(GL_TEXTURE_2D, GL_RGB, works->width_meter, works->height_meter, GL_RGB, GL_UNSIGNED_BYTE, works->meter);
	} else {
		gluBuild2DMipmaps(GL_TEXTURE_2D, GL_RGB, works->width_wmeter, works->height_wmeter, GL_RGB, GL_UNSIGNED_BYTE, works->wmeter);
	}
	glEnable( GL_TEXTURE_2D );
	glColor3ub( 0Xff, 0Xff, 0Xff );
	// scale and draw
	glScaled( works->plotter->RSSIXsize, works->plotter->RSSIYsize, 1 );
	glBegin( GL_QUADS );
	glTexCoord2d( 0, 0 ); glVertex2d( 0,  0 );
	glTexCoord2d( 1, 0 ); glVertex2d( 1,  0 );
	glTexCoord2d( 1, 1 ); glVertex2d( 1, -1 );
	glTexCoord2d( 0, 1 ); glVertex2d( 0, -1 );
	glEnd( );
	glDisable( GL_TEXTURE_2D );
	glPopMatrix();

	glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, works->colors->mat_rssi_fore);
	glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, works->colors->mat_rssi_fore);
	if( works->linParms->standBy ) {
		val=works->cat->fwdPwr;
		s=147-val/87.7;
		if( val>1000 ) {
			sprintf( buffer, "%s %4.2f %s", works->strings->messages[42], val/1000.0, works->strings->messages[41] );
		} else {
			sprintf( buffer, "%s %3.0f %s", works->strings->messages[42], val, works->strings->messages[20] );
		}
		val=works->cat->refPwr;
		d=147-val/87.7;
		if( val>1000 ) {
			sprintf( buffer+strlen(buffer), "  %s %4.2f %s", works->strings->messages[43], val/1000.0, works->strings->messages[41] );
		} else {
			sprintf( buffer+strlen(buffer), "  %s %3.0f %s", works->strings->messages[43], val, works->strings->messages[20] );
		}
		lung=ftglGetFontAdvance( works->font[10*2+works->setup->Antialiased], buffer );
		((workp)works)->etichetta( works, (width-ftglGetFontAdvance( works->font[10*2+works->setup->Antialiased], buffer ))/2, -height*4/10-ftglGetFontAscender(works->font[10*2+works->setup->Antialiased])*1.5, 3, lung, buffer, works->colors->mat_rssi_evid, works->font[10*2+works->setup->Antialiased], 1, works->colors->mat_rssi_fore );
		sprintf( buffer, "%s 1:%4.2f", works->strings->messages[39], works->cat->ros );
		lung=ftglGetFontAdvance( works->font[10*2+works->setup->Antialiased], buffer );
		((workp)works)->etichetta( works, (width-ftglGetFontAdvance( works->font[10*2+works->setup->Antialiased], buffer ))/2, -height*4/10, 3, lung, buffer, works->colors->mat_rssi_back, works->font[10*2+works->setup->Antialiased], 1, works->colors->mat_rssi_fore );
	} else {
		val=works->linParms->pwrOut;
		s=147-val/1.32;
		sprintf( buffer, "%s %6.2f %s", works->strings->messages[46], val, works->strings->messages[41] );
		val=works->linParms->pwrOut*((works->linParms->swr-1)/(works->linParms->swr+1))*((works->linParms->swr-1)/(works->linParms->swr+1));
		d=147-val/1.32;
		lung=ftglGetFontAdvance( works->font[10*2+works->setup->Antialiased], buffer );
		((workp)works)->etichetta( works, (width-ftglGetFontAdvance( works->font[10*2+works->setup->Antialiased], buffer ))/2, -height*4/10-ftglGetFontAscender(works->font[10*2+works->setup->Antialiased])*1.5, 3, lung, buffer, works->colors->mat_rssi_evid, works->font[10*2+works->setup->Antialiased], 1, works->colors->mat_rssi_fore );
		sprintf( buffer, "%s 1:%4.2f", works->strings->messages[39], works->linParms->swr );
		lung=ftglGetFontAdvance( works->font[10*2+works->setup->Antialiased], buffer );
		((workp)works)->etichetta( works, (width-ftglGetFontAdvance( works->font[10*2+works->setup->Antialiased], buffer ))/2, -height*4/10, 3, lung, buffer, works->colors->mat_rssi_back, works->font[10*2+works->setup->Antialiased], 1, works->colors->mat_rssi_fore );
	}
	glScaled( width/1000, height/1000, 1 );
	glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, works->colors->mat_rssi_fore);
	glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, works->colors->mat_rssi_fore);
	glBegin( GL_POLYGON );
	glVertex3d( 0, 0, 0 );
	glVertex3d( 990, 0, 0 );
	glVertex3d( 990, -990, 0 );
	glVertex3d( 0, -990, 0 );
	glEnd( );
	for( j=33; j<147; j+=6 ) {
		alpha = j*M_PI/180;
		beta = (j+6)*M_PI/180;
		glBegin( GL_POLYGON );
		if( j>93 ) {
			glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, works->colors->mat_rssi_back);
			glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, works->colors->mat_rssi_back);
		} else {
			glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, works->colors->mat_rssi_evid);
			glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, works->colors->mat_rssi_evid);
		}
		glVertex3d( 500+520*cos( alpha ), -650+560*sin( alpha ), 2 );
		glVertex3d( 500+510*cos( alpha ), -650+540*sin( alpha ), 2 );
		glVertex3d( 500+510*cos( beta ), -650+540*sin( beta ), 2 );
		glVertex3d( 500+520*cos( beta ), -650+560*sin( beta ), 2 );
		glEnd( );
	}
	for( j=93; j<=147; j+=6 ) {
		alpha =(j-0.5)*M_PI/180;
		beta = (j+0.5)*M_PI/180;
		glBegin( GL_POLYGON );
		glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, works->colors->mat_rssi_back);
		glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, works->colors->mat_rssi_back);
		glVertex3d( 500+520*cos( alpha ), -650+560*sin( alpha ), 2 );
		glVertex3d( 500+490*cos( alpha ), -650+500*sin( alpha ), 2 );
		glVertex3d( 500+490*cos( beta ), -650+500*sin( beta ), 2 );
		glVertex3d( 500+520*cos( beta ), -650+560*sin( beta ), 2 );
		glEnd( );
	}
	for( j=33; j<93; j+=10 ) {
		alpha =(j-0.5)*M_PI/180;
		beta = (j+0.5)*M_PI/180;
		glBegin( GL_POLYGON );
		glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, works->colors->mat_rssi_evid);
		glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, works->colors->mat_rssi_evid);
		glVertex3d( 500+520*cos( alpha ), -650+560*sin( alpha ), 2 );
		glVertex3d( 500+490*cos( alpha ), -650+500*sin( alpha ), 2 );
		glVertex3d( 500+490*cos( beta ), -650+500*sin( beta ), 2 );
		glVertex3d( 500+520*cos( beta ), -650+560*sin( beta ), 2 );
		glEnd( );
	}
	if( works->plotter->layer == works->setup->bareLayer ) {
		center=-930;
	} else {
		center=-890;
	}
	glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, works->colors->mat_rssi_back);
	glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, works->colors->mat_rssi_back);
	glBegin( GL_POLYGON );
	alpha = ((s)<33?33:(s))*M_PI/180;
	glVertex3d( 491, center, 3.1 );
	glVertex3d( 495+490*cos( alpha ), -600+420*sin( alpha ), 3.1 );
	glVertex3d( 505+490*cos( alpha ), -600+420*sin( alpha ), 3.1 );
	glVertex3d( 509, center, 3.1 );
	glEnd( );
	glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, works->colors->mat_rssi_evid);
	glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, works->colors->mat_rssi_evid);
	glBegin( GL_POLYGON );
	alpha = ((d)<33?33:(d))*M_PI/180;
	glVertex3d( 491, center, 3.1 );
	glVertex3d( 495+490*cos( alpha ), -600+420*sin( alpha ), 3.1 );
	glVertex3d( 505+490*cos( alpha ), -600+420*sin( alpha ), 3.1 );
	glVertex3d( 509, center, 3.1 );
	glEnd( );
	glPopMatrix();
}

void DrawRSSI( void *work ) {
	workp works=(workp)work;
	double left, top, width, height;
	int s,d,val;
	char buffer[100];
	int incr;
	float alpha;
	int lung;
	static struct timeval start, stop;
	float interval;
	if( works->plotter->layer == works->setup->bareLayer ) {
		works->plotter->RSSIXpos=works->plotter->RSSIbXpos;
		works->plotter->RSSIXsize=works->plotter->RSSIbXsize;
		works->plotter->RSSIYpos=works->plotter->RSSIbYpos;
		works->plotter->RSSIYsize=works->plotter->RSSIbYsize;
	} else {
		works->plotter->RSSIXpos=works->plotter->RSSIaXpos;
		works->plotter->RSSIXsize=works->plotter->RSSIaXsize;
		works->plotter->RSSIYpos=works->plotter->RSSIaYpos;
		works->plotter->RSSIYsize=works->plotter->RSSIaYsize;
	}
	left=works->plotter->RSSIXpos;
	width=works->plotter->RSSIXsize;
	top=works->plotter->RSSIYpos;
	height=works->plotter->RSSIYsize;

	glPushMatrix();
	glTranslated( left, top, 0 );

	glPushMatrix();
	glTexEnvf(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_REPLACE);
	if( works->plotter->layer == works->setup->bareLayer ) {
		gluBuild2DMipmaps(GL_TEXTURE_2D, GL_RGB, works->width_smeter, works->height_smeter, GL_RGB, GL_UNSIGNED_BYTE, works->smeter);
	} else {
		gluBuild2DMipmaps(GL_TEXTURE_2D, GL_RGB, works->width_wsmeter, works->height_wsmeter, GL_RGB, GL_UNSIGNED_BYTE, works->wsmeter);
	}
	glEnable( GL_TEXTURE_2D );
	glColor3ub( 0Xff, 0Xff, 0Xff );
	// scale and draw
	glScaled( works->plotter->RSSIXsize, works->plotter->RSSIYsize, 1 );
	glBegin( GL_QUADS );
	glTexCoord2d( 0, 0 ); glVertex2d( 0,  0 );
	glTexCoord2d( 1, 0 ); glVertex2d( 1,  0 );
	glTexCoord2d( 1, 1 ); glVertex2d( 1, -1 );
	glTexCoord2d( 0, 1 ); glVertex2d( 0, -1 );
	glEnd( );
	glDisable( GL_TEXTURE_2D );
	glPopMatrix();

	glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, works->colors->mat_rssi_fore);
	glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, works->colors->mat_rssi_fore);
	val=works->serParms->rssi;
	s=(val+127)/6;
	if( s<0 ) {
		s=0;
	}
	if( s>9 ) {
		s=9;
	}
	d=val+73;
	if( d<0 ) {
		d=0;
	}
	if( d==0 ) {
		sprintf( buffer, "S%d", s );
	} else {
		sprintf( buffer, "S%d+%d", s, d );
	}
	if( works->plotter->layer == works->setup->bareLayer ) {
		incr=-height*4/10;
	} else {
		incr=-height*6/10;
	}
	lung=ftglGetFontAdvance( works->font[11*2+works->setup->Antialiased], buffer );
	((workp)works)->etichetta( works, (width-ftglGetFontAdvance( works->font[11*2+works->setup->Antialiased], buffer ))/2, incr, 3, lung, buffer, works->colors->mat_rssi_back, works->font[11*2+works->setup->Antialiased], 1, works->colors->mat_rssi_fore );
	sprintf( buffer, "%d %s", val,works->strings->messages[47] );
	lung=ftglGetFontAdvance( works->font[11*2+works->setup->Antialiased], buffer );
	((workp)works)->etichetta( works, (width-ftglGetFontAdvance( works->font[11*2+works->setup->Antialiased], buffer ))/2, incr-ftglGetFontAscender(works->font[11*2+works->setup->Antialiased]), 3, lung, buffer, works->colors->mat_rssi_evid, works->font[11*2+works->setup->Antialiased], 1, works->colors->mat_rssi_fore );
	gettimeofday( &stop, NULL );
	interval=1.0*(stop.tv_sec-start.tv_sec)+0.000001*(stop.tv_usec-start.tv_usec);
	works->trafficIn=(works->trafficIn*8+(float)works->bytesIn*8/interval/1000)/9;
	works->trafficOut=(works->trafficOut*8+(float)works->bytesOut*8/interval/1000)/9;
	if( works->plotter->layer == works->setup->bareLayer ) {
		sprintf( buffer, "%s %s  %s%4.0f %s%4.0f %s", works->strings->messages[16], works->setup->server, works->strings->messages[8], (float)works->trafficIn, works->strings->messages[9], (float)works->trafficOut, works->strings->messages[17] );
	} else {
		sprintf( buffer, "%s %s  %s%4.0f %s%4.0f", works->strings->messages[6], works->setup->server, works->strings->messages[8], (float)works->trafficIn, works->strings->messages[9], (float)works->trafficOut );
	}
 
	if( interval > 2 ) {
		gettimeofday( &start, NULL );
		works->bytesIn=works->bytesOut=0;
	}
	lung=ftglGetFontAdvance( works->font[12*2+works->setup->Antialiased], buffer );
	((workp)works)->etichetta( works, 0, -height-13, 3, lung, buffer, works->colors->mat_write, works->font[12*2+works->setup->Antialiased], 1, works->colors->mat_background );
	((workp)works)->etichetta( works, 0, -height-13, 3, lung, buffer, works->colors->mat_write, works->font[17*2+works->setup->Antialiased], 1, works->colors->mat_background );
	if( strlen( works->message ) ) {
		sprintf( buffer, "%s", works->message );
		((workp)works)->etichetta( works, 0, -height-23, 3, lung, buffer, works->colors->mat_mode_b, works->font[12*2+works->setup->Antialiased], 1, works->colors->mat_background );
		((workp)works)->etichetta( works, 0, -height-23, 3, lung, buffer, works->colors->mat_mode_b, works->font[17*2+works->setup->Antialiased], 1, works->colors->mat_background );
	} else {
		sprintf( buffer, "%s %5.1f %s %s %5.1f %s %s", works->strings->messages[7], works->irttmax, works->strings->messages[14], works->strings->messages[10], works->irttmed, works->strings->messages[14], works->strings->messages[11] );
		((workp)works)->etichetta( works, 0, -height-23, 3, lung, buffer, works->colors->mat_write, works->font[12*2+works->setup->Antialiased], 1, works->colors->mat_background );
		((workp)works)->etichetta( works, 0, -height-23, 3, lung, buffer, works->colors->mat_write, works->font[17*2+works->setup->Antialiased], 1, works->colors->mat_background );
	}
	glScaled( width/1000, height/1000, 1 );
	glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, works->colors->mat_rssi_fore);
	glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, works->colors->mat_rssi_fore);
	glBegin( GL_POLYGON );
	glVertex3d( 0, 0, 0 );
	glVertex3d( 990, 0, 0 );
	glVertex3d( 990, -990, 0 );
	glVertex3d( 0, -990, 0 );
	glEnd( );

	glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, works->colors->mat_rssi_back);
	glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, works->colors->mat_rssi_back);
	glBegin( GL_POLYGON );
	if( val < -127 ) {
		val=-127;
	}
	if( works->plotter->layer == works->setup->bareLayer ) {
		if( val < -127+12 ) {
			alpha = (84.4-(float)(val+127-54)*1.15)*M_PI/180;
		} else if( val < -127+54 ) {
			alpha = (84.4-(float)(val+127-54)*1.22)*M_PI/180;
		} else {
			alpha = ((26-(float)val/1.25)<37?37:(26-(float)val/1.25))*M_PI/180;
		}
		glVertex3d( 491, -930, 3.1 );
		glVertex3d( 495+490*cos( alpha ), -600+420*sin( alpha ), 3.1 );
		glVertex3d( 505+490*cos( alpha ), -600+420*sin( alpha ), 3.1 );
		glVertex3d( 509, -930, 3.1 );
	} else {
		if( val < -127+12 ) {
			alpha = (84.4-(float)(val+127-54)*1.05)*M_PI/180;
		} else if( val < -127+54 ) {
			alpha = (84.4-(float)(val+127-54)*1.15)*M_PI/180;
		} else {
			alpha = ((26-(float)val/1.25)<37?37:(26-(float)val/1.25))*M_PI/180;
		}
		glVertex3d( 491, -890, 3.1 );
		glVertex3d( 493+490*cos( alpha ), -1190+850*sin( alpha ), 3.1 );
		glVertex3d( 507+490*cos( alpha ), -1190+850*sin( alpha ), 3.1 );
		glVertex3d( 509, -890, 3.1 );
	}
	glEnd( );
	glPopMatrix();
}

void DrawArrows( void *work, int btn ) {
	workp works=(workp)work;
	int j;
	double radius=4;
	double side;
	double alpha;
	GLint viewport[4];
	double width;
	double height;
	int disp = works->buttons[btn].color*4;
	int lung;
	char *pp;
	float move;
	GLfloat *command_color;
	GLfloat *display_color;
	int border=0;

        // mi prendo le dimensioni della viewport
	glGetIntegerv (GL_VIEWPORT, viewport);
	works->aspectRatio=(float)viewport[3]/(float)viewport[2]/480*800;

	if( works->setup->Graphic ) {
		width = works->buttons[btn].width;
		height = works->buttons[btn].height;
		border=0;
	} else {
		width = works->buttons[btn].width-6;
		height = works->buttons[btn].height-6;
		border=8;
	}

        glLoadName( btn );

	command_color=works->colors->mat_encoder_big_font+disp;
	display_color=works->colors->mat_encoder_small_font+disp;
	if( works->setup->Graphic ) {
		display_color=works->colors->mat_encoder_small_font_g+disp;
		if( works->buttons[btn].over==1 ) {
			command_color=works->colors->mat_button_hover+disp;
		}
	}
	side = (width/works->aspectRatio<height*0.35?(width-6):(height*0.35-6));
	if( works->buttons[btn].size==2 ) {
		side = (width/works->aspectRatio<height*0.34?(width-6):(height*0.45-6));
	}

	glPushMatrix();
        glTranslated( works->buttons[btn].left, works->buttons[btn].top, 2 );

	if( works->setup->Graphic ) {
		glPushMatrix();
		glTexEnvf(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_REPLACE);
		if( !works->buttons[btn].write ) {
			gluBuild2DMipmaps(GL_TEXTURE_2D, GL_RGB, works->width_encoder4, works->height_encoder4, GL_RGB, GL_UNSIGNED_BYTE, works->encoder4Texture );
		} else if( works->buttons[btn].size==1 ) {
			gluBuild2DMipmaps(GL_TEXTURE_2D, GL_RGB, works->width_encoder1, works->height_encoder1, GL_RGB, GL_UNSIGNED_BYTE, works->encoder1Texture );
		} else if( works->buttons[btn].size==2 ) {
			gluBuild2DMipmaps(GL_TEXTURE_2D, GL_RGB, works->width_encoder2, works->height_encoder2, GL_RGB, GL_UNSIGNED_BYTE, works->encoder2Texture );
		} else if( works->buttons[btn].size==3 ) {
			gluBuild2DMipmaps(GL_TEXTURE_2D, GL_RGB, works->width_encoder3, works->height_encoder3, GL_RGB, GL_UNSIGNED_BYTE, works->encoder3Texture );
		} else if( works->buttons[btn].size==4 ) {
			gluBuild2DMipmaps(GL_TEXTURE_2D, GL_RGB, works->width_encoder4, works->height_encoder4, GL_RGB, GL_UNSIGNED_BYTE, works->encoder4Texture );
		}
		glEnable( GL_TEXTURE_2D );
		glColor3ub( 0Xff, 0Xff, 0Xff );
		glScaled( width, height, 1 );
		glBegin( GL_QUADS );
		glTexCoord2d( 0, 0 ); glVertex2d( 0,  0 );
		glTexCoord2d( 1, 0 ); glVertex2d( 1,  0 );
		glTexCoord2d( 1, 1 ); glVertex2d( 1, -1 );
		glTexCoord2d( 0, 1 ); glVertex2d( 0, -1 );
		glEnd( );
		glDisable( GL_TEXTURE_2D );
		glPopMatrix();
	}

	if( works->mode == GL_RENDER ) {
		if( works->buttons[btn].size!=2 ) {
			move=2;
			for( pp=works->buttons[btn].name; *pp; pp++ ) {
				if( *pp=='|' ) {
					*pp=0;
					lung=ftglGetFontAdvance( works->font[15*2+works->setup->Antialiased], works->buttons[btn].name );
					((workp)works)->etichetta( works, (width-ftglGetFontAdvance( works->font[13*2+works->setup->Antialiased], works->buttons[btn].name ))/2, -2*ftglGetFontAscender(works->font[13*2+works->setup->Antialiased]), 1, lung+1, works->buttons[btn].name, command_color, works->font[13*2+works->setup->Antialiased], 1, works->colors->mat_background );
					*pp='|';
					pp++;
					move=3.2;
					break;
				}
			}
			if( ! *pp ) {
				pp=works->buttons[btn].name;
			}
			lung=ftglGetFontAdvance( works->font[15*2+works->setup->Antialiased], pp );
			((workp)works)->etichetta( works, (width-ftglGetFontAdvance( works->font[13*2+works->setup->Antialiased], pp ))/2, -ftglGetFontAscender(works->font[13*2+works->setup->Antialiased])*move, 1, lung+1, pp, command_color, works->font[13*2+works->setup->Antialiased], 1, works->colors->mat_background );
		}

		if( works->buttons[btn].read ) {
			works->buttons[btn].read( works, btn );
		}
		if( works->buttons[btn].write ) {
			works->buttons[btn].write( works, btn );
			lung=ftglGetFontAdvance( works->font[14*2+works->setup->Antialiased], works->buttons[btn].str1 );
			((workp)works)->etichetta( works, (width-ftglGetFontAdvance( works->font[14*2+works->setup->Antialiased], works->buttons[btn].str1 ))/2, -height+ftglGetFontAscender(works->font[14*2+works->setup->Antialiased]), 1, lung, works->buttons[btn].str1, display_color, works->font[14*2+works->setup->Antialiased], 1, works->colors->mat_background );
		}
	}

	// dark
	if( works->setup->SolidBackground==1 ) {
		glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, works->colors->mat_background);
		glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, works->colors->mat_background);
		glBegin( GL_POLYGON );
		glVertex3d( width+border, -height-border, -0.1 );
		glVertex3d( width+border, 0, -0.1 );
		glVertex3d( -0, 0, -0.1 );
		glVertex3d( -0, -height-border, -0.1 );
		glEnd();
	}
		
	if( works->buttons[btn].size==2 ) {
		glTranslated( works->buttons[btn].width*2/10, -works->buttons[btn].height*2/10, 2 );
	} else {
		if( works->setup->Graphic ) {
			glTranslated( works->buttons[btn].width*4/20, -works->buttons[btn].height*3.5/10, 2 );
		} else {
			glTranslated( works->buttons[btn].width*3/20, -works->buttons[btn].height*3.5/10, 2 );
		}
	}

	// rotation
        glTranslated( works->buttons[btn].width*3/10-side*0.3535, -works->buttons[btn].height*2/10, 0 );
	glScaled( 0.5, 1.0, 1.0 );
	glRotated( 45.0, 0.0, 0.0, 1.0 );

	glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, works->colors->mat_encoder_outline+disp);
	glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, works->colors->mat_encoder_outline+disp);
	glNormal3d( -1.0, 0.0, 0.0 );
	glBegin( GL_LINE_LOOP );
	glVertex3d( side, -side+radius, 1 );
	for( j=0; j<90; j+=10 ) {
		alpha = j*M_PI/180;
		glVertex3d( side-radius+radius*cos( alpha ), -radius+radius*sin( alpha ), 1 );
	}
	glVertex3d( side-radius, 0, 1 );
	glVertex3d( radius, 0, 1 );
	glEnd();
	glBegin( GL_LINE_LOOP );
	glVertex3d( 0, -radius, 1 );
	glVertex3d( 0, -side+radius, 1 );
	for( j=180; j<270; j+=10 ) {
		alpha = j*M_PI/180;
		glVertex3d( radius+radius*cos( alpha ), -side+radius+radius*sin( alpha ), 1 );
	}
	glVertex3d( radius, -side, 1 );
	glVertex3d( side-radius, -side, 1 );
	glEnd();


	glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, works->colors->mat_encoder_back+disp);
	glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, works->colors->mat_encoder_back+disp);
	if( works->setup->Graphic ) {
		if( works->buttons[btn].size==2 ) {
			glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, works->colors->mat_encoder_back_g+disp);
			glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, works->colors->mat_encoder_back_g+disp);
		}
	}
	if( works->buttons[btn].over==1 ) {
		glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, works->colors->mat_encoder_hover+disp);
		glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, works->colors->mat_encoder_hover+disp);
	}
	if( works->buttons[btn].over==2 ) {
		glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, works->colors->mat_encoder_clicked+disp);
		glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, works->colors->mat_encoder_clicked+disp);
	}
	if( works->setup->Graphic ) {
		if( works->buttons[btn].size!=2 ) {
			glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, works->colors->mat_encoder_back_g+disp);
			glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, works->colors->mat_encoder_back_g+disp);
		}
	}

	// faccia avanti
	glNormal3d( -1.0, 0.0, 0.0 );
	glNormal3d( -1.0, 0.0, 0.0 );
	glBegin( GL_POLYGON );
	glVertex3d( side, -side+radius, 1 );
	for( j=0; j<90; j+=10 ) {
		alpha = j*M_PI/180;
		glVertex3d( side-radius+radius*cos( alpha ), -radius+radius*sin( alpha ), 1 );
	}
	glVertex3d( side-radius, 0, 1 );
	glVertex3d( radius, 0, 1 );
	glEnd();
	glBegin( GL_POLYGON );
	glVertex3d( 0, -radius, 1 );
	glVertex3d( 0, -side+radius, 1 );
	for( j=180; j<270; j+=10 ) {
		alpha = j*M_PI/180;
		glVertex3d( radius+radius*cos( alpha ), -side+radius+radius*sin( alpha ), 1 );
	}
	glVertex3d( radius, -side, 1 );
	glVertex3d( side-radius, -side, 1 );
	glEnd();
	glPopMatrix();
}

void DrawEncoder( void *work, int btn ) {
	workp works=(workp)work;
	int j;
	double radius=10;
	double alpha, beta;
	GLint viewport[4];
	double width;
	double height;
	int disp = works->buttons[btn].color*4;
	int incr=0;
	int lung;
	char *pp;
	float move;
	GLfloat *command_color;
	GLfloat *tmate_color;
	GLfloat *display_color;
	int border;

        // mi prendo le dimensioni della viewport
	glGetIntegerv (GL_VIEWPORT, viewport);
	works->aspectRatio=(float)viewport[3]/(float)viewport[2]/480*800;

	if( works->setup->Graphic ) {
		width = works->buttons[btn].width;
		height = works->buttons[btn].height;
		border=0;
	} else {
		width = works->buttons[btn].width-6;
		height = works->buttons[btn].height-6;
		border=8;
	}

        glLoadName( btn );

	glPushMatrix();
        glTranslated( works->buttons[btn].left, works->buttons[btn].top, 2 );

	if( works->setup->Graphic ) {
		glPushMatrix();
		glTexEnvf(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_REPLACE);
		if( !works->buttons[btn].write ) {
			gluBuild2DMipmaps(GL_TEXTURE_2D, GL_RGB, works->width_encoder4, works->height_encoder4, GL_RGB, GL_UNSIGNED_BYTE, works->encoder4Texture );
		} else if( works->buttons[btn].size==1 ) {
			gluBuild2DMipmaps(GL_TEXTURE_2D, GL_RGB, works->width_encoder1, works->height_encoder1, GL_RGB, GL_UNSIGNED_BYTE, works->encoder1Texture );
		} else if( works->buttons[btn].size==2 ) {
			gluBuild2DMipmaps(GL_TEXTURE_2D, GL_RGB, works->width_encoder2, works->height_encoder2, GL_RGB, GL_UNSIGNED_BYTE, works->encoder2Texture );
		} else if( works->buttons[btn].size==3 ) {
			gluBuild2DMipmaps(GL_TEXTURE_2D, GL_RGB, works->width_encoder3, works->height_encoder3, GL_RGB, GL_UNSIGNED_BYTE, works->encoder3Texture );
		} else if( works->buttons[btn].size==4 ) {
			gluBuild2DMipmaps(GL_TEXTURE_2D, GL_RGB, works->width_encoder4, works->height_encoder4, GL_RGB, GL_UNSIGNED_BYTE, works->encoder4Texture );
		}
		glEnable( GL_TEXTURE_2D );
		glColor3ub( 0Xff, 0Xff, 0Xff );
		glScaled( width, height, 1 );
		glBegin( GL_QUADS );
		glTexCoord2d( 0, 0 ); glVertex2d( 0,  0 );
		glTexCoord2d( 1, 0 ); glVertex2d( 1,  0 );
		glTexCoord2d( 1, 1 ); glVertex2d( 1, -1 );
		glTexCoord2d( 0, 1 ); glVertex2d( 0, -1 );
		glEnd( );
		glDisable( GL_TEXTURE_2D );
		glPopMatrix();
	}

	command_color=works->colors->mat_encoder_big_font+disp;
	tmate_color=works->colors->mat_encoder_tmate_font+disp;
	display_color=works->colors->mat_encoder_small_font+disp;
	if( works->setup->Graphic ) {
		display_color=works->colors->mat_encoder_small_font_g+disp;
		if( works->buttons[btn].over==1 ) {
			command_color=works->colors->mat_button_hover+disp;
		}
	}
	//radius = (width/works->aspectRatio<height*0.75?(width-6)/2:(height*0.75-6)/2);
	radius = (width/works->aspectRatio<height*0.35?(width)/2:(height*0.35)/2);
	incr=height/20;
	if( works->buttons[btn].size==2 ) {
		radius = (width/works->aspectRatio<height*0.55?(width)/2:(height*0.55)/2);
		incr=height/4;
	} else if( works->buttons[btn].size==3 ) {
		radius = (width/works->aspectRatio<height*0.6?(width)/2:(height*0.6)/2);
		incr=height/10;
	} else if( works->buttons[btn].size==4 ) {
		radius = (width/works->aspectRatio<height*0.6?(width)/2:(height*0.6)/2);
		incr=height/10;
	}
	if( works->mode == GL_RENDER ) {
		if( works->buttons[btn].size!=2 ) {
			move=2;
			for( pp=works->buttons[btn].name; *pp; pp++ ) {
				if( *pp=='|' ) {
					*pp=0;
					lung=ftglGetFontAdvance( works->font[13*2+works->setup->Antialiased], works->buttons[btn].name );
					((workp)works)->etichetta( works, (width-ftglGetFontAdvance( works->font[13*2+works->setup->Antialiased], works->buttons[btn].name ))/2, -2*ftglGetFontAscender(works->font[13*2+works->setup->Antialiased]), 1, lung+1, works->buttons[btn].name, command_color, works->font[13*2+works->setup->Antialiased], 1, works->colors->mat_background );
					*pp='|';
					pp++;
					move=3.2;
					break;
				}
			}
			if( ! *pp ) {
				pp=works->buttons[btn].name;
			}
			lung=ftglGetFontAdvance( works->font[15*2+works->setup->Antialiased], pp );
			((workp)works)->etichetta( works, (width-ftglGetFontAdvance( works->font[13*2+works->setup->Antialiased], pp ))/2, -ftglGetFontAscender(works->font[13*2+works->setup->Antialiased])*move, 1, lung+1, pp, command_color, works->font[13*2+works->setup->Antialiased], 1, works->colors->mat_background );
			for( j=9; j<12 && !((workp)works)->notmate; j++ ) {
				if( works->setup->t2keys[j]==btn+1 ) {
					pp=((workp)works)->strings->messages[49+j];
					lung=ftglGetFontAdvance( works->font[19*2+works->setup->Antialiased], pp );
					((workp)works)->etichetta( works, (width-ftglGetFontAdvance( works->font[19*2+works->setup->Antialiased], pp ))/2, -5*height/9-ftglGetFontAscender(works->font[19*2+works->setup->Antialiased])/2, 1, lung+1, pp, tmate_color, works->font[19*2+works->setup->Antialiased], 1,   works->buttons[btn].over==1 ?  works->colors->mat_encoder_hover+disp : works->colors-> mat_encoder_back+disp );
					break;
				}
			}
		} else {
			for( j=9; j<12 && !((workp)works)->notmate; j++ ) {
				if( works->setup->t2keys[j]==btn+1 ) {
					pp=((workp)works)->strings->messages[49+j];
					lung=ftglGetFontAdvance( works->font[19*2+works->setup->Antialiased], pp );
					((workp)works)->etichetta( works, (width-ftglGetFontAdvance( works->font[19*2+works->setup->Antialiased], pp ))/2, -2*height/5-ftglGetFontAscender(works->font[19*2+works->setup->Antialiased])/2, 1, lung+1, pp, tmate_color, works->font[19*2+works->setup->Antialiased], 1, works->buttons[btn].over==1 ?  works->colors->mat_encoder_hover+disp : works->colors-> mat_encoder_back+disp  );
					break;
				}
			}
		}

		// dark
		if( works->setup->SolidBackground==1 ) {
			glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, works->colors->mat_background);
			glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, works->colors->mat_background);
			glBegin( GL_POLYGON );
			glVertex3d( width+border, -height-border, -0.1 );
			glVertex3d( width+border, 0, -0.1 );
			glVertex3d( -0, 0, -0.1 );
			glVertex3d( -0, -height-border, -0.1 );
			glEnd();
		}
		
		if( works->buttons[btn].read ) {
			works->buttons[btn].read( works, btn );
		}
		glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, works->colors->mat_encoder_tag);
		glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, works->colors->mat_encoder_tag);
		glNormal3d( -1.0, 0.0, 0.0 );
		glBegin( GL_POLYGON );
		beta = works->buttons[btn].activated*M_PI/180;
		for( j=0; j<360; j+=10 ) {
			alpha = j*M_PI/180;
			if( works->aspectRatio<1 ) {
				glVertex3d( width/2+radius*works->aspectRatio*0.8*0.8*cos( beta )+radius*works->aspectRatio*0.1*0.8*cos( alpha ), incr-height/2-radius*2/4-radius*0.8*sin( beta )+radius*0.1*sin( alpha ), 2 );
			} else {
				glVertex3d( width/2+radius*0.8*0.8*cos( beta )+radius*works->aspectRatio*0.1*0.8*cos( alpha ), incr-height/2-radius*2/4-radius/works->aspectRatio*0.8*sin( beta )+radius*0.1*sin( alpha ), 2 );
			}
		}
		glEnd();
		if( works->buttons[btn].write ) {
			works->buttons[btn].write( works, btn );
			lung=ftglGetFontAdvance( works->font[14*2+works->setup->Antialiased], works->buttons[btn].str1 );
			((workp)works)->etichetta( works, (width-ftglGetFontAdvance( works->font[14*2+works->setup->Antialiased], works->buttons[btn].str1 ))/2, -height+ftglGetFontAscender(works->font[14*2+works->setup->Antialiased]), 1, lung, works->buttons[btn].str1, display_color, works->font[14*2+works->setup->Antialiased], 1, works->colors->mat_background );
		}
	}

	glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, works->colors->mat_encoder_outline+disp);
	glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, works->colors->mat_encoder_outline+disp);
	glNormal3d( -1.0, 0.0, 0.0 );
	glBegin( GL_LINE_LOOP );
	for( j=0; j<360; j+=10 ) {
		alpha = j*M_PI/180;
		if( works->aspectRatio<1 ) {
			glVertex3d( width/2+radius*works->aspectRatio*0.8*cos( alpha ), incr-height/2-radius*2/4+radius*sin( alpha ), 1 );
		} else {
			glVertex3d( width/2+radius*0.8*cos( alpha ), incr-height/2-radius*2/4+radius/works->aspectRatio*sin( alpha ), 1 );
		}
		// in selezione mi bastano meno dettagli
		if( works->mode == GL_SELECT ) {
			j+= 26;
		}
	}
	glEnd();
	glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, works->colors->mat_encoder_back+disp);
	glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, works->colors->mat_encoder_back+disp);
	if( works->setup->Graphic ) {
		if( works->buttons[btn].size==2 ) {
			glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, works->colors->mat_encoder_back_g+disp);
			glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, works->colors->mat_encoder_back_g+disp);
		}
	}
	if( works->buttons[btn].over==1 ) {
		glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, works->colors->mat_encoder_hover+disp);
		glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, works->colors->mat_encoder_hover+disp);
	}
	if( works->buttons[btn].over==2 ) {
		glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, works->colors->mat_encoder_clicked+disp);
		glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, works->colors->mat_encoder_clicked+disp);
	}
	if( works->setup->Graphic ) {
		if( works->buttons[btn].size!=2 ) {
			glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, works->colors->mat_encoder_back_g+disp);
			glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, works->colors->mat_encoder_back_g+disp);
		}
	}

	// faccia avanti
	glNormal3d( -1.0, 0.0, 0.0 );
	glBegin( GL_POLYGON );
	for( j=0; j<360; j+=10 ) {
		alpha = j*M_PI/180;
		if( works->aspectRatio<1 ) {
			glVertex3d( width/2+works->aspectRatio*radius*0.8*cos( alpha ), incr-height/2-radius*2/4+radius*sin( alpha ), 1 );
		} else {
			glVertex3d( width/2+radius*0.8*cos( alpha ), incr-height/2-radius*2/4+radius/works->aspectRatio*sin( alpha ), 1 );
		}
		// in selezione mi bastano meno dettagli
		if( works->mode == GL_SELECT ) {
			j+= 26;
		}
	}
	glEnd();
	glPopMatrix();
}

void DrawButton( void * work, int btn ) {
	workp works=(workp)work;

	int j;
	double radius=10;
	double alpha;
	double width;
	double height;
        char buffer[100];
	int disp = works->buttons[btn].color*4;
	int lung;
	GLfloat *bkgnd;
	GLfloat *command_color;
	GLfloat *tmate_color;
	GLfloat *keyb_color;
	char *pp;
	int border=0;
	int interl=0;

	if( ((works->buttons[btn].layer) & (works->plotter->layer))==0 ) {
		return;
	}
	if( works->buttons[btn].transparent==1 && works->mode == GL_RENDER) {
		return;
	}
	if( works->buttons[btn].isEncoder==1 ) {
		if( works->setup->isTouch ) {
			((workp)works)->DrawArrows( (void *)works, btn );
		} else {
			((workp)works)->DrawEncoder( (void *)works, btn );
		}
		return;
	}

	if( works->setup->Graphic ) {
		width = works->buttons[btn].width;
		height = works->buttons[btn].height;
		border=0;
	} else {
		width = works->buttons[btn].width-6;
		height = works->buttons[btn].height-6;
		border=18;
	}

        glLoadName( btn );

	bkgnd = works->colors->mat_button_back+disp;
	if( works->buttons[btn].over==1 ) {
		bkgnd = works->colors->mat_button_hover+disp;
	}
	if( works->buttons[btn].over==2 ) {
		bkgnd = works->colors->mat_button_clicked+disp;
	}
	glPushMatrix();
        glTranslated( works->buttons[btn].left, works->buttons[btn].top, 2 );

	if( works->setup->Graphic ) {
		glPushMatrix();
		glTexEnvf(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_REPLACE);
		gluBuild2DMipmaps(GL_TEXTURE_2D, GL_RGB, works->width_button, works->height_button, GL_RGB, GL_UNSIGNED_BYTE, works->buttonTexture );
		glEnable( GL_TEXTURE_2D );
		glColor3ub( 0Xff, 0Xff, 0Xff );
		glScaled( width, height, 1 );
		glBegin( GL_QUADS );
		glTexCoord2d( 0, 0 ); glVertex2d( 0,  0 );
		glTexCoord2d( 1, 0 ); glVertex2d( 1,  0 );
		glTexCoord2d( 1, 1 ); glVertex2d( 1, -1 );
		glTexCoord2d( 0, 1 ); glVertex2d( 0, -1 );
		glEnd( );
		glDisable( GL_TEXTURE_2D );
		glPopMatrix();
	}

	if( works->mode != GL_RENDER ) {
		return;
	}
	command_color=works->colors->mat_button_small_font+disp;
	tmate_color=works->colors->mat_button_tmate_font+disp;
	keyb_color=works->colors->mat_button_keyb_font+disp;
	if( works->setup->Graphic ) {
		if( works->buttons[btn].over==1 ) {
			command_color=works->colors->mat_button_hover+disp;
		}
	}

	for( pp=works->buttons[btn].name; *pp; pp++ ) {
		if( *pp=='|' ) {
			*pp=0;
			lung=ftglGetFontAdvance( works->font[15*2+works->setup->Antialiased], works->buttons[btn].name );
			((workp)works)->etichetta( works, width/10, -height*11/20, 1, lung+2, works->buttons[btn].name, command_color, works->font[15*2+works->setup->Antialiased], 1, bkgnd );
			((workp)works)->etichetta( works, width/10, -height*11/20, 1, lung+2, works->buttons[btn].name, command_color, works->font[18*2+works->setup->Antialiased], 1, bkgnd );
			*pp='|';
			pp++;
			interl++;
			break;
		}
	}
	if( ! *pp ) {
		pp=works->buttons[btn].name;
	}
	lung=ftglGetFontAdvance( works->font[15*2+works->setup->Antialiased], pp );
	((workp)works)->etichetta( works, width/10, -height*11/20-1.5*ftglGetFontAscender(works->font[15*2+works->setup->Antialiased]), 1, lung+2, pp, command_color, works->font[15*2+works->setup->Antialiased], 1, bkgnd );
	((workp)works)->etichetta( works, width/10, -height*11/20-1.5*ftglGetFontAscender(works->font[18*2+works->setup->Antialiased]), 1, lung+2, pp, command_color, works->font[18*2+works->setup->Antialiased], 1, bkgnd );
	
	for( j=0; j<9 && !((workp)works)->notmate; j++ ) {
		if( works->setup->t2keys[j]==btn+1 ) {
			pp=((workp)works)->strings->messages[49+j];
			lung=ftglGetFontAdvance( works->font[15*2+works->setup->Antialiased], pp );
			((workp)works)->etichetta( works, width/10, -height*11/20+1.5*interl*ftglGetFontAscender(works->font[15*2+works->setup->Antialiased]), 1, lung+2, pp, tmate_color, works->font[15*2+works->setup->Antialiased], 1, bkgnd );
			((workp)works)->etichetta( works, width/10, -height*11/20+1.5*interl*ftglGetFontAscender(works->font[18*2+works->setup->Antialiased]), 1, lung+2, pp, tmate_color, works->font[18*2+works->setup->Antialiased], 1, bkgnd );
			interl++;
			break;
		}
	}
	if( works->buttons[btn].group==99 ) { 
		for( pp=works->buttons[works->setup->kbkeys[-1-works->buttons[btn].band]-1].name; *pp; pp++ ) {
			if( *pp=='|' ) {
				*pp=0;
				interl++;
				lung=ftglGetFontAdvance( works->font[15*2+works->setup->Antialiased], works->buttons[works->setup->kbkeys[-1-works->buttons[btn].band]-1].name );
				((workp)works)->etichetta( works, width/10, -height*11/20+1.5*interl*ftglGetFontAscender(works->font[15*2+works->setup->Antialiased]), 1, lung+2, works->buttons[works->setup->kbkeys[-1-works->buttons[btn].band]-1].name, keyb_color, works->font[15*2+works->setup->Antialiased], 1, bkgnd );
				interl--;
				*pp='|';
				pp++;
				break;
			}
		}
		if( ! *pp ) {
			pp=works->buttons[works->setup->kbkeys[-1-works->buttons[btn].band]-1].name;
		}
		lung=ftglGetFontAdvance( works->font[15*2+works->setup->Antialiased], pp );
		((workp)works)->etichetta( works, width/10, -height*11/20+1.5*interl*ftglGetFontAscender(works->font[15*2+works->setup->Antialiased]), 1, lung+2, pp, keyb_color, works->font[15*2+works->setup->Antialiased], 1, bkgnd );
	} else {
		for( j=0; j<12; j++ ) {
			if( works->setup->kbkeys[j]==btn+1 ) {
				pp=((workp)works)->strings->messages[61+j];
				lung=ftglGetFontAdvance( works->font[15*2+works->setup->Antialiased], pp );
				((workp)works)->etichetta( works, width/10, -height*11/20+1.5*interl*ftglGetFontAscender(works->font[15*2+works->setup->Antialiased]), 1, lung+2, pp, keyb_color, works->font[15*2+works->setup->Antialiased], 1, bkgnd );
				((workp)works)->etichetta( works, width/10, -height*11/20+1.5*interl*ftglGetFontAscender(works->font[18*2+works->setup->Antialiased]), 1, lung+2, pp, keyb_color, works->font[18*2+works->setup->Antialiased], 1, bkgnd );
				break;
			}
		}
	}
	if( works->buttons[btn].read ) {
		works->buttons[btn].read( works, btn );
	}

	if( works->buttons[btn].toggle == 2 || works->buttons[btn].toggle == 4 ) {
		if( works->buttons[btn].activated>0 ) {
			if( works->buttons[btn].str1[0] ) {
				lung=ftglGetFontAdvance( works->font[15*2+works->setup->Antialiased], works->buttons[btn].str1 );
				((workp)works)->etichetta( works, width*9/10-ftglGetFontAdvance( works->font[15*2+works->setup->Antialiased], works->buttons[btn].str1 ), -height/10-ftglGetFontAscender(works->font[15*2+works->setup->Antialiased]), 1, lung, works->buttons[btn].str1, works->colors->mat_button_big_font+disp, works->font[15*2+works->setup->Antialiased], 1, bkgnd );
				((workp)works)->etichetta( works, width*9/10-ftglGetFontAdvance( works->font[18*2+works->setup->Antialiased], works->buttons[btn].str1 ), -height/10-ftglGetFontAscender(works->font[18*2+works->setup->Antialiased]), 1, lung, works->buttons[btn].str1, works->colors->mat_button_big_font+disp, works->font[18*2+works->setup->Antialiased], 1, bkgnd );
			} else {
				if( works->buttons[btn].decode ) {
					sprintf( buffer, "%s ", works->buttons[btn].decode[works->buttons[btn].activated] );
				} else {
					sprintf( buffer, "%d ", works->buttons[btn].activated );
				}
				lung=ftglGetFontAdvance( works->font[15*2+works->setup->Antialiased], buffer );
				((workp)works)->etichetta( works, width*9/10-ftglGetFontAdvance( works->font[15*2+works->setup->Antialiased], buffer ), -height/10-ftglGetFontAscender(works->font[15*2+works->setup->Antialiased]), 1, lung, buffer, works->colors->mat_button_big_font+disp, works->font[15*2+works->setup->Antialiased], 1, bkgnd );
				((workp)works)->etichetta( works, width*9/10-ftglGetFontAdvance( works->font[18*2+works->setup->Antialiased], buffer ), -height/10-ftglGetFontAscender(works->font[18*2+works->setup->Antialiased]), 1, lung, buffer, works->colors->mat_button_big_font+disp, works->font[18*2+works->setup->Antialiased], 1, bkgnd );
			}
		} else {
			if( works->buttons[btn].str2[0] ) {
				lung=ftglGetFontAdvance( works->font[15*2+works->setup->Antialiased], works->buttons[btn].str2 );
				((workp)works)->etichetta( works, width*9/10-ftglGetFontAdvance( works->font[15*2+works->setup->Antialiased], works->buttons[btn].str2 ), -height/10-ftglGetFontAscender(works->font[15*2+works->setup->Antialiased]), 1, lung, works->buttons[btn].str2, works->colors->mat_button_big_font+disp, works->font[15*2+works->setup->Antialiased], 1, bkgnd );
				((workp)works)->etichetta( works, width*9/10-ftglGetFontAdvance( works->font[18*2+works->setup->Antialiased], works->buttons[btn].str2 ), -height/10-ftglGetFontAscender(works->font[18*2+works->setup->Antialiased]), 1, lung, works->buttons[btn].str2, works->colors->mat_button_big_font+disp, works->font[18*2+works->setup->Antialiased], 1, bkgnd );
			}
		}
	}

	if( works->buttons[btn].toggle <= 1 ) {
		if( works->buttons[btn].activated>=1 ) {
			if( works->setup->Graphic ) {
				strcpy( buffer, works->strings->On[1] );
				lung=ftglGetFontAdvance( works->font[15*2+works->setup->Antialiased], buffer );
				((workp)works)->etichetta( works, width*9/10-ftglGetFontAdvance( works->font[15*2+works->setup->Antialiased], buffer ), -height/10-ftglGetFontAscender(works->font[15*2+works->setup->Antialiased]), 1, lung, buffer, works->colors->mat_button_big_font+disp, works->font[15*2+works->setup->Antialiased], 1, bkgnd );
				((workp)works)->etichetta( works, width*9/10-ftglGetFontAdvance( works->font[18*2+works->setup->Antialiased], buffer ), -height/10-ftglGetFontAscender(works->font[18*2+works->setup->Antialiased]), 1, lung, buffer, works->colors->mat_button_big_font+disp, works->font[18*2+works->setup->Antialiased], 1, bkgnd );
			}
		}
	}

	if( !works->setup->Graphic ) {

		// activated
		glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, works->colors->mat_button_activated+disp);
		glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, works->colors->mat_button_activated+disp);
		if( works->buttons[btn].toggle <= 1 ) {
			if( works->buttons[btn].activated>=1 ) {
				glBegin( GL_POLYGON );
				glVertex3d( width, -radius-height/10, 0 );
				for( j=0; j<=90; j+=10 ) {
					alpha = j*M_PI/180;
					glVertex3d( width-radius+radius*cos( alpha ), -radius+radius*sin( alpha ), 0 );
				}
				glVertex3d( width*9/10-radius, 0, 0 );
				glEnd();
			}
		}

		// dark
		if( works->setup->SolidBackground==1 ) {
			glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, works->colors->mat_background);
			glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, works->colors->mat_background);
			glBegin( GL_POLYGON );
			glVertex3d( width+border, -height-border, -0.1 );
			glVertex3d( width+border, 0, -0.1 );
			glVertex3d( -0, 0, -0.1 );
			glVertex3d( -0, -height-border, -0.1 );
			glEnd();
		}
		
		// outline 

		glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, works->colors->mat_button_outline+disp);
		glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, works->colors->mat_button_outline+disp);
		glNormal3d( -1.0, 0.0, 0.0 );
		glBegin( GL_LINE_LOOP );
		glVertex3d( width, -height+radius, 1 );
		glVertex3d( width, -radius, 1 );
		for( j=0; j<90; j+=10 ) {
			alpha = j*M_PI/180;
			glVertex3d( width-radius+radius*cos( alpha ), -radius+radius*sin( alpha ), 1 );
		}
		glVertex3d( width-radius, 0, 1 );
		glVertex3d( radius, 0, 1 );
		for( j=90; j<180; j+=10 ) {
			alpha = j*M_PI/180;
			glVertex3d( radius+radius*cos( alpha ), -radius+radius*sin( alpha ), 1 );
		}
		glVertex3d( 0, -radius, 1 );
		glVertex3d( 0, -height+radius, 1 );
		for( j=180; j<270; j+=10 ) {
			alpha = j*M_PI/180;
			glVertex3d( radius+radius*cos( alpha ), -height+radius+radius*sin( alpha ), 1 );
		}
		glVertex3d( radius, -height, 1 );
		glVertex3d( width-radius, -height, 1 );
		for( j=270; j<360; j+=10 ) {
			alpha = j*M_PI/180;
			glVertex3d( width-radius+radius*cos( alpha ), -height+radius+radius*sin( alpha ), 1 );
		}
		glEnd();

		glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, works->colors->mat_button_back+disp);
		glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, works->colors->mat_button_back+disp);
		if( works->buttons[btn].over==1 ) {
			glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, works->colors->mat_button_hover+disp);
			glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, works->colors->mat_button_hover+disp);
		}
		if( works->buttons[btn].over==2 ) {
			glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, works->colors->mat_button_clicked+disp);
			glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, works->colors->mat_button_clicked+disp);
		}

		glNormal3d( -1.0, 0.0, 0.0 );
		glBegin( GL_POLYGON );
		glVertex3d( width, -height+radius, 0 );
		glVertex3d( width, -radius, 0 );
		for( j=0; j<90; j+=10 ) {
			alpha = j*M_PI/180;
			glVertex3d( width-radius+radius*cos( alpha ), -radius+radius*sin( alpha ), 0 );
		}
		glVertex3d( width-radius, 0, 0 );
		glVertex3d( radius, 0, 0 );
		for( j=90; j<180; j+=10 ) {
			alpha = j*M_PI/180;
			glVertex3d( radius+radius*cos( alpha ), -radius+radius*sin( alpha ), 0 );
		}
		glVertex3d( 0, -radius, 0 );
		glVertex3d( 0, -height+radius, 0 );
		for( j=180; j<270; j+=10 ) {
			alpha = j*M_PI/180;
			glVertex3d( radius+radius*cos( alpha ), -height+radius+radius*sin( alpha ), 0 );
		}
		glVertex3d( radius, -height, 0 );
		glVertex3d( width-radius, -height, 0 );
		for( j=270; j<360; j+=10 ) {
			alpha = j*M_PI/180;
			glVertex3d( width-radius+radius*cos( alpha ), -height+radius+radius*sin( alpha ), 0 );
		}
		glEnd();
	}

	glPopMatrix();
}

void DrawData( void *works ) {
	int j;

	glPushMatrix();

	// dati per la prima luce
	GLfloat light0_ambient[] = { 0.2, 0.2, 0.2, 1.0 };
	GLfloat light0_diffuse[] = { 0.9, 0.9, 0.9, 1.0 };
	GLfloat light0_specular[] = { 0.0, 0.0, 0.0, 1.0 };
	GLfloat light0_position[] = { -10000, +10000, 10000, 1 };

	// piazzo, caratterizzo ed abilito le luci
	glLightfv( GL_LIGHT0, GL_AMBIENT, light0_ambient );
	glLightfv( GL_LIGHT0, GL_DIFFUSE, light0_diffuse );
	glLightfv( GL_LIGHT0, GL_SPECULAR, light0_specular );
	glLightfv( GL_LIGHT0, GL_POSITION, light0_position );
	glEnable( GL_LIGHT0 );

	((workp)works)->mode=GL_RENDER;

	((workp)works)->DrawBack( works );
	((workp)works)->DrawQTC( works );
	((workp)works)->DrawOTH( works );
	((workp)works)->DrawScale( works );
	((workp)works)->DrawTune( works );
        for( j=0; j<((workp)works)->nbuttons; j++ ) {
		((workp)works)->DrawButton( works, j );
        }
	((workp)works)->DrawAudioFFT( works );
	((workp)works)->DrawFFT( works );
        ((workp)works)->DrawWfall( works );
	if( ((workp)works)->serParms->ptt>0 || ((workp)works)->serParms->tune>0 ) {
		((workp)works)->DrawPwr( works );
	} else {
		((workp)works)->DrawRSSI( works );
	}
	glPopMatrix();
}
void DrawTmate( void *works ) {
	if( ((workp)works)->notmate==0 && ((workp)works)->TMate2SetStatus ) {
		statoTmate.lp = ((workp)works)->serParms->lp>0?1:0;
		statoTmate.att = ((workp)works)->serParms->att>0?1:0;
		statoTmate.tx = ((workp)works)->serParms->ptt>0?1:0;
		statoTmate.rx = ((workp)works)->serParms->ptt>0||((workp)works)->serParms->tune>0?0:1;
		statoTmate.smeter = ((workp)works)->serParms->rssi;
		if( ((workp)works)->linParms->standBy ) {
			statoTmate.power=((workp)works)->cat->fwdPwr;
		} else {
			statoTmate.power=((workp)works)->linParms->pwrOut*1000;
		}
		statoTmate.vfo = ((workp)works)->serParms->vfoUsed>0?0:1;
		statoTmate.nr = ((workp)works)->serParms->nr>0?1:0;
		statoTmate.nb = ((workp)works)->serParms->nb>0?1:0;
		statoTmate.an = ((workp)works)->serParms->an>0?1:0;
		statoTmate.frequency = ((workp)works)->serParms->freq;
		statoTmate.am = ((workp)works)->serParms->mode==1?1:0;
		statoTmate.lsb = ((workp)works)->serParms->mode==2?1:0;
		statoTmate.usb = ((workp)works)->serParms->mode==3?1:0;
		statoTmate.cwplus = ((workp)works)->serParms->mode==4?1:0;
		statoTmate.cwminus = ((workp)works)->serParms->mode==6?1:0;
		statoTmate.fm = ((workp)works)->serParms->mode==5?1:0;
		statoTmate.e1vol = 0;
		statoTmate.e1sql = 0;
		statoTmate.e1nr = 0;
		statoTmate.e1nb = 0;
		statoTmate.e1an = 0;
		statoTmate.e2rit = 0;
		memcpy(statoTmate.rxcolor, ((workp)works)->setup->rxcolor, 3 );
		memcpy(statoTmate.txcolor, ((workp)works)->setup->txcolor, 3 );
		statoTmate.work = works;
		((workp)works)->TMate2SetStatus( &statoTmate );
	}
}

