/*
	Copyright 2018-2019 Giovanni Franza - HB9EIK 

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#if !defined __STRUCT_H__
#define __STRUCT_H__

#include <FTGL/ftgl.h>
#include <GL/freeglut.h>
#include <pthread.h>
#include <opus.h>
#include <stdlib.h>
#include <sys/time.h>
#include <errno.h>
#include <unistd.h>
#if __has_include("sys/prctl.h")
#include <sys/prctl.h>
#define FFT_AUDIO_DECIM -9
#define PULSESCAM 
#else
#define prctl(x1,x2,x3,x4,x5)
#define syslog(...)
#define FFT_AUDIO_DECIM -90
#endif

#include "TMATE2.h"

#define SAMPLES 120
#define AUDIO_BYTES_PER_SAMPLE 4
#define AUDIO_BUFFERS 40*16
// 48000*40*AUDIO_BYTES_PER_SAMPLE
#define AUDIO_LEN 7680000

typedef struct _myStrings {
	int *baudRate;
	int nBaudRate;
	char **bwCW;
	char **bwAM;
	char **bwFM;
	char **bwSSB;
	char **empty;
	char **modes;
	int *filterMode;
	int *filterMin;
	int *filterMax;
	char ***filterDesc;
	char **agcString;
	char **fast;
	char **decodePaString;
	char **decodeTuString;
	char **decodeAliased;
	char **decodeGraphic;
	char **decodeAuDev;
	char **decodeDebug;
	char **decodeIsTouch;
	char **decodeFFTtype;
	char **decodeFMdev;
	char **decodeKePad;
	char **decodeMute;
	char **decodeTXIn;
	char **decodeTXOut;
	char **decodeAntN;
	char **decodePwr;
	char **decodeTXBW;
	long *ncompress;
	char **scompress;
	float *nchunk;
	char **schunk;
	long *nbtime;
	char **sbtime;
	char **decodeKeyP;
	char **On;
	char **BWNULL;
	char **txAttStr;
	int *bwCWf;
	int *bwCWi;
	int *bwAMi;
	int *bwAMf;
	int *bwFMi;
	int *bwFMf;
	int *bwSSBi;
	int *bwSSBf;
	char **error;
	char **status;
	int nerror;
	int nstatus;
	char **decodeAB;
	char **decodeABn;
	char **messages;
} myStrings, *myStringsp;
typedef struct _linearParms {
	char banda[5];
	int stato;
	int antenna;
	int standBy;
	int atu;
	int tune;
	float swr;
	float pwrOut;
	float pwrIn;
	float temperatura;
	float tensione;
	float corrente;
	int errore;
	int pa;
	int tu;
	int ant;
	int antSel;
	int bank;
	int oldTxAtt;
	int txAtt;
	int isTune;
	char versions[20];
} linearParms, *linearParmsp;
typedef struct _serialParms {
	int duoType;
	int vfoUsed;
	int vfoSent;
	long tuningFrequency;
	long tuningFrequencyRx;
	long tuningFrequencyA;
	long tuningFrequencyB;
	long oldfreq;
	long freq;
	long oldFreq;
	int tune;
	int split;
	int splitSA;
	int mode;
	int savemode;
	int oldMode;
	int modeRx;
	int modeA;
	int modeB;
	int indVol;
	int mainVol;
	int auxVol;
	int sideVol;
	int sideTone;
	int ptt;
	int squelch;
	int agcAuto;
	int agcMlvl;
	int agcAlvl;
	int agcThr;
	int agc;
	int nr;
	int nb;
	int cwMute;
	int phMute;
	int LSBbw;
	int USBbw;
	int CWbw;
	int AMbw;
	int FMbw;
	int bw;
	int att;
	int attR;
	int lp;
	int an;
	int rit;
	int volume;
	int volumeAux;
	int volumeSide;
	int pitch;
	int rssi;
	int ritFreq;
	int startBw;
	int endBw;
} serialParms, *serialParmsp;
typedef struct _cell {
	float row;
	float col;
	float rowspan;
	float colspan;
	int button;
} cell, *cellp;
typedef struct _bands {
	int start;
	int stop;
	int call;
	int mode;
	int bw;
	int lpf;
	int antOut;
	int button;
} band, *bandp;
typedef struct _colors {
        GLfloat mat_background[4];
        GLfloat mat_area[4];
        GLfloat mat_freq_big[4];
        GLfloat mat_synt_no[4];
        GLfloat mat_synt_ok[4];
        GLfloat mat_synt_rit[4];
        GLfloat mat_freq_small[4];
        GLfloat mat_fft_back[4];
        GLfloat mat_front[4];
        GLfloat mat_FFT[4];
        GLfloat mat_FRONT[4];
        GLfloat mat_BW[4];
        GLfloat mat_draw[4];
        GLfloat mat_write[4];
        GLfloat mat_rssi_back[4];
        GLfloat mat_rssi_fore[4];
        GLfloat mat_rssi_evid[4];
        GLfloat mat_encoder_back[8];
        GLfloat mat_encoder_back_g[8];
        GLfloat mat_encoder_hover[8];
        GLfloat mat_encoder_clicked[8];
        GLfloat mat_encoder_big_font[8];
        GLfloat mat_encoder_outline[8];
        GLfloat mat_encoder_small_font[8];
        GLfloat mat_encoder_tmate_font[8];
        GLfloat mat_encoder_small_font_g[8];
        GLfloat mat_encoder_tag[4];
        GLfloat mat_button_back[8];
        GLfloat mat_button_hover[8];
        GLfloat mat_button_clicked[8];
        GLfloat mat_button_activated[8];
        GLfloat mat_button_big_font[8];
        GLfloat mat_button_outline[8];
        GLfloat mat_button_small_font[8];
        GLfloat mat_button_tmate_font[8];
        GLfloat mat_button_keyb_font[8];
        GLfloat mat_mode_b[4];
} color, *colorp;
typedef struct _impost {
	int lpf;
	int att;
	int nr;
	int nb;
	int an;
	int bw;
	int mode;
	int freq;
	int rit;
	int ritFreq;
	int antOut;
	int squelch;
	int agcAuto;
	int agcAlvl;
	int agcMlvl;
	int agcThr;
	int sat;
} impost, *impostp;
typedef struct _button {
	int tleft;
	int ttop;
	int twidth;
	int theight;
	int left;
	int top;
	int width;
	int height;
	int toggle;
	int activated;
	char str1[100];
	char str2[100];
	int pressed;
	int modified;
	void (*write)( void *, int );
	void (*read)( void *, int );
	void (*down)( void *, int );
	void (*dxdn)( void *, int );
	void (*centerdn)( void *, int );
	void (*up)( void *, int );
	void (*wheelDn)( void *, int );
	void (*wheelUp)( void *, int );
	char group;
	char *name;
	int  band;
	int color;
	char **decode;
	unsigned char layer;
	unsigned char level;
	int transparent;
	int over;
	int isEncoder;
	int tmate;
	int size;
} button, *buttonp;
typedef struct _plotter {
        int SyntaXpos;
        int SyntaXsize;
        int SyntaYpos;
        int SyntaYsize;
        int SyntbXpos;
        int SyntbXsize;
        int SyntbYpos;
        int SyntbYsize;
        int SyntXpos;
        int SyntXsize;
        int SyntYpos;
        int SyntYsize;
        int WfallaXpos;
        int WfallaXsize;
        int WfallaYpos;
        int WfallaYsize;
        int WfallbXpos;
        int WfallbXsize;
        int WfallbYpos;
        int WfallbYsize;
        int WfallXpos;
        int WfallXsize;
        int WfallYpos;
        int WfallYsize;
        int FFTaXpos;
        int FFTaXsize;
        int FFTaYpos;
        int FFTaYsize;
        int FFTainset;
        int FFTbXpos;
        int FFTbXsize;
        int FFTbYpos;
        int FFTbYsize;
        int FFTbinset;
        int FFTXpos;
        int FFTXsize;
        int FFTYpos;
        int FFTYsize;
        int FFTinset;
        int AudioFFTaXpos;
        int AudioFFTaXsize;
        int AudioFFTaYpos;
        int AudioFFTaYsize;
        int AudioFFTbXpos;
        int AudioFFTbXsize;
        int AudioFFTbYpos;
        int AudioFFTbYsize;
        int AudioFFTXpos;
        int AudioFFTXsize;
        int AudioFFTYpos;
        int AudioFFTYsize;
        int ScaleaXpos;
        int ScaleaXsize;
        int ScaleaYpos;
        int ScaleaYsize;
        int ScalebXpos;
        int ScalebXsize;
        int ScalebYpos;
        int ScalebYsize;
        int ScaleXpos;
        int ScaleXsize;
        int ScaleYpos;
        int ScaleYsize;
        int FreqaXpos;
        int FreqaXsize;
        int FreqaYpos;
        int FreqaYsize;
        int FreqbXpos;
        int FreqbXsize;
        int FreqbYpos;
        int FreqbYsize;
        int FreqXpos;
        int FreqXsize;
        int FreqYpos;
        int FreqYsize;
        int MODXpos;
        int MODXsize;
        int MODYpos;
        int MODYsize;
        int RSSIaXpos;
        int RSSIaXsize;
        int RSSIaYpos;
        int RSSIaYsize;
        int RSSIbXpos;
        int RSSIbXsize;
        int RSSIbYpos;
        int RSSIbYsize;
        int RSSIXpos;
        int RSSIXsize;
        int RSSIYpos;
        int RSSIYsize;
        int MSGXpos;
        int MSGXsize;
        int MSGYpos;
        int MSGYsize;
        int OTHXpos;
        int OTHXsize;
        int OTHYpos;
        int OTHYsize;
	float FFTVmin;
	float FFTVmax;
        int refFreqX;
        int refFreq;
        float *Ydata;
	int Ylength;
	int Ystart;
        int lastY;
	int zoom;
	int ZoomFFT;
	int layer;
	int baseLayer;
	long newFreq;
	char data[20];
	int immediateFreq;
	int mousePosX;
	int mousePosY;
} plotter, *plotterp;
typedef struct _setup {
	char enableRead;
	char enableWrite;
	char enableTime;
	char enableCW;
	char enableAudioFFT;
	char enableFIFO;
	char enableTmate;
	char webSocket;
	char FFTlevel[10];
	char FFTspan[10];
	int in_channels;
	int out_channels;
	float rxChunkTime;
	float txChunkTime;
	float bufferingTime;
	char server[16];
	char BareFFT[1];
	char FlippedFFT[1];
	int AutoSnap;
	int autoReturn;
	int timeDelay;
	int SolidBackground;
	int Antialiased;
	int Graphic;
	int startLayer;
	int bareLayer;
	int AudioBuffers;
	int wsockTimeout;
	int isTouch;
	char End;
	int FifoBaud;
	int FifoBaudIndex;
	char FifoDevice[20];
	char KeyerDevice[20];
	int KeyerMode;
	int KeyerSpeed;
	int relax;
	char myLangue[100];
	int langue;
	int fiKeyPort;
	int cwKeyPort;
	int errorCleanTime;
	int maxCleaning;
	unsigned char rxcolor[3];
	unsigned char txcolor[3];
	int kbkeys[12];
	int kbkeysidx[12];
	int t2keys[12];
	int t2keysidx[12];
	int audioFftEnabled;
	int auxVol;
	int nativeCW;
	int sidetone;
	int numDev;
	int numDevRx;
	int numDevTx;
	int numRx;
	int numTx;
	int devRx;
	int devTx;
	int numRxAux;
	int numTxAux;
	int devRxAux;
	int devTxAux;
	int nefTx;
	int nefRx;
	int defTx;
	int defRx;
	int newDev;
	int newDevAux;
	int rxDevN[50];
	int txDevN[50];
	char rxDev[50][50];
	char txDev[50][50];
	int votAuP;
	int vorAuP;
	int whatAuDev;
	int hwdebug;
} setup, *setupp;
typedef struct _cat{
	float fwdPwr;
	float refPwr;
	float ros;
} cat, *catp;
typedef struct _work {
	int	unterminated;
	char version[50];
	char server[100];	// conterpart machine
	short port;	// websocket port
	int sfd;	// outfile for websocket
	int connected;	// websocket connected
	int soundConnected;	// souns buffered
	char passphrase[100];
	int quality;
	char picture[200];
	int X;
	int Y;
	int RxChunk;
	int TxChunk;
	int rx_buffer_frames;
	int tx_buffer_frames;
	int buffer_start;
	int BufTime;
	int bufferingChanged;
	unsigned int rate;
	char sound_buffer[AUDIO_LEN];
	pthread_mutex_t *wmut;
	setupp setup;
	OpusEncoder *encoder;
	OpusDecoder *decoder;
	long rxcompress;
	long RxCompr;
	long txcompress;
	long TxCompr;
	int catFD;
	int serFD;
	int linFD;
	float FFTlevel;
	float FFTspan;
	float FFTalpha;
	int FFTtype;
	int FFTdelay;
	int delay;
	int ramp;
	serialParmsp serParms;
	linearParmsp linParms;
	plotterp plotter;
	buttonp buttons;
	int nbuttons;
	cellp   cells;
	bandp   bands;
	int 	nbands;
	impostp imposts;
	int volume;
	int saveVol;
	int thrWsock;
	void *libActions[3];
	int nActions;
	void *libDrawings[3];
	int nDrawings;
	int mode; //opengl mode
	FTGLfont *font[50]; // fonts
	void (* sintonia)( void *works, int value );
	int auxVolIncr;
	int freqIncr;
	int freqRitIncr;
	int oldRit;
	float aspectRatio;
	char statbuf[200];
	char catbuf[200];
	colorp colors;
	catp cat;
	int xDelta;
	int yDelta;
	int xPos;
	int yPos;
	int xSize;
	int ySize;
	int realxSize;
	int realySize;
	int started;
	int audioErrors;
	int outSound;
	int tximm;
	int txab;
	int fifoFd;
	int fifoFdDef;
	char *slavename;
	int keyFd;
	struct timeval freqChanged;
	struct timeval ritChanged;
	struct timeval auxVolChanged;
	struct timeval modeChanged;
	struct timeval bwChanged;
	struct timeval thresholdChanged;
	struct timeval agcMlvlChanged;
	struct timeval agcAlvlChanged;
	struct timeval nrChanged;
	struct timeval nbChanged;
	struct timeval anChanged;
	struct timeval squelchChanged;
	struct timeval pitchChanged;
	struct timeval volumeChanged;
	struct timeval sideChanged;
	struct timeval lastFFTshown;
	struct timeval lastFFTreceived;
	struct timeval lastErrorReceived;
	void (*auxdown)( void *, int );
	void (*etichetta)( void *works, int x, int y, int z, int lung, char *scritta, GLfloat *mat_dark, FTGLfont *font, float vspan, GLfloat *mat_back );
	void (*DrawBack)( void *works );
	void (*FormatFreq)( int val, unsigned char units, char *str );
	void (*DrawTune)( void *works );
	void (*DrawFFT)( void *works );
	void (*DrawAudioFFT)( void *works );
	void (*ConvertMeasColor)( int count, void *works, float val, unsigned char *r, unsigned char *g, unsigned char *b );
	void (*DrawWfall)( void *works );
	void (*DrawScale)( void *works );
	void (*DrawPwr)( void *works );
	void (*DrawRSSI)( void *works );
	void (*DrawArrows)( void *works, int btn );
	void (*DrawEncoder)( void *works, int btn );
	void (*DrawButton)( void *works, int btn );
	void (*DrawData)( void *works );
	void (*DrawTmate)( void *works );
	void (*DrawQTC)( void *works );
	void (*DrawOTH)( void *works );
	void (*modeChange)( void *works, int mode );
	void (*AddCipher)( void *works, int key );
	void (*setType)( void *works, int key );
	void (*setDelay)( void *works, int key );
	void (*setAB)( void *works, int key );
	void (*cwTx)( void *works, int key );
	void (*forget)( void *works, int key );
	int (*TMate2OpenConnection)( void );
	int (*TMate2CloseConnection)( void );
	void (*TMate2SetStatus)( t2statusp stat );
	int (*TMate2AddCallback)( int keyNumber, int Button, int *value, void *Work, void (*AuxDown)( void *, int ), void (*Write)( void *, int ), void (*Down)( void *, int ), void (*Up)( void *, int ) );
	int (*TMate2ReadVersion)(char *H1,char *H2,char *F1,char *F2);
	void (*tmateaddcallback)( void *works, int num );
	void *tmatehandle;
	void (*kbcb)( void *works, int num );
	void (*kbaddcallback)( void *works, int num );
	int (*kbAddCallback)( int keyNumber, int Button, int *value, void *Work, void (*AuxDown)( void *, int ), void (*Write)( void *, int ), void (*Down)( void *, int ), void (*Up)( void *, int ) );
	int outfifo;	// fifo where commands are sent
	int AntN;	// Antenna number
	int MGain;	// Mike gain
	int CGain;	// Compressor gain
	int NThre;	// Compressor gain
	int FMdev;	// FM Deviation
	int KePad;	// CW key / paddle
	int CWMut;	// CW tx mute
	int SSBMu;	// CW ssb mute
	int Offset;	// Offset on/off
	int TXEna;	// Tx Enable on/off
	int TXIn;	// Tx Input mic/usb/auto
	int TXOut;	// Tx output normal/0dbM
	int TuTO;	// Tune timeout
	int TXPwr;	// Tx power out
	int TuPwr;	// Tune power out
	int TXBW;	// TX Band Width
	GLubyte smeter[3*400*240];      // bare smeter texture
	int height_smeter;
	int width_smeter;
	GLubyte wsmeter[3*400*240];     // exp s meter texture
	int height_wsmeter;
	int width_wsmeter;
	GLubyte meter[3*400*240];       // bare meter texture
	int height_meter;
	int width_meter;
	GLubyte wmeter[3*400*240];      // exp meter texture
	int height_wmeter;
	int width_wmeter;
	GLubyte buttonTexture[3*400*240];      // button texture
	int height_button;
	int width_button;
	GLubyte encoder1Texture[3*400*240];      // slider texture
	int height_encoder1;
	int width_encoder1;
	GLubyte encoder2Texture[3*400*240];      // slider texture
	int height_encoder2;
	int width_encoder2;
	GLubyte encoder3Texture[3*400*240];      // slider texture
	int height_encoder3;
	int width_encoder3;
	GLubyte encoder4Texture[3*400*240];      // slider texture
	int height_encoder4;
	int width_encoder4;
	int bytesIn;
	int bytesOut;
	float trafficIn;
	float trafficOut;
	int soundReadPointer;
	int soundWritePointer;
	int countSo;
	int countOldSo;
	int countTo;
	int lowerClick;
	int shutAudio;
	char message[50];
	int serReceived;
	float ta;
	float tr;
	float irtt;
	float irttmax;
	float irttmed;
	int key;
	int txCwLock;
	int notmate;
	myStringsp strings;
	char Languages[20][100];
	int nLanguages;
	int tmateNbuttons;
	int *tmateButtons;
	int tmateNencoders;
	int *tmateEncoders;
	int lastError;
	int numSameError;
	char audioFftIn[1024*AUDIO_BYTES_PER_SAMPLE];
	unsigned char audioFftOut[1024];
	pthread_mutex_t *audioFftMut;
	pthread_cond_t *audioFftCond;
	float FFTrythm;
	float Drawrythm;
	char *argv0;
	int noAudio;
} work, *workp;

#define XtNumber(x) sizeof(x)/sizeof(x[0])

void *th_audio( void * );
void *timer( void * );
void *audioFFT( void * );
void *keyer( void * );
void *oscillator( void * );
void *Wsocket( void * );
void *Wclient( void * );
void *fifo( void * );
void sendWebSockAudioFrame( workp works, char *buffer );
void sendWebSockStatFrame( workp works, char *buffer, int len );
void sendWebSockCatFrame( workp works, char *buffer, int len );
void sendWebSockSerFrame( workp works, char *buffer, int len );
void sendWebSockCfgFrame( workp works, char *buffer, int len );
void sendWebSockCwFrame( workp works, char *buffer, int len );
void sendWebSockHebFrame( workp works, char *buffer, int len );
void readSetup( workp works );
void writeSetup( workp works );
void initSetup( workp works );
void InitGrid( workp works );
void storeParameters( workp works, int DataLength, unsigned char *rbuf);
void getParameters( serialParmsp Parms, workp works );
void storeFFT( workp works, int DataLength, unsigned char *rbuf);
void storeLinear( workp works, int DataLength, unsigned char *rbuf);
void decodeCATcmd( workp works, int DataLength, unsigned char *rbuf);
void manageButtons( workp works, int btn, int pressed );
void LoadButtons( workp works );
void locale( workp works, char *langue );
void readPng( workp works, char *picture, GLubyte *meter, int *height, int *width );
void buildConfig( workp works );
void tmateset( workp works );
void controltmate ( workp works );
void tmateaddcallback( void *works, int num );
void kbaddcallback( void *works, int num );
int kbAddCallback( int keyNumber, int Button, int *value, void *Work, void (*AuxDown)( void *, int ), void (*Write)( void *, int ), void (*Down)( void *, int ), void (*Up)( void *, int ) );

#endif
